import * as i0 from '@angular/core';
import { Input, Directive, inject, Injector, TemplateRef, ViewContainerRef, NgModule, assertInInjectionContext, DestroyRef, signal, computed, isSignal, InjectionToken, Injectable, runInInjectionContext, input, Renderer2, ElementRef, booleanAttribute, Pipe, makeEnvironmentProviders, ChangeDetectionStrategy, Component, HostListener, EventEmitter, untracked, Output, effect, ContentChildren, ChangeDetectorRef, output, viewChild, EnvironmentInjector, createComponent, linkedSignal, contentChild, forwardRef, contentChildren, provideAppInitializer } from '@angular/core';
import { shareReplay, map, switchAll, filter, tap, catchError, startWith, switchMap, mergeMap, concatMap as concatMap$1, takeUntil, distinctUntilChanged, debounceTime } from 'rxjs/operators';
import * as i1 from 'rxjs';
import { isObservable, Subject, of, ReplaySubject, filter as filter$1, first, map as map$1, Observable, combineLatest, Subscription, startWith as startWith$1, pairwise, pipe, concatMap, merge, delay, fromEvent, takeUntil as takeUntil$1, tap as tap$1, switchMap as switchMap$1, scan, timestamp } from 'rxjs';
import { toObservable, toSignal, outputFromObservable } from '@angular/core/rxjs-interop';
import * as i3$2 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import { merge as merge$1, sumBy, difference, groupBy, cloneDeep, intersection, set, get } from 'lodash';
import { CdkColumnDef } from '@angular/cdk/table';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { MatSlideToggle } from '@angular/material/slide-toggle';
import * as i8 from '@angular/material/radio';
import { MatRadioButton, MatRadioModule } from '@angular/material/radio';
import { MatButtonToggle } from '@angular/material/button-toggle';
import * as i1$2 from '@angular/material/checkbox';
import { MatCheckbox, MatCheckboxModule } from '@angular/material/checkbox';
import * as i2 from '@angular/forms';
import { NgControl, NgForm, ControlContainer, FormsModule, NG_VALUE_ACCESSOR } from '@angular/forms';
import { MatOption } from '@angular/material/core';
import { DatePipe, CurrencyPipe, NgTemplateOutlet, formatDate, formatCurrency, DecimalPipe, formatNumber, CommonModule, AsyncPipe } from '@angular/common';
import { ComponentStore } from '@ngrx/component-store';
import * as i5 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule, CdkDropList, CDK_DROP_LIST, transferArrayItem } from '@angular/cdk/drag-drop';
import * as i1$1 from '@angular/material/input';
import { MatInputModule, MatInput } from '@angular/material/input';
import * as i3 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import * as i1$3 from '@angular/material/card';
import { MatCardModule } from '@angular/material/card';
import { MatDialog, MAT_DIALOG_DEFAULT_OPTIONS } from '@angular/material/dialog';
import * as i3$1 from '@angular/material/button';
import { MatButtonModule, MatIconButton, MatButton } from '@angular/material/button';
import * as i4 from '@angular/material/tooltip';
import { MatTooltipModule, MatTooltip } from '@angular/material/tooltip';
import * as i2$1 from '@angular/material/icon';
import { MatIconModule, MatIcon } from '@angular/material/icon';
import * as i7 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i1$4 from '@angular/material/menu';
import { MatMenuModule, MatMenuTrigger, MatMenu } from '@angular/material/menu';
import * as i4$1 from '@angular/material/chips';
import { MatChipsModule } from '@angular/material/chips';
import * as i1$6 from '@angular/material/table';
import { MatTable, MatColumnDef, MatTableModule, MatHeaderRowDef, MatFooterRowDef, MatTableDataSource, MatRowDef } from '@angular/material/table';
import { SelectionModel } from '@angular/cdk/collections';
import * as i1$5 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i1$7 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import * as i1$8 from '@angular/cdk/scrolling';
import { CdkVirtualScrollViewport, VIRTUAL_SCROLL_STRATEGY, ScrollingModule } from '@angular/cdk/scrolling';
import * as i1$9 from '@ngrx/store';
import { createFeatureSelector, createSelector, StoreModule, Store } from '@ngrx/store';
import { createEntityAdapter } from '@ngrx/entity';
import * as i1$a from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';

var RequestStatus;
(function (RequestStatus) {
    RequestStatus[RequestStatus["notStarted"] = 0] = "notStarted";
    RequestStatus[RequestStatus["inProgress"] = 1] = "inProgress";
    RequestStatus[RequestStatus["success"] = 2] = "success";
    RequestStatus[RequestStatus["fail"] = 3] = "fail";
    RequestStatus[RequestStatus["cancelled"] = 4] = "cancelled";
})(RequestStatus || (RequestStatus = {}));
var RequestStrategy;
(function (RequestStrategy) {
    RequestStrategy[RequestStrategy["concurrent"] = 1] = "concurrent";
    RequestStrategy[RequestStrategy["singleUse"] = 2] = "singleUse";
    RequestStrategy[RequestStrategy["cancelPrevious"] = 3] = "cancelPrevious";
    RequestStrategy[RequestStrategy["sequential"] = 4] = "sequential";
})(RequestStrategy || (RequestStrategy = {}));

function isErrorState(state) {
    return state.status === RequestStatus.fail;
}
function isSuccessState(state) {
    return state.status === RequestStatus.success;
}
function isSuccessOrErrorState(state) {
    return state.status === RequestStatus.success || state.status === RequestStatus.fail;
}
function createSuccess(body) {
    return { status: RequestStatus.success, body };
}
function createFailure(error) {
    return { status: RequestStatus.fail, error };
}
const notStarted = { status: RequestStatus.notStarted };
const inProgress = { status: RequestStatus.inProgress };
function statusIsSuccessOrInProgress(status) {
    return [RequestStatus.success, RequestStatus.inProgress].includes(status);
}

function defaultShareReplay() {
    return function (src) {
        return src.pipe(shareReplay({ refCount: true, bufferSize: 1 }));
    };
}

class HttpRequestStateDirective {
    set stateStore(store) {
        if (isObservable(store)) {
            this.subject.next(store);
        }
        else {
            this.subject.next(store.state$.pipe(map(state => state.response)));
        }
    }
    constructor(templateRef, viewContainer) {
        this.ViewContext = {
            $implicit: undefined,
            state: undefined,
            status: {
                inProgress: false,
                notStarted: true,
                success: false,
                error: false,
            }
        };
        this.subject = new Subject();
        this.state = this.subject.pipe(switchAll(), defaultShareReplay());
        this.hooks = [];
        this.viewContainer = viewContainer;
        this.viewContainer.createEmbeddedView(templateRef, this.ViewContext);
        this.subscription = this.state.subscribe(state => {
            this.ViewContext.$implicit = state;
            this.ViewContext.state = state;
            this.ViewContext.status.inProgress = state.status === RequestStatus.inProgress;
            this.ViewContext.status.notStarted = state.status === RequestStatus.notStarted;
            this.ViewContext.status.success = state.status === RequestStatus.success;
            this.ViewContext.status.error = state.status === RequestStatus.fail;
            this.hooks.forEach(hook => hook(state));
        });
    }
    ngOnDestroy() {
        this.viewContainer.clear();
        this.subscription.unsubscribe();
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpRequestStateDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: HttpRequestStateDirective, isStandalone: true, selector: "[httpRequestState]", inputs: { stateStore: ["httpRequestState", "stateStore"] }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpRequestStateDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[httpRequestState]', }]
        }], ctorParameters: () => [{ type: i0.TemplateRef }, { type: i0.ViewContainerRef }], propDecorators: { stateStore: [{
                type: Input,
                args: ['httpRequestState']
            }] } });

class HttpStateDirectiveBase {
    constructor() {
        this.hasView = false;
        this.injector = inject(Injector);
        this.templateRef = inject((TemplateRef));
        this.viewContainer = inject(ViewContainerRef);
        this.baseRender = (state) => {
            if (this.hasView) {
                this.viewContainer.clear();
                this.hasView = false;
            }
            this.hasView = this.render(state);
        };
    }
    ngOnInit() {
        const parent = this.injector.get(HttpRequestStateDirective);
        if (parent == null) {
            throw new Error('You can only use an http state directive as a child of the httpRequestState directive.');
        }
        parent.hooks.push(this.baseRender);
        this.baseRender(parent.ViewContext.state);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpStateDirectiveBase, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: HttpStateDirectiveBase, isStandalone: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpStateDirectiveBase, decorators: [{
            type: Directive
        }] });

class HttpErrorStateDirective extends HttpStateDirectiveBase {
    constructor() {
        super(...arguments);
        this.render = (state) => {
            if (isErrorState(state)) {
                this.viewContainer.createEmbeddedView(this.templateRef, { $implicit: state.error });
                return true;
            }
            return false;
        };
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpErrorStateDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: HttpErrorStateDirective, isStandalone: true, selector: "[httpErrorState]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpErrorStateDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[httpErrorState]', }]
        }] });

class HttpInProgressStateDirective extends HttpStateDirectiveBase {
    constructor() {
        super(...arguments);
        this.render = (state) => {
            if (state.status === RequestStatus.inProgress) {
                this.viewContainer.createEmbeddedView(this.templateRef);
                return true;
            }
            return false;
        };
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpInProgressStateDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: HttpInProgressStateDirective, isStandalone: true, selector: "[httpInProgressState]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpInProgressStateDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[httpInProgressState]', }]
        }] });

class HttpNotStartedStateDirective extends HttpStateDirectiveBase {
    constructor() {
        super(...arguments);
        this.render = (state) => {
            if (state.status === RequestStatus.notStarted) {
                this.viewContainer.createEmbeddedView(this.templateRef);
                return true;
            }
            return false;
        };
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpNotStartedStateDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: HttpNotStartedStateDirective, isStandalone: true, selector: "[httpNotStartedState]", usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpNotStartedStateDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[httpNotStartedState]', }]
        }] });

class HttpSuccessStateDirective extends HttpStateDirectiveBase {
    constructor() {
        super(...arguments);
        this.render = (state) => {
            if (isSuccessState(state)) {
                this.viewContainer.createEmbeddedView(this.templateRef, { $implicit: state.body });
                return true;
            }
            return false;
        };
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpSuccessStateDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: HttpSuccessStateDirective, isStandalone: true, selector: "[httpSuccessState]", inputs: { httpSuccessStateTypeSafety: "httpSuccessStateTypeSafety" }, usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpSuccessStateDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[httpSuccessState]', }]
        }], propDecorators: { httpSuccessStateTypeSafety: [{
                type: Input
            }] } });

const getRequestorBody = (source) => source.pipe(filter(isSuccessState), map(res => res.body));

const getRequestorStatus = (source) => source.pipe(map(res => res.status));

function tapError(onError) {
    return function (src) {
        return src.pipe(tap(result => {
            if (isErrorState(result)) {
                onError(result.error);
            }
        }));
    };
}

function tapSuccess(onSuccess) {
    return function (src) {
        return src.pipe(tap(result => {
            if (isSuccessState(result)) {
                onSuccess(result.body);
            }
        }));
    };
}

function mapError(projection) {
    return function (src) {
        return src.pipe(catchError(e => of(projection(e))));
    };
}

function httpRequest(req) {
    return req.pipe(map(createSuccess), mapError(createFailure), startWith(inProgress), defaultShareReplay());
}
function httpRequestor(req) {
    const request$ = new ReplaySubject(1);
    const httpState$ = request$.pipe(switchMap((params) => httpRequest(req(...params))), startWith(notStarted), defaultShareReplay());
    const request = (...params) => {
        request$.next(params);
        return httpState$;
    };
    return ({
        request,
        httpState$,
        body$: httpState$.pipe(getRequestorBody),
        status$: httpState$.pipe(getRequestorStatus)
    });
}
function chainRequest(httpState$, request, requestParams) {
    return httpState$.pipe(switchMap(res => {
        if (res.status === RequestStatus.success) {
            const secondReq = httpRequestor(request);
            const param = requestParams(res.body);
            secondReq.request(...param);
            return secondReq.httpState$;
        }
        else {
            return of(res);
        }
    }));
}

class HttpRequestModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpRequestModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: HttpRequestModule, imports: [HttpSuccessStateDirective,
            HttpRequestStateDirective,
            HttpErrorStateDirective,
            HttpInProgressStateDirective,
            HttpNotStartedStateDirective], exports: [HttpSuccessStateDirective,
            HttpRequestStateDirective,
            HttpErrorStateDirective,
            HttpInProgressStateDirective,
            HttpNotStartedStateDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpRequestModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: HttpRequestModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        HttpSuccessStateDirective,
                        HttpRequestStateDirective,
                        HttpErrorStateDirective,
                        HttpInProgressStateDirective,
                        HttpNotStartedStateDirective,
                    ],
                    exports: [
                        HttpSuccessStateDirective,
                        HttpRequestStateDirective,
                        HttpErrorStateDirective,
                        HttpInProgressStateDirective,
                        HttpNotStartedStateDirective,
                    ]
                }]
        }] });

const onceWhen = (predicate) => (src) => {
    return src.pipe(filter$1(predicate), first());
};
const mapArray = (mapFunc) => (source) => source.pipe(map$1(src => src.map(mapFunc)));
const filterArray = (filterFunc) => (source) => source.pipe(map$1(src => src.filter(filterFunc)));
const onWait = startWithIfEmpty;
function startWithIfEmpty(val, wait = 0) {
    return (source) => {
        return new Observable(subscriber => {
            let emitted = false;
            setTimeout(() => {
                if (!emitted) {
                    subscriber.next(val);
                }
            }, wait);
            const sub = source.subscribe({
                next(x) { emitted = true; subscriber.next(x); },
                error(err) { emitted = true; subscriber.error(err); },
                complete() { emitted = true; subscriber.complete(); }
            });
            return () => sub.unsubscribe();
        });
    };
}
const combineArrays = (sources) => {
    return combineLatest(sources.map(src => src.pipe(startWithIfEmpty([])))).pipe(map$1(res => res.flat()));
};
function switchOff(switchSource, defaultState = true) {
    return (source) => {
        return new Observable(subsciber => {
            let isOn = defaultState;
            const subscription = new Subscription();
            subscription.add(switchSource.subscribe(on => isOn = on));
            subscription.add(source.subscribe({
                next(value) {
                    if (isOn) {
                        subsciber.next(value);
                    }
                },
                error: error => subsciber.error(error),
                complete: () => subsciber.complete()
            }));
            return subscription;
        });
    };
}
function skipOneWhen(skipper) {
    return (source) => {
        return new Observable(subsriber => {
            const subscription = new Subscription();
            let skipNext = false;
            subscription.add(skipper.subscribe(_ => skipNext = true));
            subscription.add(source.subscribe({
                next(value) {
                    if (skipNext) {
                        skipNext = false;
                    }
                    else {
                        subsriber.next(value);
                    }
                },
                error: error => subsriber.error(error),
                complete: () => subsriber.complete()
            }));
            return subscription;
        });
    };
}
function previousAndCurrent(startingValue) {
    return (source) => {
        return source.pipe(startWith$1(startingValue), pairwise());
    };
}
function notNull() {
    return pipe(filter$1((o) => o != null));
}
function delayOn(predicate, delayTime) {
    return (src) => {
        return src.pipe(concatMap(r => {
            if (predicate(r)) {
                return merge(of({ r }), of(null).pipe(delay(delayTime))).pipe(notNull(), map$1(d => d.r));
            }
            else {
                return of(r);
            }
        }));
    };
}

class Subjectifier extends Observable {
    constructor(_source) {
        super((obs) => {
            const s = merge(_source, this._subj).subscribe(obs);
            return s;
        });
        this._subj = new Subject();
        this.next = this._subj.next.bind(this._subj);
        this.newSubj = (...operations) => new Subjectifier(this.merged.pipe(...operations));
        this.merged = merge(_source, this._subj);
    }
}

class Subscriber {
    constructor() {
        this.subscriptions = [];
        this.handle = (subscription) => {
            this.subscriptions.push(subscription);
        };
        this.on = (obs, action) => {
            this.handle(obs.subscribe(action));
        };
    }
    ngOnDestroy() {
        this.subscriptions.forEach(subscription => {
            subscription.unsubscribe();
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: Subscriber, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: Subscriber, isStandalone: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: Subscriber, decorators: [{
            type: Directive
        }] });
function subscriber(obsOrSubOrInjector, actionOrInjector, injector) {
    const destroyRef = getDestroyRef(obsOrSubOrInjector, actionOrInjector, injector);
    const subscriber = new Subscriber();
    if (obsOrSubOrInjector instanceof Subscription) {
        subscriber.handle(obsOrSubOrInjector);
    }
    else if (obsOrSubOrInjector instanceof Observable) {
        subscriber.handle(obsOrSubOrInjector.subscribe(actionOrInjector));
    }
    destroyRef.onDestroy(() => subscriber?.ngOnDestroy());
    return subscriber;
}
function getDestroyRef(obsOrSubOrInjector, actionOrInjector, injector) {
    const providedInjector = obsOrSubOrInjector instanceof Injector ? obsOrSubOrInjector
        : actionOrInjector instanceof Injector ? actionOrInjector
            : injector;
    if (!providedInjector) {
        try {
            assertInInjectionContext(subscriber);
        }
        catch (error) {
            throw new Error('createRequestor() must be used in an Injection Context or you must provide an injector to createRequestor()');
        }
    }
    const destroyRef = providedInjector?.get(DestroyRef) || inject(DestroyRef);
    return destroyRef;
}

class RequestStateStore {
    constructor(req, options, project) {
        this._state = signal({ requestParams: null, response: notStarted });
        this.setState = (state) => this._state.set(state);
        this.state = this._state.asReadonly();
        this.state$ = toObservable(this.state);
        this.injector = inject(Injector);
        this.destroy$ = new Subject();
        this.flatteningStrategy = () => {
            if (this.options?.strategy === RequestStrategy.concurrent)
                return mergeMap((params) => this.createRequest(...params));
            if (this.options?.strategy === RequestStrategy.sequential)
                return concatMap$1((params) => this.createRequest(...params));
            return switchMap((params) => (params[0] instanceof CancellationToken) ?
                of({ requestParams: params[0], response: { status: RequestStatus.cancelled } }) : this.createRequest(...params));
        };
        this.createRequestPipeline = () => {
            const origin$ = new Subject();
            const sub = origin$.pipe(this.flatteningStrategy(), tap(state => this.setState(state)), pipe(takeUntil(this.destroy$))).subscribe();
            return (params) => {
                origin$.next(params);
                return sub;
            };
        };
        this.requestPipeLine = this.createRequestPipeline();
        this.flattenedRequest = (...value) => {
            return this.requestPipeLine(value);
        };
        this.singleUseRequest = (...value) => {
            if (this.state().response.status !== RequestStatus.notStarted) {
                throw new Error("state can not be reused. either reset the state by calling reset() or use a state requester that allows concurrent requests.");
            }
            return this.requestPipeLine(value);
        };
        this.$selectRequestState = computed(() => this.state().response);
        this.selectRequestState$ = this.state$.pipe(map(s => s.response));
        /**
         * @deprecated use selectRequestState$ instead
         */
        this.selectHttpState$ = this.selectRequestState$;
        this.$selectStatus = computed(() => this.$selectRequestState()?.status);
        this.selectStatus$ = this.selectRequestState$.pipe(map(s => s.status));
        this.$isSuccess = computed(() => isSuccessState(this.$selectRequestState()));
        this.$isError = computed(() => isErrorState(this.$selectRequestState()));
        this.$isInProgress = computed(() => this.$selectStatus() === RequestStatus.inProgress);
        this.$isNotStarted = computed(() => this.$selectStatus() === RequestStatus.notStarted);
        this.selectError$ = this.selectRequestState$.pipe(filter(isErrorState), map(state => state.error));
        this.$selectError = computed(() => {
            const state = this.$selectRequestState();
            if (isErrorState(state))
                return state.error;
        });
        this.selectResponse$ = this.selectRequestState$.pipe(filter(isSuccessState), map(state => state.body));
        this.$selectResponse = computed(() => {
            const state = this.$selectRequestState();
            if (isSuccessState(state)) {
                return state.body;
            }
            return undefined;
        });
        this.selectSuccessOrError$ = this.state$.pipe(map(r => r.response), filter(isSuccessOrErrorState), map(() => undefined));
        this.errorHandled = false;
        this.#onDefaultErrorHandling = (e) => {
            if (this.defaultErrorHandling)
                this.defaultErrorHandling(e);
            else
                console.error(e);
        };
        this.subscriber = (srcObservable, func) => {
            return srcObservable.pipe(tap(func), takeUntil(this.destroy$)).subscribe();
        };
        /**
         * @deprecated use the standalone subscriber helper function
         */
        this.on = this.subscriber;
        this.requestWith = (params) => {
            if (isSignal(params)) {
                params = toObservable(params, { injector: this.injector }).pipe(notNull());
            }
            params.pipe(takeUntil(this.destroy$)).subscribe((p) => this.request(...p));
            return this;
        };
        this.assertInjectionContext();
        this.injector.get(DestroyRef).onDestroy(() => this.destroy$.next());
        this.project = project;
        this.options = options;
        this.req = req;
        const config = inject(RequestStateStoreConfigToken, { optional: true });
        if (config) {
            this.defaultErrorHandling = config.defaultErrorHandling;
            this._useDefaultErrorHandler = config.useDefaultErrorHandler;
            this.defaultSuccessHandling = config.defaultSuccessHandling;
            if (this._useDefaultErrorHandler) {
                this.subscriber(this.selectError$, e => {
                    if (!this.errorHandled) {
                        this.#onDefaultErrorHandling(e);
                    }
                });
            }
        }
        this.request = (this.options?.strategy === RequestStrategy.singleUse) ? this.singleUseRequest : this.flattenedRequest;
        if (options?.autoRequest) {
            this.request();
        }
    }
    reset() {
        this._state.set({ requestParams: null, response: notStarted });
    }
    onError(cb) {
        this.errorHandled = true;
        this.subscriber(this.selectError$, cb);
        return this;
    }
    #onDefaultErrorHandling;
    /**
     * if no handler was provided will call `console.error`
     */
    useDefaultErrorHandler() {
        this.subscriber(this.selectError$, this.#onDefaultErrorHandling);
        return this;
    }
    /**
     * if no handler was provided will call `console.log` with 'Success'
     */
    useDefaultSuccessHandler() {
        this.subscriber(this.selectResponse$, this.defaultSuccessHandling || (() => console.log('Success')));
        return this;
    }
    onSuccess(cb) {
        this.subscriber(this.selectResponse$, cb);
        return this;
    }
    onSuccessOrError(cb) {
        this.subscriber(this.selectSuccessOrError$, cb);
        return this;
    }
    onSuccessWithRequest(func) {
        this.subscriber(this.state$, ({ requestParams, response }) => {
            if (isSuccessState(response))
                func({ requestParams, body: response.body });
        });
        return this;
    }
    onErrorWithRequest(func) {
        this.errorHandled = true;
        this.subscriber(this.state$, ({ requestParams, response }) => {
            if (isErrorState(response))
                func({ requestParams, error: response.error });
        });
        return this;
    }
    createRequest(...params) {
        return this.req(...params).pipe(map(re => createSuccess((this.project ? this.project(re) : re))), mapError(createFailure), startWith(inProgress), map(state => ({ requestParams: params, response: state })), defaultShareReplay());
    }
    assertInjectionContext() {
        try {
            assertInInjectionContext(RequestStateStore);
        }
        catch (error) {
            throw new Error('RequestStateStore must be created in an Injection Context');
        }
    }
    destroy() {
        this.destroy$.next();
    }
}
class CancellationToken {
}
/**
 * If any values from the array of signals or observables are null or undefined, all values will be filtered
 */
function wrapInArr(...sigOrObs) {
    if (isSignal(sigOrObs[0])) {
        return computed(() => {
            const arr = sigOrObs.map(s => s());
            if (arr.some(s => s == undefined))
                return undefined;
            return arr;
        });
    }
    else {
        return combineLatest(sigOrObs).pipe(filter(vals => vals.every(val => val != undefined)));
    }
}
const RequestStateStoreConfigToken = new InjectionToken('RequestStateConfig');

class RequestStateFactory {
    constructor() {
        this.requestors = [];
    }
    ngOnDestroy() {
        this.requestors.forEach(request => request.destroy());
    }
    create(req, optionsOrProject, options) {
        const requestor = (typeof (optionsOrProject) === 'function' ? new RequestStateStore(req, options, optionsOrProject) : new RequestStateStore(req, optionsOrProject));
        this.requestors.push(requestor);
        return requestor;
    }
    createHttpClient(r, options) {
        const requestor = new RequestStateStore(r, options);
        this.requestors.push(requestor);
        return requestor;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: RequestStateFactory, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: RequestStateFactory }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: RequestStateFactory, decorators: [{
            type: Injectable
        }], ctorParameters: () => [] });
function createRequestor(req, optionsOrProject, options) {
    const ops = typeof (optionsOrProject) === 'function' ? options : optionsOrProject;
    const injector = getInjector(ops);
    return runInInjectionContext(injector, () => {
        const requestStore = typeof (optionsOrProject) === 'function' ?
            new RequestStateStore(req, options, optionsOrProject)
            : new RequestStateStore(req, optionsOrProject);
        return requestStore;
    });
}
function getInjector(options) {
    const providedInjector = options?.injector;
    if (!providedInjector) {
        try {
            assertInInjectionContext(createRequestor);
        }
        catch (error) {
            throw new Error('createRequestor() must be used in an Injection Context or you must provide an injector to createRequestor()');
        }
    }
    return providedInjector ?? inject(Injector);
}

/**
 * @deprecated use RequestStateFactory
 */

var FieldType;
(function (FieldType) {
    FieldType[FieldType["Unknown"] = 0] = "Unknown";
    FieldType[FieldType["Date"] = 1] = "Date";
    /**
     * @deprecated If `additional.link` is set the column will be treated as a link.
     */
    FieldType[FieldType["Link"] = 2] = "Link";
    FieldType[FieldType["ImageUrl"] = 3] = "ImageUrl";
    FieldType[FieldType["Currency"] = 4] = "Currency";
    FieldType[FieldType["Array"] = 5] = "Array";
    FieldType[FieldType["Hidden"] = 6] = "Hidden";
    FieldType[FieldType["Number"] = 7] = "Number";
    FieldType[FieldType["String"] = 8] = "String";
    FieldType[FieldType["Boolean"] = 9] = "Boolean";
    FieldType[FieldType["PhoneNumber"] = 10] = "PhoneNumber";
    /**
     * @deprecated For mapped properties use proper type (for sorting and filtering) with `map`.
     * For unmapped properties use `FieldType.NotMapped` with map.
     */
    FieldType[FieldType["Expression"] = 11] = "Expression";
    FieldType[FieldType["Enum"] = 12] = "Enum";
    FieldType[FieldType["DateTime"] = 13] = "DateTime";
    FieldType[FieldType["NotMapped"] = 14] = "NotMapped";
})(FieldType || (FieldType = {}));
var SortDirection;
(function (SortDirection) {
    SortDirection["asc"] = "asc";
    SortDirection["desc"] = "desc";
})(SortDirection || (SortDirection = {}));
var Target;
(function (Target) {
    Target["Blank"] = "_blank";
    Target["Self"] = "_self";
    Target["Parent"] = "_parent";
    Target["Top"] = "_top";
})(Target || (Target = {}));
var ArrayStyle;
(function (ArrayStyle) {
    ArrayStyle[ArrayStyle["CommaDelimited"] = 0] = "CommaDelimited";
    ArrayStyle[ArrayStyle["NewLine"] = 1] = "NewLine";
})(ArrayStyle || (ArrayStyle = {}));
function metaDataArrToDict(arr, transform) {
    const dict = {};
    if (transform) {
        arr.forEach(e => dict[e.key] = transform(e));
    }
    else {
        arr.forEach(e => dict[e.key] = e);
    }
    return dict;
}

class GeneralTableSettings {
    constructor() {
        this.headerSettings = new TableWrapperHeaderSettings();
        this.footerSettings = new TableWrapperFooterSettings();
        this.columnHeaderSettings = new TableColumnHeaderSettings();
        this.columnFooterSettings = new TableColumnFooterSettings();
        this.tableSettings = new TableSettings();
    }
}
class TableWrapperHeaderSettings {
    constructor() {
        this.hideExport = false;
        this.hideFilter = false;
        this.hideColumnSettings = false;
        this.hideHeader = false;
        this.hideSort = false;
        this.collapse = false;
        this.showTitleWhenCollapsed = true;
        this.headerHeight = undefined;
    }
}
class TableWrapperFooterSettings {
    constructor() {
        this.collapse = false;
    }
}
class TableColumnHeaderSettings {
    constructor() {
        this.stickyHeaderRow = true;
        this.noFilters = false;
        this.noHeader = false;
    }
}
class TableColumnFooterSettings {
    constructor() {
        this.stickyFooterRow = false;
    }
}
class TableSettings {
    constructor() {
        this.tableId = undefined;
        this.trackBy = undefined;
        this.includeIndexColumn = false;
        this.includeSelectionColumn = false;
        this.usePaginator = undefined;
        this.useVirtualScroll = undefined;
        this.paginatorSettings = undefined;
        this.virtualScrollSettings = undefined;
        this.rowHeight = undefined;
        this.groupHeaderHeight = undefined;
        this.rowClick = undefined;
        this.exportSettings = undefined;
    }
}
class PersistedTableSettings {
    constructor(tableSettings) {
        this.collapseHeader = false;
        this.collapseFooter = false;
        if (tableSettings) {
            this.collapseHeader = tableSettings.collapseHeader;
            this.collapseFooter = tableSettings.collapseFooter;
        }
    }
    merge(tableSettings) {
        const newPts = new PersistedTableSettings(this);
        if (tableSettings) {
            newPts.collapseHeader = tableSettings.headerSettings?.collapse ?? newPts.collapseHeader;
            newPts.collapseFooter = tableSettings.footerSettings?.collapse ?? newPts.collapseFooter;
        }
        return newPts;
    }
}
class NotPersistedTableSettings {
    constructor() {
        this.hideExport = false;
        this.hideFilter = false;
        this.hideColumnSettings = false;
        this.hideSort = false;
        this.showTitleWhenHeaderCollapsed = true;
        this.hideHeader = false;
        this.hideColumnHeaderFilters = false;
        this.hideColumnHeader = false;
        this.usePaginator = true;
        this.useVirtualScroll = false;
        this.paginatorSettings = undefined;
        this.virtualSettings = undefined;
        this.groupHeaderHeight = undefined;
        this.headerHeight = undefined;
        this.rowClick = undefined;
        this.exportSettings = undefined;
    }
    merge(tableSettings) {
        const newNpts = merge$1(this, new NotPersistedTableSettings());
        if (tableSettings) {
            newNpts.hideExport = tableSettings.headerSettings?.hideExport ?? newNpts.hideExport;
            newNpts.hideColumnSettings = tableSettings.headerSettings?.hideColumnSettings ?? newNpts.hideColumnSettings;
            newNpts.hideFilter = tableSettings.headerSettings?.hideFilter ?? newNpts.hideFilter;
            newNpts.hideSort = tableSettings.headerSettings?.hideSort ?? newNpts.hideSort;
            newNpts.showTitleWhenHeaderCollapsed = tableSettings.headerSettings?.showTitleWhenCollapsed ?? newNpts.showTitleWhenHeaderCollapsed;
            newNpts.hideHeader = tableSettings.headerSettings?.hideHeader ?? newNpts.hideHeader;
            newNpts.hideColumnHeaderFilters = tableSettings.columnHeaderSettings?.noFilters ?? newNpts.hideColumnHeaderFilters;
            newNpts.hideColumnHeader = tableSettings.columnHeaderSettings?.noHeader ?? newNpts.hideColumnHeader;
            newNpts.usePaginator = tableSettings.tableSettings?.usePaginator ?? newNpts.usePaginator;
            newNpts.useVirtualScroll = tableSettings.tableSettings?.useVirtualScroll != undefined ? tableSettings.tableSettings?.useVirtualScroll :
                tableSettings.tableSettings?.virtualScrollSettings ? true
                    : newNpts.useVirtualScroll;
            newNpts.rowHeight = tableSettings.tableSettings?.rowHeight ?? newNpts.rowHeight;
            newNpts.headerHeight = tableSettings.headerSettings?.headerHeight ?? newNpts.headerHeight;
            newNpts.groupHeaderHeight = tableSettings.tableSettings?.groupHeaderHeight ?? newNpts.groupHeaderHeight;
            newNpts.minColumnWidth = tableSettings.tableSettings?.minColumnWidth ?? newNpts.minColumnWidth;
            newNpts.rowClasses = tableSettings.tableSettings?.rowClasses ?? newNpts.rowClasses;
            newNpts.rowStyles = tableSettings.tableSettings?.rowStyles ?? newNpts.rowStyles;
            newNpts.rowClick = tableSettings.tableSettings?.rowClick ?? newNpts.rowClick;
            newNpts.exportSettings = tableSettings.tableSettings?.exportSettings ?? newNpts.exportSettings;
            if (tableSettings.tableSettings?.virtualScrollSettings) {
                const currVirt = tableSettings.tableSettings?.virtualScrollSettings || newNpts.virtualSettings;
                if (!currVirt.headerHeight) {
                    currVirt.headerHeight = tableSettings.headerSettings?.headerHeight || DefaultVirtualScrollOptions.headerHeight;
                }
                if (!currVirt.rowHeight) {
                    currVirt.rowHeight = tableSettings.tableSettings?.rowHeight || DefaultVirtualScrollOptions.rowHeight;
                }
                newNpts.virtualSettings = { ...new VirtualScrollOptions(), ...currVirt };
            }
            else
                newNpts.virtualSettings ??= new VirtualScrollOptions();
            if (tableSettings.tableSettings?.paginatorSettings) {
                const currPag = tableSettings.tableSettings?.paginatorSettings ? merge$1(newNpts.paginatorSettings, tableSettings.tableSettings?.paginatorSettings) : (newNpts.paginatorSettings ?? new PaginatorOptions());
                currPag.includeAllInOptions = (currPag.defaultAll && currPag.includeAllInOptions !== false) || currPag.includeAllInOptions;
                newNpts.paginatorSettings = { ...new PaginatorOptions(), ...currPag };
            }
            else
                newNpts.paginatorSettings ??= new PaginatorOptions();
        }
        return newNpts;
    }
}
class VirtualScrollOptions {
    constructor() {
        this.rowHeight = 48;
        this.enforceRowHeight = true;
        this.headerHeight = 56;
        this.enforceHeaderHeight = true;
        this.amountOfVisibleItems = 10;
        /**
         * This will win over `amountOfVisibleItems`
         */
        this.maxViewPortHeight = undefined;
        /**
         * Will try to bring the table to the bottom of the screen
         * If `amountOfVisibleItems` is set that will be the minimum number of rows
         * If `maxViewPortHeight` is set that will be the max table size
         */
        this.dynamicHeight = false;
        /**
         * If `dynamicHeight` is set to true, we will try to add this amount of space from the bottom of view port
         */
        this.dynamicalHeightBuffer = 0;
    }
}
class PaginatorOptions {
    constructor() {
        this.pageSize = undefined;
        this.defaultAll = false;
        this.includeAllInOptions = false;
    }
}
const DefaultVirtualScrollOptions = {
    rowHeight: 48,
    headerHeight: 56,
};
function parseTbSizeToPixels(size) {
    if (!size)
        return undefined;
    if (typeof size === 'number')
        return size;
    if (size.endsWith('px'))
        return Number(size.replace('px', ''));
    if (size.endsWith('rem')) {
        const htmlElement = document.documentElement;
        const remSize = window.getComputedStyle(htmlElement).getPropertyValue('font-size');
        const remSizeNum = Number(remSize.replace('px', ''));
        const num = Number(size.replace('rem', ''));
        return num * remSizeNum;
    }
    return undefined;
}

function isGroupHeader(data) {
    return !!data?.isGroupHeader;
}
class KeysToDelete {
    constructor() {
        this.initializationState = null;
        this.metaData = null;
        this.notPersistedTableSettings = null;
        this.linkMaps = null;
        this.pageSize = null;
        this.currentPage = null;
        this.virtualScrollOffset = null;
        this.dataLen = null;
        this.virtualEnds = null;
        this.virtualEnd = null;
        this.props = null;
        this.showAll = null;
        this.minColumnWidth = null;
        this.allFilters = null;
    }
}
const keysToDelete = Object.keys(new KeysToDelete());
var InitializationState;
(function (InitializationState) {
    InitializationState[InitializationState["Created"] = 0] = "Created";
    InitializationState[InitializationState["MetaDataLoaded"] = 1] = "MetaDataLoaded";
    InitializationState[InitializationState["TableSettingsLoaded"] = 2] = "TableSettingsLoaded";
    InitializationState[InitializationState["Ready"] = 3] = "Ready";
})(InitializationState || (InitializationState = {}));
const defaultTableState = {
    initializationState: InitializationState.Created,
    metaData: {},
    filters: {},
    hiddenKeys: [],
    sorted: [],
    userDefined: { order: {}, widths: {}, table: {} },
    persistedTableSettings: new PersistedTableSettings(),
    notPersistedTableSettings: new NotPersistedTableSettings(),
    pageSize: 10,
    linkMaps: {},
    allFilters: {},
    groupBy: [],
    currentPage: 0,
    props: {},
    showAll: false,
};
const defaultDataState = {
    virtualScrollOffset: 0,
    sortedFilteredDataLength: 0,
    sortedFilteredGroupedDataLength: 0,
    virtualEnds: {
        start: 0, end: 20
    },
};

const ArrayDefaults = {
    limit: 3,
    arrayStyle: ArrayStyle.CommaDelimited
};

// here is how to use it
// <generic-table [report]="report">
//     <p *customCell="'column1'; let element = element" [class.makeMeRed]="element?.port">If Port, i will be red</p>
//     <p *customCell="'column2'">I am custom cell two </p>
// </generic-table>
class CustomCellDirective {
    constructor() {
        this.templateRef = inject(TemplateRef, { optional: true });
        this.columnDef = inject(CdkColumnDef, { optional: true });
        this.$customCell = input.required({ alias: 'customCell' });
        this.$displayName = input(undefined, { alias: 'customCellDisplayName' });
        this.$preSort = input(undefined, { alias: 'preSort' });
        this.$templateRef = input(this.templateRef || undefined, { alias: 'templateRef' });
        this.$customCellOrder = input(undefined, { alias: 'customCellOrder' });
        this.$customCellWidth = input(undefined, { alias: 'customCellWidth' });
        /**
           * for type safety, this is a reference to the table builder instance.
           */
        this.$customCellTableRef = input(undefined, { alias: 'customCellTableRef' });
        /**
           * true if column not mapped to a property in the data source. Default is false.
           */
        this.$customCellNotMapped = input(false, { alias: 'customCellNotMapped', transform: coerceBooleanProperty });
        this.$metaData = computed(() => {
            const c = this.$customCell();
            if (!c)
                return;
            return ({
                key: this.$customCell(),
                displayName: this.$displayName(),
                preSort: this.$preSort(),
                fieldType: this.$customCellNotMapped() ? FieldType.NotMapped : FieldType.Unknown,
                order: this.$customCellOrder(),
                width: this.$customCellWidth(),
                customCell: true,
                noExport: true,
            });
        });
        this.$inited = signal(false);
    }
    ngOnInit() {
        this.$inited.set(true);
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: CustomCellDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.3", type: CustomCellDirective, isStandalone: true, selector: "[customCell]", inputs: { $customCell: { classPropertyName: "$customCell", publicName: "customCell", isSignal: true, isRequired: true, transformFunction: null }, $displayName: { classPropertyName: "$displayName", publicName: "customCellDisplayName", isSignal: true, isRequired: false, transformFunction: null }, $preSort: { classPropertyName: "$preSort", publicName: "preSort", isSignal: true, isRequired: false, transformFunction: null }, $templateRef: { classPropertyName: "$templateRef", publicName: "templateRef", isSignal: true, isRequired: false, transformFunction: null }, $customCellOrder: { classPropertyName: "$customCellOrder", publicName: "customCellOrder", isSignal: true, isRequired: false, transformFunction: null }, $customCellWidth: { classPropertyName: "$customCellWidth", publicName: "customCellWidth", isSignal: true, isRequired: false, transformFunction: null }, $customCellTableRef: { classPropertyName: "$customCellTableRef", publicName: "customCellTableRef", isSignal: true, isRequired: false, transformFunction: null }, $customCellNotMapped: { classPropertyName: "$customCellNotMapped", publicName: "customCellNotMapped", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: CustomCellDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[customCell]' }]
        }] });

class ResizeColumnDirective {
    constructor() {
        this.renderer = inject(Renderer2);
        this.el = inject(ElementRef);
        this.store = inject(TableStore);
        this.resizable = false;
        this.getElementWidth = (elem) => (+(globalThis.getComputedStyle(elem).getPropertyValue('width').replace('px', '')));
    }
    ngOnInit() {
        if (this.resizable) {
            const { table, columnHead } = this.getTableAndColumnHeadHtmlElements();
            const resizer = this.createResizerSpanInColumnHead(columnHead);
            const aggregateMouseEventsMapped$ = this.mouseDownThroughMouseUpEventMapper(resizer, columnHead, table);
            const resizeColsData$ = aggregateMouseEventsMapped$.pipe(filter(({ mouseMove }) => !!mouseMove.buttons), map(({ mouseDownData, mouseMove }) => {
                const { newTableWidth, newColumnWidth } = this.calculateNewWidths(mouseDownData, mouseMove);
                return ({
                    key: this.key,
                    widthInPixel: newColumnWidth,
                    tableSize: newTableWidth,
                });
            }), defaultShareReplay());
            this.store.setUserDefinedWidth(resizeColsData$.pipe(map(resizeData => ([{ key: this.key, widthInPixel: resizeData.widthInPixel }]))));
            this.store.setTableWidth(resizeColsData$.pipe(map(resizeData => resizeData.tableSize)));
        }
    }
    createResizerSpanInColumnHead(columnHead) {
        const resizer = this.renderer.createElement("span");
        this.renderer.addClass(resizer, "resize-holder");
        resizer.style['cursor'] = 'col-resize';
        resizer.style['user-select'] = 'none';
        resizer.style['width'] = '10px';
        resizer.style['height'] = '100%';
        resizer.style['position'] = 'absolute';
        resizer.style['right'] = '0';
        resizer.style['top'] = '0';
        resizer.style['z-index'] = '1';
        this.renderer.appendChild(columnHead, resizer);
        return resizer;
    }
    getTableAndColumnHeadHtmlElements() {
        const columnHead = this.el.nativeElement;
        const row = this.renderer.parentNode(columnHead);
        const table = this.renderer.parentNode(row);
        return ({ table, columnHead });
    }
    mouseDownThroughMouseUpEventMapper(resizer, columnHead, table) {
        return this.resizerMouseDownEventMapper(resizer, columnHead, table)
            .pipe(switchMap(mouseDownData => fromEvent(table, "mousemove").pipe(map(mouseMove => ({ mouseDownData, mouseMove })), takeUntil(fromEvent(document, "mouseup")))));
    }
    resizerMouseDownEventMapper(resizer, columnHead, table) {
        return fromEvent(resizer, "mousedown").pipe(map(event => ({
            startPageX: event.pageX,
            startColumnWidth: this.getElementWidth(columnHead),
            startTableWidth: this.getElementWidth(table),
        })));
    }
    calculateNewWidths(mouseDownData, mouseMove) {
        const change = (mouseMove.pageX - mouseDownData.startPageX);
        let newColumnWidth = mouseDownData.startColumnWidth + change;
        if (newColumnWidth < 1) {
            newColumnWidth = 1;
        }
        const columnChange = newColumnWidth - mouseDownData.startColumnWidth;
        const newTableWidth = (mouseDownData.startTableWidth + columnChange);
        return ({ newTableWidth, newColumnWidth });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ResizeColumnDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "16.1.0", version: "20.0.3", type: ResizeColumnDirective, isStandalone: true, selector: "[resizeColumn]", inputs: { resizable: ["resizeColumn", "resizable", booleanAttribute], key: "key" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ResizeColumnDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[resizeColumn]",
                }]
        }], propDecorators: { resizable: [{
                type: Input,
                args: [{ alias: 'resizeColumn', transform: booleanAttribute }]
            }], key: [{
                type: Input
            }] } });

class TableWrapperDirective {
    constructor() {
        this.$registrations = signal([]);
    }
    register(filter) {
        this.$registrations.update(registrations => [...registrations, filter]);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableWrapperDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TableWrapperDirective, isStandalone: true, selector: "[tbWrapper]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableWrapperDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tbWrapper]',
                }]
        }] });

const FilterType = {
    NumberEquals: 'Equals',
    NumberNotEqual: 'Does Not Equal',
    NumberGreaterThan: 'Greater Than',
    NumberLessThan: 'Less Than',
    NumberBetween: 'Between',
    StringEquals: 'Equals',
    StringContains: 'Contains',
    StringDoesNotContain: 'Does Not Contain',
    StringStartWith: 'Start With',
    StringEndsWith: 'Ends With',
    DateIsOn: 'Is on',
    DateIsNotOn: 'Is Not On',
    DateOnOrAfter: 'On or After',
    DateOnOrBefore: 'On or Before',
    DateBetween: 'Between',
    DateTimeIsAt: 'Is At',
    DateTimeIsNotAt: 'Is Not At',
    DateTimeAtOrAfter: 'At or After',
    DateTimeAtOrBefore: 'At or Before',
    DateTimeBetween: 'Between',
    BooleanEquals: 'Is',
    IsNull: 'Is Blank',
    Or: 'Or',
    And: 'And',
    In: 'In',
    Custom: 'Custom',
};

const inputs = [
    'predicate: tbCustomFilter',
    'filterId: filterId',
];
class TableCustomFilterDirective {
    constructor() {
        this.savable = false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableCustomFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TableCustomFilterDirective, isStandalone: true, selector: "tb-abstract", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableCustomFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'tb-abstract'
                }]
        }] });
class TableFilterDirective {
    constructor() {
        this.model = inject(NgControl, { optional: true });
        this.wrapper = inject(TableWrapperDirective, { optional: true });
        this.filter$ = new ReplaySubject(1);
        this.$filter = toSignal(this.filter$);
        this.active = true;
        this.filterValue = null;
        this.savable = false;
        this.ready = false;
        this._userActive = true;
        if (this.wrapper) {
            this.wrapper.register(this);
        }
        if (this.model) {
            subscriber(this.model.valueChanges, val => {
                if (this.filterType === FilterType.StringContains && val === '') {
                    val = undefined;
                }
                this.filterValue = val;
                this.update();
            });
        }
    }
    reset() {
        this.filterValue = undefined;
    }
    setFilterValue(value) {
        if (this.model) {
            setTimeout(() => {
                this.model.reset(value);
            }, 0);
        }
        else {
            this.filterValue = value;
        }
    }
    ngOnChanges(changes) {
        this.update();
    }
    ngOnInit() {
        if (!this.filterId) {
            this.filterId = crypto.randomUUID();
        }
        else {
            this.savable = true;
        }
        this.ready = true;
        this.update();
    }
    setFilter(filter) {
        this.filter$.next(filter);
    }
    update() {
        if (this.ready) {
            this.setFilter({
                filterId: this.filterId,
                key: this.key,
                filterType: this.filterType,
                fieldType: this.fieldType,
                filterValue: this.filterValue,
                active: this.active && this.filterValue !== undefined,
                _isExternallyManaged: true,
            });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TableFilterDirective, isStandalone: true, selector: "[tbFilter]", inputs: { filterType: "filterType", key: "key", fieldType: "fieldType", filterId: "filterId", active: "active", filterValue: "filterValue" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[tbFilter]",
                }]
        }], ctorParameters: () => [], propDecorators: { filterType: [{
                type: Input
            }], key: [{
                type: Input
            }], fieldType: [{
                type: Input
            }], filterId: [{
                type: Input
            }], active: [{
                type: Input
            }], filterValue: [{
                type: Input
            }] } });
class TableFilterStringContainsDirective extends TableFilterDirective {
    constructor() {
        super();
        this.filterType = FilterType.StringContains;
        this.fieldType = FieldType.String;
    }
    reset() {
        if (this.model) {
            this.model.reset();
        }
        super.reset();
    }
    setFilter(filter) {
        filter.active = filter.filterValue && this._userActive;
        super.setFilter(filter);
    }
    ngOnChanges(changes) {
        if (changes['active']) {
            this._userActive = changes['active'].currentValue;
        }
        super.ngOnChanges(changes);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableFilterStringContainsDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TableFilterStringContainsDirective, isStandalone: true, selector: "[tbFilterStringContains]", inputs: { key: ["tbFilterStringContains", "key"], filterValue: "filterValue", filterId: "filterId", active: "active" }, providers: [{ provide: TableFilterDirective, useExisting: TableFilterStringContainsDirective }], usesInheritance: true, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableFilterStringContainsDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tbFilterStringContains]',
                    providers: [{ provide: TableFilterDirective, useExisting: TableFilterStringContainsDirective }],
                    inputs: [
                        'key:tbFilterStringContains',
                        'filterValue:filterValue',
                        'filterId: filterId',
                        'active: active',
                    ],
                }]
        }], ctorParameters: () => [] });
class TableCustomFilterDirectiveBase extends TableCustomFilterDirective {
    constructor() {
        super(...arguments);
        this.filter$ = new ReplaySubject(1);
        this.$filter = toSignal(this.filter$);
        this._active = false;
        this.ready = false;
    }
    set predicate(val) {
        this._predicate = val;
        this.update({ predicate: val });
    }
    update(val) {
        if (this.ready) {
            this.filter = { ...this.filter, ...val };
            this.filter$.next(this.filter);
        }
    }
    set active(val) {
        if (this._active !== val) {
            this._active = val;
            this.update({ active: val });
        }
    }
    get active() {
        return this._active;
    }
    ngOnInit() {
        if (!this.filterId) {
            this.filterId = crypto.randomUUID();
        }
        else {
            this.savable = true;
        }
        this.filter = {
            filterType: FilterType.Custom,
            filterId: this.filterId,
            active: this._active,
            predicate: this._predicate,
        };
        this.ready = true;
        this.filter$.next(this.filter);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableCustomFilterDirectiveBase, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TableCustomFilterDirectiveBase, isStandalone: true, selector: "[tbCustomFilter]", inputs: { predicate: ["tbCustomFilter", "predicate"], active: "active" }, usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableCustomFilterDirectiveBase, decorators: [{
            type: Directive,
            args: [{
                    selector: "[tbCustomFilter]",
                }]
        }], propDecorators: { predicate: [{
                type: Input,
                args: ['tbCustomFilter']
            }], active: [{
                type: Input
            }] } });
class TbSelectedFilterDirective extends TableCustomFilterDirectiveBase {
    constructor(change, isActive) {
        super();
        this.change = change;
        this.isActive = isActive;
        this.wrapper = inject(TableWrapperDirective, { optional: true });
        this.destroySubject$ = new ReplaySubject(1);
        if (this.wrapper) {
            this.wrapper.register(this);
        }
    }
    reset() {
        this.active = false;
    }
    ngOnDestroy() {
        this.destroySubject$.next();
    }
    ngOnInit() {
        this._active = this.isActive();
        super.ngOnInit();
        this.change.pipe(takeUntil$1(this.destroySubject$)).subscribe(() => {
            this.active = this.isActive();
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TbSelectedFilterDirective, deps: "invalid", target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TbSelectedFilterDirective, isStandalone: true, usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TbSelectedFilterDirective, decorators: [{
            type: Directive
        }], ctorParameters: () => [{ type: i1.Observable }, { type: undefined }] });
// Checkbox
class MatCheckboxTbFilterDirective extends TbSelectedFilterDirective {
    set active(val) {
        this.matCheckbox.checked = val;
        super.active = val;
    }
    constructor() {
        const matCheckbox = inject(MatCheckbox);
        super(matCheckbox.change, () => matCheckbox.checked);
        this.matCheckbox = inject(MatCheckbox);
        this.matCheckbox = matCheckbox;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatCheckboxTbFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MatCheckboxTbFilterDirective, isStandalone: true, selector: "mat-checkbox[tbCustomFilter]", inputs: { predicate: ["tbCustomFilter", "predicate"], filterId: "filterId" }, providers: [{ provide: TableCustomFilterDirective, useExisting: MatCheckboxTbFilterDirective }], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatCheckboxTbFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'mat-checkbox[tbCustomFilter]',
                    inputs: [
                        ...inputs
                    ],
                    providers: [{ provide: TableCustomFilterDirective, useExisting: MatCheckboxTbFilterDirective }],
                }]
        }], ctorParameters: () => [] });
class MatSlideToggleTbFilterDirective extends TbSelectedFilterDirective {
    set active(val) {
        this.matSlideToggle.checked = val;
        super.active = val;
    }
    constructor() {
        const matSlideToggle = inject(MatSlideToggle);
        super(matSlideToggle.change, () => matSlideToggle.checked);
        this.matSlideToggle = matSlideToggle;
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatSlideToggleTbFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MatSlideToggleTbFilterDirective, isStandalone: true, selector: "mat-slide-toggle[tbCustomFilter]", inputs: { predicate: ["tbCustomFilter", "predicate"], filterId: "filterId" }, providers: [{ provide: TableCustomFilterDirective, useExisting: MatSlideToggleTbFilterDirective }], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatSlideToggleTbFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'mat-slide-toggle[tbCustomFilter]',
                    inputs: [
                        ...inputs
                    ],
                    providers: [{ provide: TableCustomFilterDirective, useExisting: MatSlideToggleTbFilterDirective }],
                }]
        }], ctorParameters: () => [] });
// Radio button
class MatRadioButtonTbFilterDirective extends TbSelectedFilterDirective {
    set active(val) {
        this.matRadioButton.checked = val;
        super.active = val;
    }
    constructor() {
        const matRadioButton = inject(MatRadioButton);
        super(matRadioButton.change, () => matRadioButton.checked);
        this.matRadioButton = matRadioButton;
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatRadioButtonTbFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MatRadioButtonTbFilterDirective, isStandalone: true, selector: "mat-radio-button[tbCustomFilter]", inputs: { predicate: ["tbCustomFilter", "predicate"] }, providers: [{ provide: TableCustomFilterDirective, useExisting: MatRadioButtonTbFilterDirective }], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatRadioButtonTbFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'mat-radio-button[tbCustomFilter]',
                    inputs: ['predicate: tbCustomFilter'],
                    providers: [{ provide: TableCustomFilterDirective, useExisting: MatRadioButtonTbFilterDirective }],
                }]
        }], ctorParameters: () => [] });
// Option (select)
class MatOptionTbFilterDirective extends TbSelectedFilterDirective {
    set active(val) {
        if (val) {
            this.matOption.select();
        }
        else {
            this.matOption.deselect();
        }
        super.active = val;
    }
    constructor() {
        const matOption = inject(MatOption);
        super(matOption.onSelectionChange.pipe(tap$1(d => {
            if (!matOption.value) {
                matOption.value = crypto.randomUUID();
            }
        })), () => matOption.selected);
        this.matOption = matOption;
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatOptionTbFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MatOptionTbFilterDirective, isStandalone: true, selector: "mat-option[tbCustomFilter]", inputs: { predicate: ["tbCustomFilter", "predicate"], filterId: "filterId" }, providers: [{ provide: TableCustomFilterDirective, useExisting: MatOptionTbFilterDirective }], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatOptionTbFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'mat-option[tbCustomFilter]',
                    inputs: [
                        ...inputs
                    ],
                    providers: [{ provide: TableCustomFilterDirective, useExisting: MatOptionTbFilterDirective }],
                }]
        }], ctorParameters: () => [] });
// Button toggle
class MatButtonToggleFilterDirective extends TbSelectedFilterDirective {
    set active(val) {
        this.matButtonToggle.checked = val;
        super.active = val;
    }
    constructor() {
        const matButtonToggle = inject(MatButtonToggle);
        super(matButtonToggle.change, () => matButtonToggle.checked);
        this.matButtonToggle = matButtonToggle;
    }
    ngOnInit() {
        super.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatButtonToggleFilterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MatButtonToggleFilterDirective, isStandalone: true, selector: "mat-button-toggle[tbCustomFilter]", inputs: { predicate: ["tbCustomFilter", "predicate"], filterId: "filterId" }, providers: [{ provide: TableCustomFilterDirective, useExisting: MatButtonToggleFilterDirective }], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatButtonToggleFilterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'mat-button-toggle[tbCustomFilter]',
                    inputs: [
                        ...inputs
                    ],
                    providers: [{ provide: TableCustomFilterDirective, useExisting: MatButtonToggleFilterDirective }],
                }]
        }], ctorParameters: () => [] });

class PhoneNumberPipe {
    transform(phoneNum) {
        return phoneFormatter(phoneNum);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: PhoneNumberPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: PhoneNumberPipe, isStandalone: true, name: "phone" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: PhoneNumberPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'phone' }]
        }] });
function phoneFormatter(phoneNum) {
    if (phoneNum) {
        phoneNum = phoneNum.replace(/\D/g, '');
        if (phoneNum[0] === '1') {
            phoneNum = phoneNum.substring(1);
        }
        return '(' + phoneNum.slice(0, 3) + ') ' + phoneNum.slice(3, 6) + '-' + phoneNum.slice(6, 10) + ' ' + phoneNum.slice(10);
    }
    return '';
}

class SpaceCasePipe {
    transform(value) {
        return spaceCase(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SpaceCasePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: SpaceCasePipe, isStandalone: true, name: "spaceCase" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SpaceCasePipe, decorators: [{
            type: Pipe,
            args: [{ name: 'spaceCase' }]
        }] });
/**
 * Adds a space before uppercase letters that either
 * 1. follows a lowercase letter or digit
 * 2. or precedes a lowercase letter and follows an alpha-numeric character
 *
 * Uppercases the first digit
 *
 * Turns underscores into spaces
 */
function spaceCase(value) {
    const phrase = value?.replace(regex1, '$1$3 $2$4');
    // uppercase the first character of every word
    return phrase?.replace(regex2, x => x.toUpperCase());
}
const regex1 = /([a-z0-9])([A-Z])|([a-zA-Z0-9])([A-Z])(?=[a-z])|_/g;
const regex2 = /(^| )(\w)/g;

const defaultConfig = {
    defaultTableSettings: {
        pageSize: 10
    },
    arrayDefaults: ArrayDefaults
};
const TableBuilderConfigToken = new InjectionToken('TableBuilderConfig');
function provideTableBuilder(config) {
    return makeEnvironmentProviders([
        MultiSortDirective,
        SpaceCasePipe,
        DatePipe,
        CurrencyPipe,
        PhoneNumberPipe,
        { provide: TableBuilderConfigToken, useValue: config || defaultConfig }
    ]);
}

const isNull = (filterInfo) => {
    const func = filterInfo.filterValue ?
        (val) => val == null || val === ''
        :
            (val) => val != null && val !== '';
    return func;
};

const stringEqualFunc = (filterInfo) => {
    const equalsVal = prepareForStringCompare(filterInfo.filterValue);
    return ((val) => prepareForStringCompare(val) === equalsVal);
};
const stringContainsFunc = (filterInfo) => {
    const containsVal = prepareForStringCompare(filterInfo.filterValue);
    return ((val) => prepareForStringCompare(val).includes(containsVal));
};
const stringDoesNotContainFunc = (filterInfo) => {
    const doesNotContainVal = prepareForStringCompare(filterInfo.filterValue);
    return ((val) => !prepareForStringCompare(val)?.includes(doesNotContainVal));
};
const stringStartsWithFunc = (filterInfo) => {
    const startsWith = prepareForStringCompare(filterInfo.filterValue);
    return ((val) => prepareForStringCompare(val).startsWith(startsWith));
};
const stringEndsWithFunc = (filterInfo) => {
    const startsWith = prepareForStringCompare(filterInfo.filterValue);
    return ((val) => prepareForStringCompare(val).endsWith(startsWith));
};
const multipleStringValuesEqualsFunc = (filterInfo) => {
    const filterVals = filterInfo.filterValue.map((v) => prepareForStringCompare(v));
    return ((val) => {
        const v = prepareForStringCompare(val);
        return filterVals.some((s) => v === s);
    });
};
const StringFilterFuncs = {
    [FilterType.StringEquals]: stringEqualFunc,
    [FilterType.StringContains]: stringContainsFunc,
    [FilterType.StringDoesNotContain]: stringDoesNotContainFunc,
    [FilterType.StringStartWith]: stringStartsWithFunc,
    [FilterType.StringEndsWith]: stringEndsWithFunc,
    [FilterType.IsNull]: isNull,
    [FilterType.In]: multipleStringValuesEqualsFunc,
};
const EnumFilterFuncs = {
    [FilterType.IsNull]: isNull,
    [FilterType.In]: multipleStringValuesEqualsFunc,
};
const prepareForStringCompare = (val) => (val?.toString().trim().toLowerCase());

const numberEqalsFunc = (filterInfo) => (val) => {
    return val === filterInfo.filterValue;
};
const numberNotEqualFunc = (filterInfo) => (val) => {
    return val !== filterInfo.filterValue;
};
const numberGreaterThanFunc = (filterInfo) => (val) => {
    return val > filterInfo.filterValue;
};
const numberLessThanFunc = (filterInfo) => (val) => {
    return val < filterInfo.filterValue;
};
const numberBetweenFunc = (filterInfo) => {
    const startVal = Number(filterInfo.filterValue.Start);
    const endVal = Number(filterInfo.filterValue.End);
    return ((val) => (val > startVal) && (val < endVal));
};
const multipleNumberValuesEqualsFunc = (filterInfo) => {
    return ((val) => filterInfo.filterValue.some((value) => val === value));
};
const NumberFilterFuncs = {
    [FilterType.NumberEquals]: numberEqalsFunc,
    [FilterType.NumberNotEqual]: numberNotEqualFunc,
    [FilterType.NumberGreaterThan]: numberGreaterThanFunc,
    [FilterType.NumberLessThan]: numberLessThanFunc,
    [FilterType.NumberBetween]: numberBetweenFunc,
    [FilterType.IsNull]: isNull,
    [FilterType.In]: multipleNumberValuesEqualsFunc,
};

const dateIsOnFunc = (filterInfo) => {
    const isOnVal = new Date(filterInfo.filterValue).getTime();
    const clean = filterInfo.fieldType === FieldType.Date ? (a, b) => b : cleanDateTime;
    return ((val) => clean(filterInfo, val).getTime() === isOnVal);
};
const dateIsNotOnFunc = (filterInfo) => {
    const isNotOnVal = new Date(filterInfo.filterValue).getTime();
    const clean = filterInfo.fieldType === FieldType.Date ? (a, b) => b : cleanDateTime;
    return ((val) => clean(filterInfo, val).getTime() !== isNotOnVal);
};
const dateIsOnOrAfterFunc = (filterInfo) => {
    const afterVal = new Date(filterInfo.filterValue).getTime();
    const clean = filterInfo.fieldType === FieldType.Date ? (a, b) => b : cleanDateTime;
    return ((val) => clean(filterInfo, val).getTime() >= afterVal);
};
const dateIsOnOrBeforeFunc = (filterInfo) => {
    const beforeVal = new Date(filterInfo.filterValue).getTime();
    const clean = filterInfo.fieldType === FieldType.Date ? (a, b) => b : cleanDateTime;
    return ((val) => clean(filterInfo, val).getTime() <= beforeVal);
};
const dateIsInFunc = (filterInfo) => {
    const filterVals = filterInfo.filterValue.map(v => new Date(v).getTime());
    const clean = filterInfo.fieldType === FieldType.Date ? (a, b) => b : cleanDateTime;
    return ((val) => {
        const d = clean(filterInfo, val).getTime();
        return filterVals.some((f) => f === d);
    });
};
const dateBetweenFunc = (filterInfo) => {
    const startVal = new Date(filterInfo.filterValue.Start);
    const endVal = new Date(filterInfo.filterValue.End);
    const clean = filterInfo.fieldType === FieldType.Date ? (a, b) => b : cleanDateTime;
    return ((val) => {
        const cleanedVal = clean(filterInfo, val);
        return cleanedVal >= startVal && cleanedVal <= endVal;
    });
};
const cleanDateTime = (filterInfo, val) => {
    if (!!DateFilterFuncs[filterInfo.filterType]) {
        const d = new Date(val);
        d.setHours(0, 0, 0, 0);
        return d;
    }
    return val;
};
const DateFilterFuncs = {
    [FilterType.DateIsOn]: dateIsOnFunc,
    [FilterType.DateIsNotOn]: dateIsNotOnFunc,
    [FilterType.DateOnOrAfter]: dateIsOnOrAfterFunc,
    [FilterType.DateOnOrBefore]: dateIsOnOrBeforeFunc,
    [FilterType.DateBetween]: dateBetweenFunc,
    [FilterType.In]: dateIsInFunc,
    [FilterType.IsNull]: isNull,
};
const DateTimeFilterFuncs = {
    ...DateFilterFuncs,
    [FilterType.DateTimeIsAt]: dateIsOnFunc,
    [FilterType.DateTimeIsNotAt]: dateIsNotOnFunc,
    [FilterType.DateTimeAtOrAfter]: dateIsOnOrAfterFunc,
    [FilterType.DateTimeAtOrBefore]: dateIsOnOrBeforeFunc,
    [FilterType.DateTimeBetween]: dateBetweenFunc,
    [FilterType.In]: dateIsInFunc,
    [FilterType.IsNull]: isNull,
};

const booleanEqualsFunc = (filterInfo) => (val) => {
    return filterInfo.filterValue === val;
};
const BooleanFilterFuncs = {
    [FilterType.BooleanEquals]: booleanEqualsFunc,
    [FilterType.IsNull]: isNull,
};

function sortData(data, sorted) {
    return data.sort(compareT(sorted));
}
function filterData(data, filters, resetAll = false) {
    if (filters.length === 0) {
        if (resetAll) {
            for (let index = 0; index < data.length; index++) {
                const element = data[index];
                element[tbNoShowSymbol] = false;
            }
        }
        return data;
    }
    for (let index = 0; index < data.length; index++) {
        const element = data[index];
        const hide = !filters.every(filter => filter(element));
        if (hide || resetAll) {
            element[tbNoShowSymbol] = hide;
        }
    }
    return data;
}
const tbNoShowSymbol = Symbol('tb_no_show');
function compareT(criteria) {
    const transforms = criteria.reduce((acc, c) => {
        acc[c.active] = {
            transform: c.sortBy ? c.sortBy : getFactory(c.active), nulls: c.nulls === 'first' ? -1 : 1
        };
        return acc;
    }, {});
    return function (a, b) {
        for (let index = 0; index < criteria.length; index++) {
            const c = criteria[index];
            const d = transforms[c.active];
            const nullValue = d.nulls;
            if (a == null) {
                if (b == null)
                    return 0;
                return nullValue;
            }
            if (b == null)
                return -nullValue;
            const transform = d.transform;
            const aVal = transform(a);
            const bVal = transform(b);
            if (aVal == null) {
                if (bVal == null)
                    return 0;
                return nullValue;
            }
            if (bVal == null)
                return -nullValue;
            if (aVal < bVal)
                return c.direction === 'asc' ? -1 : 1;
            if (aVal > bVal)
                return c.direction === 'asc' ? 1 : -1;
        }
        return 0;
    };
}
function getFactory(b) {
    if (typeof b !== 'string')
        return (a) => a[b];
    if (!b.includes('.'))
        return (a) => {
            if (!a)
                return a;
            return a[b];
        };
    const arr = b.split('.');
    return (a) => {
        let val = a;
        if (!a)
            return a;
        for (let index = 0; index < arr.length; index++) {
            val = val[arr[index]];
            if (val == undefined)
                return undefined;
            if (typeof val !== 'object' && index + 1 < arr.length)
                return undefined;
        }
        return val;
    };
}

const filterFactoryMap = {
    [FilterType.And]: (filter) => {
        const filters = createFilterFuncs(filter.filterValue);
        return (obj) => filters.every(f => f(obj));
    },
    [FilterType.In]: (filter) => {
        const filters = createFilterFuncs(filter.filterValue);
        return (obj) => filters.some(f => f(obj));
    },
};
const filterTypeFuncMap = {
    [FieldType.Array]: StringFilterFuncs,
    [FieldType.Boolean]: BooleanFilterFuncs,
    [FieldType.Currency]: NumberFilterFuncs,
    [FieldType.Date]: DateFilterFuncs,
    [FieldType.DateTime]: DateTimeFilterFuncs,
    [FieldType.Enum]: EnumFilterFuncs,
    [FieldType.Link]: StringFilterFuncs,
    [FieldType.Number]: NumberFilterFuncs,
    [FieldType.PhoneNumber]: StringFilterFuncs,
    [FieldType.String]: StringFilterFuncs,
    [FieldType.Unknown]: StringFilterFuncs,
};
const filterTypeMap = Object.entries(filterTypeFuncMap).reduce((acc, [key, value]) => ({ ...acc, [key]: Object.keys(value) }), {});
function isCustomFilter(filter) {
    return filter && filter.filterType === FilterType.Custom;
}
function isFilterInfo(filter) {
    return filter && typeof filter.key === 'string' && filter.filterType !== FilterType.Custom;
}
const defaultPredicate = () => true;
function createFilterFuncs(filters) {
    return filters.filter(needsFilterCreation).map(createFilterFunc);
}
function needsFilterCreation(filter) {
    if (isCustomFilter(filter)) {
        return filter.active !== false;
    }
    return filter.filterValue != undefined && filter.active !== false;
}
function createFilterFunc(filter) {
    if (isCustomFilter(filter)) {
        return filter.active ? filter.predicate : defaultPredicate;
    }
    if (filter.filterValue == undefined) {
        return defaultPredicate;
    }
    const func = filterTypeFuncMap[filter.fieldType][filter.filterType](filter);
    if (!func) {
        if (filterFactoryMap[filter.filterType]) {
            return filterFactoryMap[filter.filterType](filter);
        }
    }
    const cannotBeTrueForNull = !FalseyValueCanBeIncludedFilterTypes.includes(filter.filterType);
    const getter = filter.filterBy || getFactory(filter.key);
    return (rowObj) => {
        const value = getter(rowObj);
        return ((value == undefined) && cannotBeTrueForNull)
            ? false
            : func(value);
    };
}
const FalseyValueCanBeIncludedFilterTypes = [
    FilterType.IsNull,
    FilterType.NumberNotEqual,
    FilterType.DateIsNotOn,
    FilterType.StringDoesNotContain,
];

const replaceInArrayWithClone = (arr, findMeth, actionOnClone = ((t) => { })) => {
    const index = arr.findIndex(findMeth);
    const clonedArray = [...arr];
    const t = clonedArray[index];
    clonedArray[index] =
        t != null && typeof t === 'object' ?
            Array.isArray(t) ?
                [...t]
                : { ...t }
            : t;
    actionOnClone(clonedArray[index]);
    return clonedArray;
};

const orderedStateVisibleMetaData = (state) => {
    const ordered = orderStateMetaData(state);
    const orderedVisible = ordered
        .filter(metaData => !state.hiddenKeys.includes(metaData.key) && state.metaData[metaData.key].fieldType !== FieldType.Hidden);
    return orderedVisible;
};
const orderedCodeVisibleMetaData = (state) => orderStateMetaData(state).filter(md => md.fieldType !== FieldType.Hidden);
const orderStateMetaData = (state) => {
    return orderMetaData(state.metaData, state.userDefined.order);
};
const orderMetaData = (metaData, userDefined) => {
    const userOrderArr = Object.entries(userDefined);
    return userOrderArr.length ?
        Object.values(metaData).sort((a, b) => {
            const orderA = userDefined[a.key];
            const orderB = userDefined[b.key];
            return order(orderA, orderB);
        })
        :
            Object.values(metaData).sort((a, b) => {
                const orderA = a.order;
                const orderB = b.order;
                return order(orderA, orderB);
            });
};
function order(orderA, orderB) {
    if (orderA == null && orderB == null) {
        return 0;
    }
    if (orderA == null) {
        return 1;
    }
    if (orderB == null) {
        return -1;
    }
    return orderA - orderB;
}
function cleanPersistedState(state, pState) {
    const metas = Object.values(state.metaData);
    const filters = Object.values(pState.filters).filter(fltr => isCustomFilter(fltr) || metas.some(m => m.key === fltr.key)).reduce((obj, filter) => {
        obj[filter.filterId] = pState.filters[filter.filterId];
        return obj;
    }, {});
    const sorted = pState.sorted.filter(s => metas.some(m => m.key === s.active));
    return ({ ...pState, filters, sorted });
}
const mapSaveableState = (s) => {
    const savableState = { ...s };
    keysToDelete.forEach(key => delete savableState[key]);
    return savableState;
};
const createPreSort = (metaDatas) => {
    return Object.values(metaDatas).filter((metaData) => !!metaData.preSort)
        .sort(({ preSort: ps1 }, { preSort: ps2 }) => (ps1.precedence || Number.MAX_VALUE) - (ps2.precedence || Number.MAX_VALUE))
        .map(({ key, preSort: { direction } }) => ({ active: key, direction }));
};
const mergeMeta = (orig, merge) => {
    return {
        key: orig.key,
        displayName: merge.displayName ?? orig.displayName,
        fieldType: merge.fieldType || orig.fieldType,
        additional: { ...orig.additional, ...merge.additional },
        order: merge.order ?? orig.order,
        preSort: merge.preSort ?? orig.preSort,
        width: merge.width ?? orig.width,
        noExport: merge.noExport || orig.noExport,
        noFilter: merge.noFilter || orig.noFilter,
        customCell: merge.customCell ?? orig.customCell,
        transform: merge.transform ?? orig.transform,
        map: merge.map ?? orig.map,
        click: merge.click ?? orig.click,
        classes: merge.classes ?? orig.classes,
        noSort: merge.noSort ?? orig.noSort,
        template: merge.template ?? orig.template,
        toolTip: merge.toolTip ?? orig.toolTip,
        useIcon: merge.useIcon ?? orig.useIcon,
        filterLogic: merge.filterLogic ?? orig.filterLogic,
        sortLogic: merge.sortLogic ?? orig.sortLogic
    };
};
const initializeOrder = (state, mds) => {
    const viewableMetaDataArr = Object.values(mds).filter(a => a.fieldType !== FieldType.Hidden);
    let userDefinedOrder = state.userDefined.order;
    if (viewableMetaDataArr.some(meta => userDefinedOrder[meta.key] == null)) {
        return {};
    }
    return userDefinedOrder;
};

class TableStore extends ComponentStore {
    constructor() {
        const config = inject(TableBuilderConfigToken);
        const settingsFromConfig = {
            persistedTableSettings: new PersistedTableSettings().merge(config.defaultTableSettings),
            notPersistedTableSettings: new NotPersistedTableSettings().merge(config.defaultTableSettings),
        };
        if (config.defaultTableSettings?.pageSize) {
            settingsFromConfig.notPersistedTableSettings.paginatorSettings.pageSize = config.defaultTableSettings?.pageSize;
        }
        const pageSize = settingsFromConfig.notPersistedTableSettings.paginatorSettings.pageSize || defaultTableState.pageSize;
        const showAll = settingsFromConfig.notPersistedTableSettings.paginatorSettings.defaultAll || defaultTableState.showAll;
        super({ ...defaultTableState, ...settingsFromConfig, pageSize, showAll });
        this.$initializationState = this.selectSignal(state => state.initializationState);
        this.$savableState = computed(() => {
            const state = this.state();
            return mapSaveableState(state);
        });
        this.$userDefinedOrder = this.selectSignal(state => state.userDefined.order);
        this.metaData$ = this.select(state => state.metaData);
        this.$metaData = this.selectSignal(state => state.metaData);
        this.$metaDataArray = this.selectSignal(this.$metaData, this.$userDefinedOrder, orderMetaData);
        this.$orderedCodeVisibleMetaDatas = this.selectSignal(this.$metaDataArray, (mds) => mds.filter(m => m.fieldType !== FieldType.Hidden), { equal: (a, b) => b.length === a.length && b.every((s, i) => a[i].key === s.key) });
        this.$getMetaData = (key) => computed(() => {
            const metaData = this.state().metaData[key];
            if (!metaData)
                console.warn(`Meta data with key ${key} not found`);
            return metaData;
        });
        this.$hiddenKeys = this.selectSignal(state => state.hiddenKeys);
        this.$orderedVisibleColumns = this.selectSignal(this.$orderedCodeVisibleMetaDatas, this.$hiddenKeys, (cs, hiddenKeys) => cs.filter(m => !hiddenKeys.includes(m.key)).map(m => m.key));
        this.$getUserDefinedWidths = this.selectSignal(state => state.userDefined.widths);
        this.$tableSettingsMinWidth = this.selectSignal(state => parseTbSizeToPixels(state.notPersistedTableSettings.minColumnWidth));
        this.$getUserDefinedWidth = (key) => this.selectSignal(this.$getUserDefinedWidths, widths => widths[key]);
        this.$filters = this.selectSignal(state => state.filters);
        this.filters$ = this.select(state => state.filters);
        this.$getFilter = (filterId) => {
            return this.selectSignal(this.$filters, filters => filters[filterId]);
        };
        this.$preSort = computed(() => createPreSort(this.$metaData()));
        this._$selectSorted = this.selectSignal(state => state.sorted, {
            equal: sortsAreSame
        });
        this.$selectSorted = computed(() => {
            const metaDict = this.$metaData();
            return this._$selectSorted().map(s => {
                const meta = metaDict[s.active];
                const sortLogic = meta.sortLogic;
                const sortBy = sortLogic?.sortBy === 'use map' ? meta.map : sortLogic?.sortBy;
                return ({ ...s, ...sortLogic, sortBy });
            });
        });
        this.selectSorted$ = this.select(state => state.sorted).pipe(distinctUntilChanged(sortsAreSame));
        this.$getSorts = this.selectSignal(() => this.$initializationState() !== InitializationState.Ready ? [] : this.$selectSorted());
        this.sort$ = toObservable(this.$getSorts);
        this.$getUserDefinedTableWidth = this.selectSignal(state => state.userDefined.table.width);
        this.getUserDefinedTableWidth$ = this.select(state => state.userDefined.table.width);
        this.$userDefinedRowHeight = this.selectSignal(state => (state.userDefined.rowHeight));
        this.$userDefinedHeaderHeight = this.selectSignal(state => (state.userDefined.headerHeight));
        this.$userDefinedPageSize = this.selectSignal(state => (state.userDefined.pageSize));
        this.$footerCollapsed = this.selectSignal(state => state.persistedTableSettings.collapseFooter);
        this.$headerCollapsed = this.selectSignal(state => state.persistedTableSettings.collapseHeader);
        this.$groupBy = this.selectSignal(state => state.groupBy);
        this.$groupByKeys = this.selectSignal(this.$groupBy, this.$metaDataArray, (gb, mds) => gb.map(gbk => gbk.key).filter(bg => mds.some(md => md.key === bg)), {
            equal: (prev, curr) => prev.length === curr.length && curr.every((k, i) => prev[i] === k)
        });
        this.groupByKeys$ = this.select(state => state.groupBy.map(gbk => gbk.key))
            .pipe(distinctUntilChanged((prev, curr) => prev.length === curr.length && curr.every((k, i) => prev[i] === k)));
        this.expandedGroups$ = this.select(state => state.groupBy).pipe(distinctUntilChanged((a, b) => {
            const aa = a.flatMap(g => g.expandedHeaders);
            const bb = b.flatMap(g => g.expandedHeaders);
            return aa.length === bb.length && aa.every((k) => bb.includes(k));
        }));
        this.$expandGroups = this.selectSignal(state => state.groupBy, { equal: (a, b) => {
                const aa = a.flatMap(g => g.expandedHeaders);
                const bb = b.flatMap(g => g.expandedHeaders);
                return aa.length === bb.length && aa.every((k) => bb.includes(k));
            } });
        this.$getIsExpanded = (columnKey, groupUniqueName) => {
            return this.selectSignal(state => !!state.groupBy.filter(g => g.key === columnKey && g.expandedHeaders.includes(groupUniqueName)).length);
        };
        this.$currentPage = this.selectSignal(state => state.currentPage);
        this.$pageSize = this.selectSignal(s => s.userDefined?.pageSize || s.pageSize);
        this.$showAll = this.selectSignal(s => s.userDefined?.showAll ?? s.showAll);
        this.$tableSettings = this.selectSignal(state => {
            const ts = { ...state.persistedTableSettings, ...state.notPersistedTableSettings };
            return ts;
        });
        this.$notPersistedTableSettings = this.selectSignal(state => state.notPersistedTableSettings);
        this.tableSettings$ = toObservable(this.$tableSettings);
        this.$props = this.selectSignal(s => s.props);
        this.$getLinkInfo = (md) => this.selectSignal(state => state.linkMaps[md.key]);
        this.$isVirtual = this.selectSignal(state => state.notPersistedTableSettings.useVirtualScroll
            || state.showAll
            || state.userDefined?.showAll);
        this.$viewType = this.selectSignal(state => {
            const usePaginator = state.notPersistedTableSettings.usePaginator;
            const showAll = state.showAll || state.userDefined?.showAll;
            const useVirtualScroll = state.notPersistedTableSettings.useVirtualScroll;
            if (showAll || (useVirtualScroll && !usePaginator)) {
                return 'virtual all';
            }
            else if (useVirtualScroll && usePaginator) {
                return 'virtual paginator';
            }
            else if (usePaginator) {
                return 'paginator';
            }
            else {
                return 'all';
            }
        });
        this.resetState = this.updater((state) => {
            const sorted = this.$preSort();
            return ({ ...state, hiddenKeys: [], sorted, filters: {}, groupBy: [], userDefined: { widths: {}, order: {}, table: {} } });
        });
        this.resetPart = this.updater((state, part) => {
            const newState = { ...state };
            switch (part) {
                case 'Sorting':
                    newState.sorted = this.$preSort();
                    return newState;
                case 'Filters':
                    newState.filters = {};
                    return newState;
                case 'Group By':
                    newState.groupBy = [];
                    return newState;
                case 'Hidden Columns':
                    newState.hiddenKeys = [];
                    return newState;
                case 'Column Widths':
                    newState.userDefined.widths = {};
                    newState.userDefined.table = {};
                    return newState;
                case 'Column Order':
                    newState.userDefined.order = {};
                    return newState;
                case 'Page Size':
                    delete newState.userDefined.pageSize;
                    return newState;
                case 'Show All':
                    delete newState.userDefined.showAll;
                    return newState;
                case 'Row Height':
                    delete newState.userDefined.rowHeight;
                    return newState;
                case 'Header Height':
                    delete newState.userDefined.headerHeight;
                    return newState;
            }
        });
        this.updateStateFromPersistedState = this.updater((state, persistedState) => {
            const incomingTableState = cleanPersistedState(state, persistedState);
            const newState = this.updateStateFunc(state, incomingTableState);
            newState.initializationState = state.initializationState <= InitializationState.MetaDataLoaded ? InitializationState.TableSettingsLoaded : state.initializationState;
            return newState;
        });
        this.updateStateFunc = (state, incomingTableState) => {
            const metaData = state.metaData;
            const sorted = incomingTableState.sorted?.length ? incomingTableState.sorted
                : state.initializationState <= InitializationState.Created ? createPreSort(metaData) : state.sorted;
            return { ...state, ...incomingTableState, metaData, sorted };
        };
        this.setTableSettings = this.updater((state, settings) => {
            const s = {
                ...state,
                persistedTableSettings: state.persistedTableSettings.merge(settings),
                notPersistedTableSettings: state.notPersistedTableSettings.merge(settings),
                initializationState: InitializationState.TableSettingsLoaded
            };
            s.pageSize = settings.tableSettings?.paginatorSettings?.pageSize ?? s.pageSize;
            s.showAll = settings.tableSettings?.paginatorSettings?.defaultAll ?? s.showAll;
            return s;
        });
        this.setMetaData = this.updater((state, md) => {
            const metaData = md
                .reduce((prev, curr) => {
                if (prev[curr.key]) {
                    prev[curr.key] = mergeMeta(prev[curr.key], curr);
                }
                else {
                    prev[curr.key] = curr;
                }
                return prev;
            }, {});
            const sortedInitialized = state.sorted.length > 0;
            const sorted = sortedInitialized ? state.sorted : createPreSort(metaData);
            const order = initializeOrder(state, metaData);
            const initializationState = state.initializationState == InitializationState.Created ? InitializationState.MetaDataLoaded : state.initializationState;
            return { ...state, initializationState, metaData, sorted, userDefined: { ...state.userDefined, order: order } };
        });
        this.showColumn = this.updater((state, key) => ({
            ...state,
            hiddenKeys: state.hiddenKeys.filter(k => k !== key),
        }));
        this.hideColumn = this.updater((state, key) => ({
            ...state,
            hiddenKeys: [...state.hiddenKeys.filter(k => k !== key), key],
        }));
        this.setHiddenColumns = this.updater((state, displayCols) => {
            return ({ ...state, hiddenKeys: displayCols.filter(d => !d.visible).map(d => d.key) });
        });
        this.setUserDefinedWidth = this.updater((state, colWidths) => {
            const userDefinedWidths = { ...state.userDefined.widths };
            colWidths.forEach(cw => {
                userDefinedWidths[cw.key] = cw.widthInPixel;
            });
            return { ...state, userDefined: { ...state.userDefined, widths: userDefinedWidths } };
        });
        this.setUserDefinedOrder = this.updater((state, moved) => {
            const { newOrder, oldOrder } = moved;
            const mdsArr = orderedStateVisibleMetaData(state);
            moveItemInArray(mdsArr, oldOrder, newOrder);
            const userDefinedOrder = mdsArr.reduce((aggregate, current, index) => {
                aggregate[current.key] = index;
                return aggregate;
            }, {});
            return ({ ...state, userDefined: { ...state.userDefined, order: userDefinedOrder } });
        });
        this.setUserDefinedRowHeight = this.updater((state, rowHeight) => {
            return ({ ...state, userDefined: { ...state.userDefined, rowHeight } });
        });
        this.setUserDefinedHeaderHeight = this.updater((state, headerHeight) => {
            return ({ ...state, userDefined: { ...state.userDefined, headerHeight } });
        });
        this.addFilter = this.updater((state, filter) => {
            return this.addFiltersToState(state, [filter]);
        });
        this.addFilters = this.updater((state, filters) => {
            return this.addFiltersToState(state, filters);
        });
        this.removeFilter = this.updater((state, filterId) => {
            const filtersCopy = { ...state.filters };
            delete filtersCopy[filterId];
            return ({ ...state, filters: filtersCopy });
        });
        this.removeFilters = this.updater((state, filterIds) => {
            const filtersCopy = { ...state.filters };
            filterIds.forEach(id => { delete filtersCopy[id]; });
            return ({ ...state, filters: filtersCopy });
        });
        this.clearFilters = this.updater((state) => ({ ...state, filters: {} }));
        this.addFiltersToState = (state, filters) => {
            var customFilters = filters.filter(isCustomFilter);
            var filterInfos = filters.filter(isFilterInfo);
            const filtersObj = filterInfos
                .filter(fltr => Object.keys(state.metaData).some(key => key === fltr.key) || console.warn(`Meta data with key ${fltr.key} not found`))
                .reduce((filtersObj, filter) => {
                if (!filter.filterId) {
                    filter.filterId = crypto.randomUUID();
                }
                filtersObj[filter.filterId] = filter;
                return filtersObj;
            }, {});
            customFilters.forEach(fltr => {
                if (!fltr.filterId) {
                    fltr.filterId = crypto.randomUUID();
                }
                filtersObj[fltr.filterId] = fltr;
            });
            return {
                ...state,
                filters: { ...state.filters, ...filtersObj }
            };
        };
        this.setSort = this.updater((state, { key, direction }) => {
            const sortArray = state.sorted.filter(s => s.active !== key);
            if (direction) {
                sortArray.unshift({ active: key, direction });
            }
            return {
                ...state,
                sorted: sortArray,
            };
        });
        this.setAllSort = this.updater((state, sortArray) => {
            return {
                ...state,
                sorted: sortArray,
            };
        });
        this.setCurrentPage = this.updater((state, currentPage) => ({ ...state, currentPage }));
        this.setPageSize = this.updater((state, pageSize) => ({ ...state, pageSize }));
        this.setUserDefinedPageSize = this.updater((state, pageSize) => ({ ...state, userDefined: { ...state.userDefined, pageSize } }));
        this.setUserDefinedShowAll = this.updater((state, showAll) => ({ ...state, showAll, userDefined: { ...state.userDefined, showAll } }));
        this.setProps = this.updater((state, props) => {
            return ({ ...state, props });
        });
        this.setTableWidth = this.updater((state, widthInPixels) => ({ ...state, userDefined: { ...state.userDefined, table: { width: widthInPixels } } }));
        this.setInitializationState = this.updater((state, initializationState) => {
            return { ...state, initializationState };
        });
        this.toggleCollapseHeader = this.updater((state) => {
            const tableSettings = { ...state.persistedTableSettings };
            tableSettings.collapseHeader = !tableSettings.collapseHeader;
            return ({ ...state, persistedTableSettings: new PersistedTableSettings(tableSettings) });
        });
        this.toggleCollapseFooter = this.updater((state, options) => {
            const tableSettings = { ...state.persistedTableSettings };
            tableSettings.collapseFooter = options?.collapseFooter ?? !tableSettings.collapseFooter;
            return ({ ...state, persistedTableSettings: new PersistedTableSettings(tableSettings) });
        });
        this.addGroupByKey = this.updater((state, metaDataKey) => ({
            ...state,
            groupBy: [...state.groupBy, { key: metaDataKey, expandedHeaders: [] }]
        }));
        this.removeGroupByKey = this.updater((state, groupByKey) => ({
            ...state,
            groupBy: state.groupBy.filter(key => groupByKey !== key.key)
        }));
        this.updateExpandedGroups = this.updater((state, data) => {
            const gbk = replaceInArrayWithClone(state.groupBy, k => k.key === data.key, gk => {
                gk.expandedHeaders = data.isExpanded ? [...gk.expandedHeaders, data.groupUniqueName] : gk.expandedHeaders.filter(g => g !== data.groupUniqueName);
            });
            return ({
                ...state,
                groupBy: gbk
            });
        });
        this.expandAllOfGroup = this.updater((state, data) => {
            const newGroupedData = state.groupBy.map(gb => ({
                key: gb.key,
                expandedHeaders: data.groupHeadersByKey[gb.key]?.map(g => g.uniqueName) ?? gb.expandedHeaders
            }));
            return ({ ...state, groupBy: newGroupedData });
        });
        this.collapseAll = this.updater((state) => ({
            ...state,
            groupBy: state.groupBy.map(gb => ({ key: gb.key, expandedHeaders: [] }))
        }));
        this.collapseAllOfKey = this.updater((state, data) => ({
            ...state,
            groupBy: state.groupBy.map(gb => ({
                key: gb.key,
                expandedHeaders: data.keys.includes(gb.key) ? [] : gb.expandedHeaders
            }))
        }));
        this.setLinkMaps = this.updater((state, maps) => {
            return ({ ...state, linkMaps: maps });
        });
        this.updateRowProps = this.updater((state, updates) => {
            const notPersistedTableSettings = merge$1(new NotPersistedTableSettings(), (state.notPersistedTableSettings));
            if (updates.rowClasses)
                notPersistedTableSettings.rowClasses = updates.rowClasses;
            if (updates.rowClick)
                notPersistedTableSettings.rowClick = updates.rowClick;
            if (updates.rowStyles)
                notPersistedTableSettings.rowStyles = updates.rowStyles;
            return ({ ...state, notPersistedTableSettings });
        });
        this.on = (srcObservable, func) => {
            this.effect(() => srcObservable.pipe(tap(func)));
            return this;
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableStore, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableStore }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableStore, decorators: [{
            type: Injectable
        }], ctorParameters: () => [] });
const resetable = [
    'Sorting',
    'Filters',
    'Group By',
    'Hidden Columns',
    'Column Widths',
    'Column Order',
    'Row Height',
    'Header Height',
    'Page Size',
    'Show All',
];

class MultiSortDirective extends MatSort {
    constructor() {
        super();
        this.state = inject(TableStore);
        this.state.setSort(this.sortChange.pipe(distinctUntilChanged((f, s) => f.active === s.active && f.direction === s.direction), map(sc => ({ key: sc.active, direction: sc.direction }))));
        this.state.on(this.state.sort$, (rules) => {
            const topRule = { active: rules[0]?.active || '', direction: rules[0]?.direction || '' };
            const topActiveChanged = topRule.active !== this.active || '';
            const topDirectionChanged = topRule.direction !== this.direction || '';
            if (topActiveChanged || topDirectionChanged) {
                this.active = topRule.active;
                this.direction = topRule.direction;
                this.sortChange.emit(topRule);
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MultiSortDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MultiSortDirective, isStandalone: true, selector: "[multiSort]", inputs: { disabled: ["matSortDisabled", "disabled"] }, providers: [
            { provide: MatSort, useExisting: MultiSortDirective }
        ], exportAs: ["multiSort"], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MultiSortDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[multiSort]',
                    exportAs: 'multiSort',
                    inputs: ['disabled: matSortDisabled'],
                    providers: [
                        { provide: MatSort, useExisting: MultiSortDirective }
                    ],
                }]
        }], ctorParameters: () => [] });
function sortsAreSame(a, b) {
    if (a.length !== b.length) {
        return false;
    }
    for (let i = 0; i < a.length; i++) {
        if (a[i].active !== b[i].active || a[i].direction !== b[i].direction) {
            return false;
        }
    }
    return true;
}

class DateFilterComponent {
    constructor() {
        this.FilterType = FilterType;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DateFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: DateFilterComponent, isStandalone: true, selector: "tb-date-filter", inputs: { info: "info", CurrentFilterType: "CurrentFilterType" }, ngImport: i0, template: "@if (CurrentFilterType !== FilterType.DateBetween && CurrentFilterType !== FilterType.IsNull)\r\n{\r\n  <mat-form-field>\r\n    <input matInput name=\"filterValue\" [ngModel]=\"info.filterValue\" [matDatepicker]=\"cal\"/>\r\n    <mat-datepicker-toggle class=\"small-button date-toggle\" matSuffix preventEnter [for]=\"cal\" />\r\n    <mat-datepicker #cal />\r\n  </mat-form-field>\r\n}\r\n@if(CurrentFilterType === FilterType.DateBetween)\r\n{\r\n  <ng-container ngModelGroup=\"filterValue\">\r\n    <mat-form-field class=\"my-filter\" >\r\n      <input matInput name=\"Start\" placeholder=\"From\"  [ngModel]=\"info.filterValue?.Start\" [matDatepicker]=\"fromVal\"\r\n          (click)=\"fromVal.open()\"/>\r\n      <mat-datepicker-toggle matSuffix class=\"small-button date-toggle\" preventEnter [for]=\"fromVal\" />\r\n      <mat-datepicker #fromVal />\r\n    </mat-form-field>\r\n    <mat-form-field>\r\n      <input matInput name=\"End\" placeholder=\"To\"  [ngModel]=\"info.filterValue?.End\" [matDatepicker]=\"toVal\" (click)=\"toVal.open()\"/>\r\n      <mat-datepicker-toggle matSuffix class=\"small-button date-toggle\" preventEnter [for]=\"toVal\" />\r\n      <mat-datepicker #toVal />\r\n    </mat-form-field>\r\n  </ng-container>\r\n}\r\n\r\n", styles: [".filter-name{color:var(tb-filter-name);margin:10px 0;font-weight:600;display:inline-block}.switch{display:inline-block}.head-row{display:flex;width:100%;align-items:center;justify-content:space-between}.filter-row{display:flex;align-items:center;gap:1rem}mat-card.filter-card::ng-deep mat-form-field{width:150px}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.inline{display:inline-block}.small-button{height:18px;width:18px;font-size:18px;padding:0;margin:0}.small-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.cancel-button{font-weight:700}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"], dependencies: [{ kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i1$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i1$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i2.NgModelGroup, selector: "[ngModelGroup]", inputs: ["ngModelGroup"], exportAs: ["ngModelGroup"] }, { kind: "ngmodule", type: MatDatepickerModule }, { kind: "component", type: i3.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i3.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: i3.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }], viewProviders: [{ provide: ControlContainer, useExisting: NgForm }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DateFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-date-filter', changeDetection: ChangeDetectionStrategy.OnPush, viewProviders: [{ provide: ControlContainer, useExisting: NgForm }], imports: [
                        MatInputModule, FormsModule, MatDatepickerModule
                    ], template: "@if (CurrentFilterType !== FilterType.DateBetween && CurrentFilterType !== FilterType.IsNull)\r\n{\r\n  <mat-form-field>\r\n    <input matInput name=\"filterValue\" [ngModel]=\"info.filterValue\" [matDatepicker]=\"cal\"/>\r\n    <mat-datepicker-toggle class=\"small-button date-toggle\" matSuffix preventEnter [for]=\"cal\" />\r\n    <mat-datepicker #cal />\r\n  </mat-form-field>\r\n}\r\n@if(CurrentFilterType === FilterType.DateBetween)\r\n{\r\n  <ng-container ngModelGroup=\"filterValue\">\r\n    <mat-form-field class=\"my-filter\" >\r\n      <input matInput name=\"Start\" placeholder=\"From\"  [ngModel]=\"info.filterValue?.Start\" [matDatepicker]=\"fromVal\"\r\n          (click)=\"fromVal.open()\"/>\r\n      <mat-datepicker-toggle matSuffix class=\"small-button date-toggle\" preventEnter [for]=\"fromVal\" />\r\n      <mat-datepicker #fromVal />\r\n    </mat-form-field>\r\n    <mat-form-field>\r\n      <input matInput name=\"End\" placeholder=\"To\"  [ngModel]=\"info.filterValue?.End\" [matDatepicker]=\"toVal\" (click)=\"toVal.open()\"/>\r\n      <mat-datepicker-toggle matSuffix class=\"small-button date-toggle\" preventEnter [for]=\"toVal\" />\r\n      <mat-datepicker #toVal />\r\n    </mat-form-field>\r\n  </ng-container>\r\n}\r\n\r\n", styles: [".filter-name{color:var(tb-filter-name);margin:10px 0;font-weight:600;display:inline-block}.switch{display:inline-block}.head-row{display:flex;width:100%;align-items:center;justify-content:space-between}.filter-row{display:flex;align-items:center;gap:1rem}mat-card.filter-card::ng-deep mat-form-field{width:150px}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.inline{display:inline-block}.small-button{height:18px;width:18px;font-size:18px;padding:0;margin:0}.small-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.cancel-button{font-weight:700}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"] }]
        }], propDecorators: { info: [{
                type: Input
            }], CurrentFilterType: [{
                type: Input
            }] } });

class PreventEnterDirective {
    onKeyDown() {
        return false;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: PreventEnterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: PreventEnterDirective, isStandalone: true, selector: "preventEnter", host: { listeners: { "keydown.enter": "onKeyDown($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: PreventEnterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'preventEnter',
                }]
        }], propDecorators: { onKeyDown: [{
                type: HostListener,
                args: ['keydown.enter', ['$event']]
            }] } });

class StopPropagationDirective {
    onClick(event) {
        event.stopPropagation();
    }
    onMousedown(event) {
        event.stopPropagation();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: StopPropagationDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: StopPropagationDirective, isStandalone: true, selector: "[stop-propagation]", host: { listeners: { "click": "onClick($event)", "mousedown": "onMousedown($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: StopPropagationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[stop-propagation]",
                }]
        }], propDecorators: { onClick: [{
                type: HostListener,
                args: ["click", ["$event"]]
            }], onMousedown: [{
                type: HostListener,
                args: ["mousedown", ["$event"]]
            }] } });

class AutoFocusDirective {
    constructor() {
        this.elementRef = inject(ElementRef);
        this.autoFocus = true;
    }
    ngAfterViewInit() {
        if (this.autoFocus) {
            setTimeout(() => {
                this.elementRef.nativeElement.focus();
            });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: AutoFocusDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: AutoFocusDirective, isStandalone: true, selector: "[autoFocus]", inputs: { autoFocus: "autoFocus" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: AutoFocusDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[autoFocus]',
                }]
        }], propDecorators: { autoFocus: [{
                type: Input
            }] } });

class ClickSubjectDirective extends Subject {
    constructor() {
        super();
    }
    set clickSubject(val) {
        this._val = val;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ClickSubjectDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: ClickSubjectDirective, isStandalone: true, selector: "[clickSubject]", inputs: { clickSubject: "clickSubject" }, host: { listeners: { "click": "next(this._val)" } }, exportAs: ["clickSubject"], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ClickSubjectDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[clickSubject]',
                    exportAs: 'clickSubject',
                    host: {
                        '(click)': 'next(this._val)'
                    },
                }]
        }], ctorParameters: () => [], propDecorators: { clickSubject: [{
                type: Input,
                args: ['clickSubject']
            }] } });

class ClickEmitterDirective extends Subject {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ClickEmitterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: ClickEmitterDirective, isStandalone: true, selector: "[clickEmitter]", host: { listeners: { "click": "next(true)" } }, exportAs: ["clickEmitter"], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ClickEmitterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[clickEmitter]',
                    exportAs: 'clickEmitter',
                    host: {
                        '(click)': 'next(true)'
                    },
                }]
        }], ctorParameters: () => [] });

class DialogService {
    constructor() {
        this.allOpenOpDialogs = [];
    }
    addDialogRef(ref) {
        this.allOpenOpDialogs.push(ref);
    }
    removeDialogRef(ref) {
        this.allOpenOpDialogs = this.allOpenOpDialogs.filter(rf => ref.id !== rf.id);
    }
    closeAllOpDialogs() {
        this.allOpenOpDialogs.forEach(ref => ref.close());
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class DialogWrapper {
    constructor() {
        this.vcr = inject(ViewContainerRef);
        this.viewEmbedded = false;
        this.viewContext = {
            close: () => { },
        };
    }
    set template(tmpl) {
        if (this.viewEmbedded) {
            this.vcr.clear();
        }
        this.viewEmbedded = true;
        this.vcr.createEmbeddedView(tmpl, this.viewContext);
    }
    set close(closeMethod) {
        this.viewContext.close = closeMethod;
    }
    set data(value) {
        this.viewContext.$implicit = value;
        this.viewContext.opDialog = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogWrapper, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.3", type: DialogWrapper, isStandalone: true, selector: "dialog-wrapper", ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogWrapper, decorators: [{
            type: Component,
            args: [{
                    selector: 'dialog-wrapper',
                    template: ``,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }] });
const defaultDialogConfig = {
    maxHeight: '95vh',
};
class DialogDirective {
    constructor() {
        this.templateRef = inject(TemplateRef);
        this.dialog = inject(MatDialog);
        this.dialogConfig = inject(MAT_DIALOG_DEFAULT_OPTIONS, { optional: true }) || {};
        this.service = inject(DialogService);
        this.opDialogClosed = new EventEmitter();
        this._dialogConfig = { ...this.dialogConfig, ...defaultDialogConfig };
        this.opDialogAddDialogClass = true;
        this.injector = inject(Injector);
        this.subscriber = subscriber(this.injector);
        this._data = new Subject();
        this.setDataAndState = (data) => {
            if (data) {
                this.opDialogConfig.data = data;
                this.setDialogState(true);
            }
            else {
                this.setDialogState(false);
            }
        };
    }
    set opDialogConfig(config) {
        this._dialogConfig = { ...this.dialogConfig, ...defaultDialogConfig, ...config };
    }
    get opDialogConfig() {
        return this._dialogConfig;
    }
    set setControl(i) {
        let o;
        if (isSignal(i)) {
            o = toObservable(i, { injector: this.injector });
        }
        else {
            o = i;
        }
        untracked(() => {
            this.subscriber.on(o, this.setDataAndState);
        });
    }
    close() {
        this.dialogRef?.close();
    }
    initDialog() {
        if (this.nativeElement) {
            const rect = this.nativeElement.getBoundingClientRect();
            const position = { left: `${rect.left}px`, top: `${rect.bottom - 50}px` };
            this.opDialogConfig = { ...this.opDialogConfig, position };
        }
        if (this.opDialogAddDialogClass) {
            this.opDialogConfig.panelClass = [...(Array.isArray(this.opDialogConfig.panelClass) ? this.opDialogConfig.panelClass : this.opDialogConfig.panelClass ? [this.opDialogConfig.panelClass] : []), 'opDialog'];
        }
        this.dialogRef = this.dialog.open(DialogWrapper, this.opDialogConfig);
        this.componentWrapper = this.dialogRef.componentInstance;
        this.componentWrapper.close = () => this.dialogRef?.close();
        this.componentWrapper.data = this.opDialogConfig.data;
        this.componentWrapper.template = this.templateRef;
        if (!this.opDialogConfig.disableClose) {
            this.service.addDialogRef(this.dialogRef);
        }
        const sub = this.dialogRef.afterClosed().subscribe(() => {
            this.opDialogClosed.emit(true);
            this.service.removeDialogRef(this.dialogRef);
            this.dialogRef = undefined;
            sub.unsubscribe();
        });
    }
    setDialogState(open) {
        if (open) {
            if (!this.dialogRef) {
                this.initDialog();
            }
            else {
                this.componentWrapper.data = this.opDialogConfig.data;
            }
        }
        else if (!open && this.dialogRef) {
            this.dialogRef.close();
        }
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: DialogDirective, isStandalone: true, selector: "[opDialog]", inputs: { opDialogAddDialogClass: "opDialogAddDialogClass", opDialogConfig: "opDialogConfig", setControl: ["opDialog", "setControl"], nativeElement: ["opDialogOrigin", "nativeElement"] }, outputs: { opDialogClosed: "opDialogClosed" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DialogDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[opDialog]', }]
        }], propDecorators: { opDialogClosed: [{
                type: Output
            }], opDialogAddDialogClass: [{
                type: Input
            }], opDialogConfig: [{
                type: Input
            }], setControl: [{
                type: Input,
                args: ['opDialog']
            }], nativeElement: [{
                type: Input,
                args: ['opDialogOrigin']
            }] } });

class StylerDirective {
    constructor() {
        this.el = inject(ElementRef);
        this.renderer = inject(Renderer2);
        this.$stylesApplied = signal({});
        this.$element = input.required({ alias: 'element' });
        this.$styler = input.required({ alias: 'styler' });
        this.#stylerEffect = effect(() => {
            const styles = this.$styler();
            untracked(() => {
                const element = this.$element();
                const toApply = Object.entries(styles ?? {}).reduce((acc, [key, val]) => {
                    if (!val)
                        return acc;
                    if (typeof (val) === 'string') {
                        acc[key] = val;
                        this.el.nativeElement.style[key] = val;
                    }
                    else if (!val?.condition || val?.condition === true || val?.condition(element)) {
                        const value = typeof (val.value) === 'string' ? val.value : val?.value(element);
                        acc[key] = value;
                        this.el.nativeElement.style[key] = value;
                    }
                    return acc;
                }, {});
                Object.keys(this.$stylesApplied()).filter(key => !Object.keys(toApply).includes(key)).forEach(key => {
                    this.renderer.removeStyle(this.el.nativeElement, key);
                });
                this.$stylesApplied.set(toApply);
            });
        });
    }
    #stylerEffect;
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: StylerDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.3", type: StylerDirective, isStandalone: true, selector: "[styler]", inputs: { $element: { classPropertyName: "$element", publicName: "element", isSignal: true, isRequired: true, transformFunction: null }, $styler: { classPropertyName: "$styler", publicName: "styler", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: StylerDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[styler]' }]
        }] });

class MatSlideToggleGroupDirective {
    constructor() {
        this.allowMultiple = false;
        this._ready = new ReplaySubject(1);
    }
    set toggles(val) {
        this._toggles = val;
        this._ready.next(true);
    }
    get valueEmitter() {
        return this._ready.pipe(switchMap$1(_ => this.getObs()));
    }
    getInitValue() {
        const startValue = this._toggles.reduce((prev, cur) => {
            if (!cur.name) {
                throw new Error('toggle must have the name attribute set');
            }
            prev[cur.name] = cur.checked;
            return prev;
        }, {});
        return startValue;
    }
    getObs() {
        var toggleChanges = merge(...this._toggles.map(toggle => toggle.change));
        const startValue = this.getInitValue();
        return toggleChanges.pipe(scan((prev, cur) => {
            const toggleName = cur.source.name;
            const newVal = { ...prev, [toggleName]: cur.checked };
            if (cur.checked && !this.allowMultiple) {
                Object.keys(prev)
                    .filter(key => key !== toggleName && prev[key])
                    .forEach(key => {
                    newVal[key] = false;
                    this._toggles.find(toggle => toggle.name === key).toggle();
                });
            }
            return newVal;
        }, startValue), startWith$1(startValue));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatSlideToggleGroupDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: MatSlideToggleGroupDirective, isStandalone: true, selector: "[opMatSlideToggleGroup]", inputs: { allowMultiple: "allowMultiple" }, outputs: { valueEmitter: "valueEmitter" }, queries: [{ propertyName: "toggles", predicate: MatSlideToggle }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: MatSlideToggleGroupDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[opMatSlideToggleGroup]',
                }]
        }], propDecorators: { allowMultiple: [{
                type: Input
            }], toggles: [{
                type: ContentChildren,
                args: [MatSlideToggle]
            }], valueEmitter: [{
                type: Output
            }] } });

class TrimWhitespaceDirective {
    constructor() {
        this.elem = inject(ElementRef);
    }
    onBlur() {
        const inputString = this.elem.nativeElement.value;
        if (inputString) {
            const newValue = inputString.trim().replace(/\t/g, '');
            if (inputString !== newValue) {
                this.elem.nativeElement.value = newValue;
                this.elem.nativeElement.dispatchEvent(new Event('input', { bubbles: true }));
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TrimWhitespaceDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "20.0.3", type: TrimWhitespaceDirective, isStandalone: true, selector: "input[trimWhitespace]", host: { listeners: { "blur": "onBlur()" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TrimWhitespaceDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[trimWhitespace]',
                }]
        }], propDecorators: { onBlur: [{
                type: HostListener,
                args: ['blur']
            }] } });

class FunctionPipe {
    transform(func, ...args) {
        if (typeof func === 'string') {
            const [instance, ...tail] = args;
            const method = instance[func].bind(instance);
            return method(...tail);
        }
        return func(...args);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FunctionPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: FunctionPipe, isStandalone: true, name: "func" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FunctionPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'func',
                }]
        }] });

class ConditionalClassesDirective {
    constructor() {
        this.el = inject(ElementRef);
        this.renderer = inject(Renderer2);
        this.$element = input.required({ alias: 'element' });
        this.$classes = input(undefined, { alias: 'conditionalClasses' });
        this.classesApplied = [];
        this.#onClasses = effect(() => {
            const classes = this.$classes();
            untracked(() => {
                const element = this.$element();
                let toApply = [];
                if (classes) {
                    toApply = Object.keys(classes)
                        .filter(key => (classes[key] === true) || classes[key](element));
                }
                var classesNotYetApplied = toApply.filter(c => !this.classesApplied.includes(c));
                var classesToRemove = this.classesApplied.filter(c => !toApply.includes(c));
                classesToRemove.forEach(c => this.renderer.removeClass(this.el.nativeElement, c));
                classesNotYetApplied.forEach(c => this.renderer.addClass(this.el.nativeElement, c));
                this.classesApplied = toApply;
            });
        });
    }
    #onClasses;
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ConditionalClassesDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "17.1.0", version: "20.0.3", type: ConditionalClassesDirective, isStandalone: true, selector: "[conditionalClasses]", inputs: { $element: { classPropertyName: "$element", publicName: "element", isSignal: true, isRequired: true, transformFunction: null }, $classes: { classPropertyName: "$classes", publicName: "conditionalClasses", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ConditionalClassesDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[conditionalClasses]',
                }]
        }] });

class UtilitiesModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: UtilitiesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: UtilitiesModule, imports: [SpaceCasePipe,
            PhoneNumberPipe,
            FunctionPipe,
            StopPropagationDirective,
            StylerDirective,
            PreventEnterDirective,
            AutoFocusDirective,
            TrimWhitespaceDirective,
            ClickSubjectDirective,
            ClickEmitterDirective,
            DialogDirective,
            MatSlideToggleGroupDirective,
            ConditionalClassesDirective], exports: [StopPropagationDirective,
            PreventEnterDirective,
            SpaceCasePipe,
            PhoneNumberPipe,
            FunctionPipe,
            TrimWhitespaceDirective,
            StylerDirective,
            AutoFocusDirective,
            ClickSubjectDirective,
            ClickEmitterDirective,
            DialogDirective,
            MatSlideToggleGroupDirective,
            ConditionalClassesDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: UtilitiesModule, providers: [
            DialogService
        ] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: UtilitiesModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [
                        StopPropagationDirective,
                        PreventEnterDirective,
                        SpaceCasePipe,
                        PhoneNumberPipe,
                        FunctionPipe,
                        TrimWhitespaceDirective,
                        StylerDirective,
                        AutoFocusDirective,
                        ClickSubjectDirective,
                        ClickEmitterDirective,
                        DialogDirective,
                        MatSlideToggleGroupDirective,
                        ConditionalClassesDirective,
                    ],
                    imports: [
                        SpaceCasePipe,
                        PhoneNumberPipe,
                        FunctionPipe,
                        StopPropagationDirective,
                        StylerDirective,
                        PreventEnterDirective,
                        AutoFocusDirective,
                        TrimWhitespaceDirective,
                        ClickSubjectDirective,
                        ClickEmitterDirective,
                        DialogDirective,
                        MatSlideToggleGroupDirective,
                        ConditionalClassesDirective,
                    ],
                    providers: [
                        DialogService
                    ]
                }]
        }] });

class InFilterComponent {
    constructor() {
        this.ref = inject(ChangeDetectorRef);
        this.FieldType = FieldType;
        this.$type = input.required({ alias: 'type' });
        this.value = [undefined];
        this.onChange = (_) => { };
        this.onTouched = () => { };
        this.value = [undefined];
    }
    writeValue(obj) {
        if (!obj?.length)
            obj = [undefined];
        this.value = obj;
        this.ref.markForCheck();
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    addInput() {
        this.value = [...this.value, undefined];
        this.ref.markForCheck();
        this.onChange(this.value);
    }
    removeInput(index) {
        this.value = [...this.value];
        this.value.splice(index, 1);
        this.ref.markForCheck();
        this.onChange(this.value);
    }
    onValueChange(i, value) {
        this.value = [...this.value];
        this.value[i] = value;
        this.ref.markForCheck();
        this.onChange(this.value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: InFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: InFilterComponent, isStandalone: true, selector: "lib-in-filter", inputs: { $type: { classPropertyName: "$type", publicName: "type", isSignal: true, isRequired: true, transformFunction: null } }, providers: [{
                provide: NG_VALUE_ACCESSOR,
                useExisting: InFilterComponent,
                multi: true
            }], ngImport: i0, template: "<div class=inline>\r\n  @for (val of value; track $index)\r\n  {\r\n    <div>\r\n      @if($type() === FieldType.Number || $type() === FieldType.Currency)\r\n      {\r\n        <input type=\"number\" [ngModel]=\"val\"\r\n        [readonly]=\"$index + 1 < value.length\" [ngModelOptions]=\"{standalone:true}\" [autoFocus]=\"$index === value.length - 1\" (ngModelChange)=\"onValueChange($index, $event)\"/>\r\n      }\r\n      @else\r\n      {\r\n        <input #input type=\"string\"\r\n        [ngModel]=\"val\" [readonly]=\"$index + 1 < value.length\" [ngModelOptions]=\"{standalone:true}\"\r\n        [autoFocus]=\"$index === value.length - 1\" (ngModelChange)=\"onValueChange($index ,$event)\" />\r\n      }\r\n    </div>\r\n    <button [disabled]=\"value.length <= 1\" (click)=\"removeInput($index)\">-</button>\r\n    @if ($index === value.length - 1)\r\n    {\r\n      <button [disabled]=\"val == undefined || val === ''\" (click)=\"addInput()\">+</button>\r\n    }\r\n  }\r\n</div>\r\n", styles: [".inline{display:inline-block}\n"], dependencies: [{ kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: AutoFocusDirective, selector: "[autoFocus]", inputs: ["autoFocus"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: InFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-in-filter', changeDetection: ChangeDetectionStrategy.OnPush, providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: InFilterComponent,
                            multi: true
                        }], imports: [
                        FormsModule, AutoFocusDirective
                    ], template: "<div class=inline>\r\n  @for (val of value; track $index)\r\n  {\r\n    <div>\r\n      @if($type() === FieldType.Number || $type() === FieldType.Currency)\r\n      {\r\n        <input type=\"number\" [ngModel]=\"val\"\r\n        [readonly]=\"$index + 1 < value.length\" [ngModelOptions]=\"{standalone:true}\" [autoFocus]=\"$index === value.length - 1\" (ngModelChange)=\"onValueChange($index, $event)\"/>\r\n      }\r\n      @else\r\n      {\r\n        <input #input type=\"string\"\r\n        [ngModel]=\"val\" [readonly]=\"$index + 1 < value.length\" [ngModelOptions]=\"{standalone:true}\"\r\n        [autoFocus]=\"$index === value.length - 1\" (ngModelChange)=\"onValueChange($index ,$event)\" />\r\n      }\r\n    </div>\r\n    <button [disabled]=\"value.length <= 1\" (click)=\"removeInput($index)\">-</button>\r\n    @if ($index === value.length - 1)\r\n    {\r\n      <button [disabled]=\"val == undefined || val === ''\" (click)=\"addInput()\">+</button>\r\n    }\r\n  }\r\n</div>\r\n", styles: [".inline{display:inline-block}\n"] }]
        }], ctorParameters: () => [] });

class NumberFilterComponent {
    constructor() {
        this.FilterType = FilterType;
        this.FieldType = FieldType;
        this.$currentFilterType = input.required({ alias: 'CurrentFilterType' });
        this.$info = input.required({ alias: 'info' });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: NumberFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: NumberFilterComponent, isStandalone: true, selector: "tb-number-filter", inputs: { $currentFilterType: { classPropertyName: "$currentFilterType", publicName: "CurrentFilterType", isSignal: true, isRequired: true, transformFunction: null }, $info: { classPropertyName: "$info", publicName: "info", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: "@let CurrentFilterType = $currentFilterType();\r\n@let info = $info();\r\n\r\n@if(CurrentFilterType !== FilterType.NumberBetween && CurrentFilterType !== FilterType.IsNull && CurrentFilterType !== FilterType.In)\r\n{\r\n  <mat-form-field class=\"my-filter\">\r\n    <input matInput name=\"filterValue\" type=\"number\" [ngModel]=\"info.filterValue\"/>\r\n  </mat-form-field>\r\n}\r\n@if(CurrentFilterType === FilterType.NumberBetween)\r\n{\r\n  <ng-container ngModelGroup=\"filterValue\"  >\r\n    <mat-form-field class=\"my-filter\">\r\n      <input matInput name=\"Start\" placeholder=\"Start\" type=\"number\" [ngModel]=\"info.filterValue?.Start\"/>\r\n    </mat-form-field>\r\n    <mat-form-field class=\"my-filter\">\r\n      <input matInput name=\"End\" placeholder=\"End\" type=\"number\" [ngModel]=\"info.filterValue?.End\"/>\r\n    </mat-form-field>\r\n  </ng-container>\r\n}\r\n\r\n@if (CurrentFilterType === FilterType.In)\r\n{\r\n  <lib-in-filter name='filterValue' [type]=\"FieldType.Number\" [(ngModel)]='info.filterValue' />\r\n}\r\n", styles: [".switch{display:inline-block}.my-filter{margin-right:15px}.inline{display:inline-block}\n"], dependencies: [{ kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i1$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i2.NgModelGroup, selector: "[ngModelGroup]", inputs: ["ngModelGroup"], exportAs: ["ngModelGroup"] }, { kind: "component", type: InFilterComponent, selector: "lib-in-filter", inputs: ["type"] }], viewProviders: [{ provide: ControlContainer, useExisting: NgForm }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: NumberFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-number-filter', changeDetection: ChangeDetectionStrategy.OnPush, viewProviders: [{ provide: ControlContainer, useExisting: NgForm }], imports: [
                        MatInputModule, FormsModule, InFilterComponent
                    ], template: "@let CurrentFilterType = $currentFilterType();\r\n@let info = $info();\r\n\r\n@if(CurrentFilterType !== FilterType.NumberBetween && CurrentFilterType !== FilterType.IsNull && CurrentFilterType !== FilterType.In)\r\n{\r\n  <mat-form-field class=\"my-filter\">\r\n    <input matInput name=\"filterValue\" type=\"number\" [ngModel]=\"info.filterValue\"/>\r\n  </mat-form-field>\r\n}\r\n@if(CurrentFilterType === FilterType.NumberBetween)\r\n{\r\n  <ng-container ngModelGroup=\"filterValue\"  >\r\n    <mat-form-field class=\"my-filter\">\r\n      <input matInput name=\"Start\" placeholder=\"Start\" type=\"number\" [ngModel]=\"info.filterValue?.Start\"/>\r\n    </mat-form-field>\r\n    <mat-form-field class=\"my-filter\">\r\n      <input matInput name=\"End\" placeholder=\"End\" type=\"number\" [ngModel]=\"info.filterValue?.End\"/>\r\n    </mat-form-field>\r\n  </ng-container>\r\n}\r\n\r\n@if (CurrentFilterType === FilterType.In)\r\n{\r\n  <lib-in-filter name='filterValue' [type]=\"FieldType.Number\" [(ngModel)]='info.filterValue' />\r\n}\r\n", styles: [".switch{display:inline-block}.my-filter{margin-right:15px}.inline{display:inline-block}\n"] }]
        }] });

class DateTimeFilterComponent {
    constructor() {
        this.FilterType = FilterType;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DateTimeFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: DateTimeFilterComponent, isStandalone: true, selector: "tb-date-time-filter", inputs: { info: "info", CurrentFilterType: "CurrentFilterType" }, ngImport: i0, template: "@if(CurrentFilterType !== FilterType.DateTimeBetween && CurrentFilterType !== FilterType.IsNull)\r\n{\r\n  <input type=\"datetime-local\" preventEnter name=\"filterValue\" class=\"op-date-time-input\" [ngModel]=\"info.filterValue\"/>\r\n}\r\n@if(CurrentFilterType === FilterType.DateTimeBetween)\r\n{\r\n  <ng-container ngModelGroup=\"filterValue\">\r\n    <input type=\"datetime-local\" preventEnter name=\"Start\" class=\"op-date-time-input\" [ngModel]=\"info.filterValue?.Start\"/>\r\n    <input type=\"datetime-local\" preventEnter name=\"End\" class=\"op-date-time-input\" [ngModel]=\"info.filterValue?.End\"/>\r\n  </ng-container>\r\n}", styles: [".filter-name{color:var(tb-filter-name);margin:10px 0;font-weight:600;display:inline-block}.switch{display:inline-block}.head-row{display:flex;width:100%;align-items:center;justify-content:space-between}.filter-row{display:flex;align-items:center;gap:1rem}mat-card.filter-card::ng-deep mat-form-field{width:150px}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.inline{display:inline-block}.small-button{height:18px;width:18px;font-size:18px;padding:0;margin:0}.small-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.cancel-button{font-weight:700}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"], dependencies: [{ kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i2.NgModelGroup, selector: "[ngModelGroup]", inputs: ["ngModelGroup"], exportAs: ["ngModelGroup"] }], viewProviders: [{ provide: ControlContainer, useExisting: NgForm }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DateTimeFilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-date-time-filter', changeDetection: ChangeDetectionStrategy.OnPush, viewProviders: [{ provide: ControlContainer, useExisting: NgForm }], imports: [
                        FormsModule
                    ], template: "@if(CurrentFilterType !== FilterType.DateTimeBetween && CurrentFilterType !== FilterType.IsNull)\r\n{\r\n  <input type=\"datetime-local\" preventEnter name=\"filterValue\" class=\"op-date-time-input\" [ngModel]=\"info.filterValue\"/>\r\n}\r\n@if(CurrentFilterType === FilterType.DateTimeBetween)\r\n{\r\n  <ng-container ngModelGroup=\"filterValue\">\r\n    <input type=\"datetime-local\" preventEnter name=\"Start\" class=\"op-date-time-input\" [ngModel]=\"info.filterValue?.Start\"/>\r\n    <input type=\"datetime-local\" preventEnter name=\"End\" class=\"op-date-time-input\" [ngModel]=\"info.filterValue?.End\"/>\r\n  </ng-container>\r\n}", styles: [".filter-name{color:var(tb-filter-name);margin:10px 0;font-weight:600;display:inline-block}.switch{display:inline-block}.head-row{display:flex;width:100%;align-items:center;justify-content:space-between}.filter-row{display:flex;align-items:center;gap:1rem}mat-card.filter-card::ng-deep mat-form-field{width:150px}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.inline{display:inline-block}.small-button{height:18px;width:18px;font-size:18px;padding:0;margin:0}.small-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.cancel-button{font-weight:700}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"] }]
        }], propDecorators: { info: [{
                type: Input
            }], CurrentFilterType: [{
                type: Input
            }] } });

class InListFilterComponent {
    constructor() {
        this.ref = inject(ChangeDetectorRef);
        this.tableState = inject(TableStore);
        this.$values = input([], { alias: 'values' });
        this.#e = effect(() => this.writeValue(this.$values()));
        this.value = [];
        this.FieldType = FieldType;
        this.includes = (value, values) => {
            return values.map(item => this.getValue(this.$metaData().fieldType, item)).includes(this.getValue(this.$metaData().fieldType, value));
        };
        this.onChange = (_) => { };
        this.onTouched = () => { };
        this.$key = input.required({ alias: 'key' });
        this.$selectedKeys = signal([]);
        this.$metaData = computed(() => this.tableState.$getMetaData(this.$key())());
        this.$keyValues = computed(() => {
            const metaData = this.$metaData();
            if (metaData?.additional?.filterOptions?.filterableValues === 'all values') {
                return this.tableState.selectSignal(s => s.allFilters)()[metaData.key].map(f => ({ key: f, value: f }));
            }
            else if (metaData?.additional?.filterOptions?.filterableValues) {
                return metaData.additional.filterOptions.filterableValues.map(value => ({ key: value, value }));
            }
            else if (metaData?.fieldType === FieldType.Enum) {
                return Object.entries(metaData.additional.enumMap).map(([key, value]) => ({ key: value, value: +key }));
            }
            return [];
        });
    }
    #e;
    writeValue(obj) {
        this.value = obj;
        if (this.value) {
            const selectedKeys = this.$keyValues().filter(item => this.value.includes(this.getValue(this.$metaData().fieldType, item)));
            this.$selectedKeys.set(selectedKeys);
        }
        this.ref.markForCheck();
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    selectFilterChanged($event, val) {
        if ($event.checked) {
            this.$selectedKeys.update(keys => [...keys, val]);
        }
        else {
            this.$selectedKeys.update(keys => keys.filter(item => item !== val));
        }
        this.value = this.$selectedKeys().map(item => this.getValue(this.$metaData().fieldType, item));
        this.onChange(this.value);
    }
    getValue(metaDateType, val) {
        if (metaDateType === FieldType.Enum) {
            return val.value;
        }
        return val.key;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: InListFilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: InListFilterComponent, isStandalone: true, selector: "tb-in-list-filter", inputs: { $values: { classPropertyName: "$values", publicName: "values", isSignal: true, isRequired: false, transformFunction: null }, $key: { classPropertyName: "$key", publicName: "key", isSignal: true, isRequired: true, transformFunction: null } }, providers: [{
                provide: NG_VALUE_ACCESSOR,
                useExisting: InListFilterComponent,
                multi: true
            }], ngImport: i0, template: `
  @for (item of $keyValues(); track item.key) {
    <div>
      <mat-checkbox [checked]="includes | func :  item : $selectedKeys()" stop-propagation (change)='selectFilterChanged($event, item)' >
        @switch ($metaData().fieldType)
        {
          @case (FieldType.Enum)
          {
            {{(item.key | spaceCase)}}
          }
          @case (FieldType.Date)
          {
            {{item.value | date: 'shortDate'}}
          }
          @case (FieldType.DateTime)
          {
            {{item.value | date: 'short'}}
          }
          @case (FieldType.Currency)
          {
            {{item.value | currency }}
          }
          @default
          {
            {{item.key}}
          }
        }
      </mat-checkbox>
    </div>
  }

  `, isInline: true, dependencies: [{ kind: "ngmodule", type: MatCheckboxModule }, { kind: "component", type: i1$2.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "aria-expanded", "aria-controls", "aria-owns", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }, { kind: "pipe", type: FunctionPipe, name: "func" }, { kind: "pipe", type: DatePipe, name: "date" }, { kind: "pipe", type: CurrencyPipe, name: "currency" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: InListFilterComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tb-in-list-filter',
                    template: `
  @for (item of $keyValues(); track item.key) {
    <div>
      <mat-checkbox [checked]="includes | func :  item : $selectedKeys()" stop-propagation (change)='selectFilterChanged($event, item)' >
        @switch ($metaData().fieldType)
        {
          @case (FieldType.Enum)
          {
            {{(item.key | spaceCase)}}
          }
          @case (FieldType.Date)
          {
            {{item.value | date: 'shortDate'}}
          }
          @case (FieldType.DateTime)
          {
            {{item.value | date: 'short'}}
          }
          @case (FieldType.Currency)
          {
            {{item.value | currency }}
          }
          @default
          {
            {{item.key}}
          }
        }
      </mat-checkbox>
    </div>
  }

  `,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: InListFilterComponent,
                            multi: true
                        }],
                    imports: [
                        MatCheckboxModule, StopPropagationDirective, SpaceCasePipe, FunctionPipe, DatePipe, CurrencyPipe
                    ]
                }]
        }] });

class FilterComponent {
    constructor() {
        this.state = inject(TableStore);
        this.filterTypes = filterTypeMap;
        this.FilterType = FilterType;
        this.FieldType = FieldType;
        this.$filter = input.required({
            alias: 'filter',
            transform: (f) => ({ ...f })
        });
        this.close = output();
        this.$enteredFilterType = signal(undefined);
        this.$currentFilterType = computed(() => this.$enteredFilterType() || this.$filter()?.filterType);
        this.$availableFilterTypes = computed(() => this.filterTypes[this.$filter()?.fieldType]);
        this.$filterBy = computed(() => this.$filter().filterBy);
    }
    onEnter(filter, event) {
        event.preventDefault();
        if (filter.filterValue != null && filter.filterType) {
            this.addFilter(filter);
            this.close.emit();
        }
    }
    addFilter(filter) {
        this.state.addFilter({ ...filter, filterBy: this.$filterBy() });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FilterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: FilterComponent, isStandalone: true, selector: "tb-filter", inputs: { $filter: { classPropertyName: "$filter", publicName: "filter", isSignal: true, isRequired: true, transformFunction: null } }, outputs: { close: "close" }, ngImport: i0, template: "@let filter = $filter();\r\n@let currentFilterType = $currentFilterType();\r\n\r\n@if (filter)\r\n{\r\n  <mat-card appearance=\"outlined\" class=\"filter-card\">\r\n    <mat-card-content>\r\n      <form #form=\"ngForm\"  (keydown.enter)=\"onEnter(form.value,$event)\" (keydown.escape)=\"close.emit()\">\r\n        <input type=\"hidden\" name=\"filterId\" [ngModel]=\"filter.filterId\" />\r\n        <input type=\"hidden\" name=\"key\" [ngModel]=\"filter.key\" />\r\n        <input type=\"hidden\" name=\"fieldType\" [ngModel]=\"filter.fieldType\" />\r\n        <div class=\"head-row\" >\r\n          <h4 class=\"filter-name\">{{(filter.key | spaceCase)}} Filter</h4>\r\n          <button class=\"cancel-button small-button\" color=\"primary\" mat-icon-button type=\"button\" [matTooltip]=\"'Close'\"\r\n              (click)=\"close.emit();\">\r\n            <mat-icon class=\"cancel-button\" color=\"primary\">close</mat-icon>\r\n          </button>\r\n        </div>\r\n        <div class=\"filter-row\">\r\n            <div class=\"inline\">\r\n              <mat-form-field class=\"my-filter\" >\r\n                  <mat-select  placeholder=\"Select Filter Type\" name=\"filterType\"  [ngModel]=\"$currentFilterType()\" [panelWidth]=\"null\" (ngModelChange)=\"$enteredFilterType.set($event)\">\r\n                    @for (kvp of filterTypes[filter.fieldType]; track kvp)\r\n                    {\r\n                      <mat-option [value]=\"kvp\">\r\n                        {{ kvp }}\r\n                      </mat-option>\r\n                    }\r\n                  </mat-select>\r\n              </mat-form-field>\r\n            </div>\r\n            @if(\r\n              filter.fieldType === FieldType.String\r\n              || filter.fieldType === FieldType.Array\r\n              || filter.fieldType === FieldType.Link\r\n              || filter.fieldType === FieldType.Unknown\r\n              || filter.fieldType === FieldType.PhoneNumber)\r\n            {\r\n              <ng-container *ngTemplateOutlet=\"String\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Number || filter.fieldType === FieldType.Currency)\r\n            {\r\n              <tb-number-filter [info]=\"filter\" [CurrentFilterType]=\"currentFilterType!\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Boolean)\r\n            {\r\n              <ng-container *ngTemplateOutlet=\"Boolean\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Date)\r\n            {\r\n              <tb-date-filter [info]=\"filter\" [CurrentFilterType]=\"currentFilterType!\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.DateTime)\r\n            {\r\n              <tb-date-time-filter [info]=\"filter\" [CurrentFilterType]=\"currentFilterType!\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Enum)\r\n            {\r\n              <ng-container *ngTemplateOutlet=\"Enum\" />\r\n            }\r\n\r\n            @if(currentFilterType === FilterType.IsNull)\r\n            {\r\n              <mat-radio-group name=\"filterValue\" [ngModel]=\"filter.filterValue\">\r\n                <mat-radio-button [value]=\"true\">True</mat-radio-button>\r\n                <mat-radio-button [value]=\"false\">False</mat-radio-button>\r\n              </mat-radio-group>\r\n            }\r\n        </div>\r\n        <button mat-button disableRipple [disabled]=\"form.value.filterValue==undefined || !form.value.filterType\" (click)=\"addFilter(form.value)\">\r\n          Apply\r\n        </button>\r\n      \r\n      \r\n      <ng-template #String>\r\n        @if(currentFilterType !== FilterType.IsNull && currentFilterType !== FilterType.In)\r\n        {\r\n          <mat-form-field class=\"my-filter\">\r\n            <input matInput name=\"filterValue\" [ngModel]=\"filter.filterValue\" />\r\n          </mat-form-field>\r\n        }\r\n        @else if(currentFilterType === FilterType.In)\r\n        {\r\n          <lib-in-filter name='filterValue' [type]=\"FieldType.String\" [(ngModel)]=\"filter.filterValue\" />\r\n        }\r\n      </ng-template>\r\n      \r\n      <ng-template #Boolean >\r\n        @if(currentFilterType === FilterType.BooleanEquals)\r\n        {\r\n          <div class=\"switch\">\r\n            <mat-radio-group name=\"filterValue\" [ngModel]=\"filter.filterValue\" >\r\n              <mat-radio-button preventEnter [value]=\"true\">True</mat-radio-button>\r\n              <mat-radio-button preventEnter [value]=\"false\">False</mat-radio-button>\r\n            </mat-radio-group>\r\n          </div>\r\n        }\r\n      </ng-template>\r\n      <ng-template #Enum>\r\n        @if(currentFilterType === FilterType.In)\r\n        {\r\n          <tb-in-list-filter name='filterValue' [key]=\"filter.key\" [values]=\"filter.filterValue\" [(ngModel)]=\"filter.filterValue\" />\r\n\r\n        }\r\n      </ng-template>\r\n      </form>\r\n    </mat-card-content>\r\n  </mat-card>\r\n}\r\n", styles: [".filter-name{color:var(tb-filter-name);margin:10px 0;font-weight:600;display:inline-block}.switch{display:inline-block}.head-row{display:flex;width:100%;align-items:center;justify-content:space-between}.filter-row{display:flex;align-items:center;gap:1rem}mat-card.filter-card::ng-deep mat-form-field{width:150px}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.inline{display:inline-block}.small-button{height:18px;width:18px;font-size:18px;padding:0;margin:0}.small-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.cancel-button{font-weight:700}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"], dependencies: [{ kind: "ngmodule", type: MatCardModule }, { kind: "component", type: i1$3.MatCard, selector: "mat-card", inputs: ["appearance"], exportAs: ["matCard"] }, { kind: "directive", type: i1$3.MatCardContent, selector: "mat-card-content" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i2.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatButton, selector: "    button[matButton], a[matButton], button[mat-button], button[mat-raised-button],    button[mat-flat-button], button[mat-stroked-button], a[mat-button], a[mat-raised-button],    a[mat-flat-button], a[mat-stroked-button]  ", inputs: ["matButton"], exportAs: ["matButton", "matAnchor"] }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i1$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "ngmodule", type: MatSelectModule }, { kind: "component", type: i7.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth", "canSelectNullableOptions"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i7.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "component", type: NumberFilterComponent, selector: "tb-number-filter", inputs: ["CurrentFilterType", "info"] }, { kind: "component", type: DateFilterComponent, selector: "tb-date-filter", inputs: ["info", "CurrentFilterType"] }, { kind: "component", type: DateTimeFilterComponent, selector: "tb-date-time-filter", inputs: ["info", "CurrentFilterType"] }, { kind: "ngmodule", type: MatRadioModule }, { kind: "directive", type: i8.MatRadioGroup, selector: "mat-radio-group", inputs: ["color", "name", "labelPosition", "value", "selected", "disabled", "required", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioGroup"] }, { kind: "component", type: i8.MatRadioButton, selector: "mat-radio-button", inputs: ["id", "name", "aria-label", "aria-labelledby", "aria-describedby", "disableRipple", "tabIndex", "checked", "value", "labelPosition", "disabled", "required", "color", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioButton"] }, { kind: "component", type: InFilterComponent, selector: "lib-in-filter", inputs: ["type"] }, { kind: "component", type: InListFilterComponent, selector: "tb-in-list-filter", inputs: ["values", "key"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FilterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-filter', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatCardModule, FormsModule, SpaceCasePipe, MatButtonModule, MatTooltipModule, MatIconModule,
                        MatInputModule, MatSelectModule, NumberFilterComponent,
                        DateFilterComponent, DateTimeFilterComponent, MatRadioModule, InFilterComponent, InListFilterComponent,
                        NgTemplateOutlet
                    ], template: "@let filter = $filter();\r\n@let currentFilterType = $currentFilterType();\r\n\r\n@if (filter)\r\n{\r\n  <mat-card appearance=\"outlined\" class=\"filter-card\">\r\n    <mat-card-content>\r\n      <form #form=\"ngForm\"  (keydown.enter)=\"onEnter(form.value,$event)\" (keydown.escape)=\"close.emit()\">\r\n        <input type=\"hidden\" name=\"filterId\" [ngModel]=\"filter.filterId\" />\r\n        <input type=\"hidden\" name=\"key\" [ngModel]=\"filter.key\" />\r\n        <input type=\"hidden\" name=\"fieldType\" [ngModel]=\"filter.fieldType\" />\r\n        <div class=\"head-row\" >\r\n          <h4 class=\"filter-name\">{{(filter.key | spaceCase)}} Filter</h4>\r\n          <button class=\"cancel-button small-button\" color=\"primary\" mat-icon-button type=\"button\" [matTooltip]=\"'Close'\"\r\n              (click)=\"close.emit();\">\r\n            <mat-icon class=\"cancel-button\" color=\"primary\">close</mat-icon>\r\n          </button>\r\n        </div>\r\n        <div class=\"filter-row\">\r\n            <div class=\"inline\">\r\n              <mat-form-field class=\"my-filter\" >\r\n                  <mat-select  placeholder=\"Select Filter Type\" name=\"filterType\"  [ngModel]=\"$currentFilterType()\" [panelWidth]=\"null\" (ngModelChange)=\"$enteredFilterType.set($event)\">\r\n                    @for (kvp of filterTypes[filter.fieldType]; track kvp)\r\n                    {\r\n                      <mat-option [value]=\"kvp\">\r\n                        {{ kvp }}\r\n                      </mat-option>\r\n                    }\r\n                  </mat-select>\r\n              </mat-form-field>\r\n            </div>\r\n            @if(\r\n              filter.fieldType === FieldType.String\r\n              || filter.fieldType === FieldType.Array\r\n              || filter.fieldType === FieldType.Link\r\n              || filter.fieldType === FieldType.Unknown\r\n              || filter.fieldType === FieldType.PhoneNumber)\r\n            {\r\n              <ng-container *ngTemplateOutlet=\"String\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Number || filter.fieldType === FieldType.Currency)\r\n            {\r\n              <tb-number-filter [info]=\"filter\" [CurrentFilterType]=\"currentFilterType!\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Boolean)\r\n            {\r\n              <ng-container *ngTemplateOutlet=\"Boolean\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Date)\r\n            {\r\n              <tb-date-filter [info]=\"filter\" [CurrentFilterType]=\"currentFilterType!\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.DateTime)\r\n            {\r\n              <tb-date-time-filter [info]=\"filter\" [CurrentFilterType]=\"currentFilterType!\" />\r\n            }\r\n            @else if(filter.fieldType === FieldType.Enum)\r\n            {\r\n              <ng-container *ngTemplateOutlet=\"Enum\" />\r\n            }\r\n\r\n            @if(currentFilterType === FilterType.IsNull)\r\n            {\r\n              <mat-radio-group name=\"filterValue\" [ngModel]=\"filter.filterValue\">\r\n                <mat-radio-button [value]=\"true\">True</mat-radio-button>\r\n                <mat-radio-button [value]=\"false\">False</mat-radio-button>\r\n              </mat-radio-group>\r\n            }\r\n        </div>\r\n        <button mat-button disableRipple [disabled]=\"form.value.filterValue==undefined || !form.value.filterType\" (click)=\"addFilter(form.value)\">\r\n          Apply\r\n        </button>\r\n      \r\n      \r\n      <ng-template #String>\r\n        @if(currentFilterType !== FilterType.IsNull && currentFilterType !== FilterType.In)\r\n        {\r\n          <mat-form-field class=\"my-filter\">\r\n            <input matInput name=\"filterValue\" [ngModel]=\"filter.filterValue\" />\r\n          </mat-form-field>\r\n        }\r\n        @else if(currentFilterType === FilterType.In)\r\n        {\r\n          <lib-in-filter name='filterValue' [type]=\"FieldType.String\" [(ngModel)]=\"filter.filterValue\" />\r\n        }\r\n      </ng-template>\r\n      \r\n      <ng-template #Boolean >\r\n        @if(currentFilterType === FilterType.BooleanEquals)\r\n        {\r\n          <div class=\"switch\">\r\n            <mat-radio-group name=\"filterValue\" [ngModel]=\"filter.filterValue\" >\r\n              <mat-radio-button preventEnter [value]=\"true\">True</mat-radio-button>\r\n              <mat-radio-button preventEnter [value]=\"false\">False</mat-radio-button>\r\n            </mat-radio-group>\r\n          </div>\r\n        }\r\n      </ng-template>\r\n      <ng-template #Enum>\r\n        @if(currentFilterType === FilterType.In)\r\n        {\r\n          <tb-in-list-filter name='filterValue' [key]=\"filter.key\" [values]=\"filter.filterValue\" [(ngModel)]=\"filter.filterValue\" />\r\n\r\n        }\r\n      </ng-template>\r\n      </form>\r\n    </mat-card-content>\r\n  </mat-card>\r\n}\r\n", styles: [".filter-name{color:var(tb-filter-name);margin:10px 0;font-weight:600;display:inline-block}.switch{display:inline-block}.head-row{display:flex;width:100%;align-items:center;justify-content:space-between}.filter-row{display:flex;align-items:center;gap:1rem}mat-card.filter-card::ng-deep mat-form-field{width:150px}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}mat-card.filter-card::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.inline{display:inline-block}.small-button{height:18px;width:18px;font-size:18px;padding:0;margin:0}.small-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.cancel-button{font-weight:700}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"] }]
        }] });

class GenColDisplayerComponent {
    constructor() {
        this.tableState = inject(TableStore);
        this.$columns = computed(() => this.tableState.$orderedCodeVisibleMetaDatas().map(md => ({
            key: md.key,
            displayName: md.displayName,
            isVisible: !this.tableState.$hiddenKeys().includes(md.key)
        })));
    }
    reset(displayCols) {
        displayCols.forEach(c => c.isVisible = true);
        this.emit(displayCols);
    }
    drop(event) {
        this.tableState.setUserDefinedOrder({ newOrder: event.currentIndex, oldOrder: event.previousIndex });
    }
    unset(displayCols) {
        displayCols.forEach(c => c.isVisible = false);
        this.emit(displayCols);
    }
    emit(displayCols) {
        this.tableState.setHiddenColumns(displayCols.map(c => ({ key: c.key, visible: c.isVisible })));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GenColDisplayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: GenColDisplayerComponent, isStandalone: true, selector: "tb-col-displayer", ngImport: i0, template: "@if($columns(); as displayCols)\r\n{\r\n  <span matTooltip=\"Show/hide columns\">\r\n    <button color=\"primary\" mat-icon-button [matMenuTriggerFor]=\"menu\">\r\n      <mat-icon color=\"primary\">visibility_off</mat-icon>\r\n    </button>\r\n  </span>\r\n  <mat-menu #menu=\"matMenu\" class=\"my-mat-menu\">\r\n\r\n    <button mat-menu-item>\r\n      <span matTooltip=\"Close\">\r\n        <button class=\"filter-button\" mat-icon-button>\r\n          <mat-icon>close</mat-icon>\r\n        </button>\r\n      </span>\r\n    </button>\r\n\r\n    <button mat-menu-item stop-propagation>\r\n      <span matTooltip=\"Show all columns\">\r\n        <button color=\"primary\" mat-icon-button (click)=\"reset(displayCols)\">\r\n          <mat-icon color=\"primary\">done_all</mat-icon>\r\n        </button>\r\n      </span>\r\n\r\n      <span matTooltip=\"Hide all columns\">\r\n        <button color=\"primary\" mat-icon-button (click)=\"unset(displayCols)\">\r\n          <mat-icon color=\"primary\">cancel</mat-icon>\r\n        </button>\r\n      </span>\r\n    </button>\r\n\r\n    <div cdkDropList stop-propagation [cdkDropListLockAxis]=\"'y'\" (cdkDropListDropped)=\"drop($event)\">\r\n      @for (col of displayCols; track col.key)\r\n      {\r\n        <button stop-propagation mat-menu-item cdkDrag [class.isHidden]=\"!col.isVisible\" [cdkDragData]=\"col\">\r\n        <div style=\"display: flex; align-items: center;\" (click)=\"col.isVisible = !col.isVisible; emit(displayCols)\">\r\n          @if(col.isVisible)\r\n          {\r\n            <button color=\"primary\" mat-icon-button matTooltip=\"Hide Column\" class=\"show-hide\">\r\n              <mat-icon color=\"primary\">check_box</mat-icon>\r\n            </button>\r\n          }\r\n          @else\r\n          {\r\n            <button mat-icon-button matTooltip=\"Show Column\" class=\"show-hide\">\r\n              <mat-icon>indeterminate_check_box</mat-icon>\r\n            </button>\r\n          }\r\n          \r\n          <p class=\"label\">\r\n            {{col.displayName || (col.key | spaceCase) }}\r\n          </p>\r\n\r\n        </div>\r\n      </button>\r\n      }\r\n\r\n    </div>\r\n  </mat-menu>\r\n}", styles: [".show-hide{margin-right:15px;height:24px;width:24px;padding:4px}.label{color:var(tb-col-display-name);text-overflow:ellipsis;overflow:hidden;white-space:nowrap;text-align:left;margin:0;font-size:17px;font-weight:700;display:inline-block;width:66%}.row{margin:0;padding:0}.isHidden{background-color:#d3d3d3;color:#a9a9a9;font-weight:700;font-size:17px;white-space:nowrap}.filter-button{margin-top:10px}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.mdc-list-item__primary-text{display:inline-block;width:100%}\n"], dependencies: [{ kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }, { kind: "ngmodule", type: DragDropModule }, { kind: "directive", type: i5.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep", "cdkDropListElementContainer"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i5.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer", "cdkDragScale"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GenColDisplayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-col-displayer', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatTooltipModule, MatIconModule, MatButtonModule, MatMenuModule, StopPropagationDirective,
                        DragDropModule, SpaceCasePipe
                    ], template: "@if($columns(); as displayCols)\r\n{\r\n  <span matTooltip=\"Show/hide columns\">\r\n    <button color=\"primary\" mat-icon-button [matMenuTriggerFor]=\"menu\">\r\n      <mat-icon color=\"primary\">visibility_off</mat-icon>\r\n    </button>\r\n  </span>\r\n  <mat-menu #menu=\"matMenu\" class=\"my-mat-menu\">\r\n\r\n    <button mat-menu-item>\r\n      <span matTooltip=\"Close\">\r\n        <button class=\"filter-button\" mat-icon-button>\r\n          <mat-icon>close</mat-icon>\r\n        </button>\r\n      </span>\r\n    </button>\r\n\r\n    <button mat-menu-item stop-propagation>\r\n      <span matTooltip=\"Show all columns\">\r\n        <button color=\"primary\" mat-icon-button (click)=\"reset(displayCols)\">\r\n          <mat-icon color=\"primary\">done_all</mat-icon>\r\n        </button>\r\n      </span>\r\n\r\n      <span matTooltip=\"Hide all columns\">\r\n        <button color=\"primary\" mat-icon-button (click)=\"unset(displayCols)\">\r\n          <mat-icon color=\"primary\">cancel</mat-icon>\r\n        </button>\r\n      </span>\r\n    </button>\r\n\r\n    <div cdkDropList stop-propagation [cdkDropListLockAxis]=\"'y'\" (cdkDropListDropped)=\"drop($event)\">\r\n      @for (col of displayCols; track col.key)\r\n      {\r\n        <button stop-propagation mat-menu-item cdkDrag [class.isHidden]=\"!col.isVisible\" [cdkDragData]=\"col\">\r\n        <div style=\"display: flex; align-items: center;\" (click)=\"col.isVisible = !col.isVisible; emit(displayCols)\">\r\n          @if(col.isVisible)\r\n          {\r\n            <button color=\"primary\" mat-icon-button matTooltip=\"Hide Column\" class=\"show-hide\">\r\n              <mat-icon color=\"primary\">check_box</mat-icon>\r\n            </button>\r\n          }\r\n          @else\r\n          {\r\n            <button mat-icon-button matTooltip=\"Show Column\" class=\"show-hide\">\r\n              <mat-icon>indeterminate_check_box</mat-icon>\r\n            </button>\r\n          }\r\n          \r\n          <p class=\"label\">\r\n            {{col.displayName || (col.key | spaceCase) }}\r\n          </p>\r\n\r\n        </div>\r\n      </button>\r\n      }\r\n\r\n    </div>\r\n  </mat-menu>\r\n}", styles: [".show-hide{margin-right:15px;height:24px;width:24px;padding:4px}.label{color:var(tb-col-display-name);text-overflow:ellipsis;overflow:hidden;white-space:nowrap;text-align:left;margin:0;font-size:17px;font-weight:700;display:inline-block;width:66%}.row{margin:0;padding:0}.isHidden{background-color:#d3d3d3;color:#a9a9a9;font-weight:700;font-size:17px;white-space:nowrap}.filter-button{margin-top:10px}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.mdc-list-item__primary-text{display:inline-block;width:100%}\n"] }]
        }] });

class WrapperFilterStore extends ComponentStore {
    constructor() {
        super({ filterInfo: [] });
        this.clearAll = this.updater(() => ({ filterInfo: [] }));
        this.deleteByIndex = this.updater((state, index) => {
            const arr = [...state.filterInfo];
            arr.splice(index, 1);
            return { filterInfo: arr };
        });
        this.$currentFilters = this.selectSignal(state => state.filterInfo);
        this.addFilter = this.updater((state, filter) => {
            return ({ ...state, filterInfo: [...state.filterInfo, filter] });
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: WrapperFilterStore, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: WrapperFilterStore }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: WrapperFilterStore, decorators: [{
            type: Injectable
        }], ctorParameters: () => [] });

class GenFilterDisplayerComponent {
    constructor() {
        this.tableState = inject(TableStore);
        this.filterStore = inject(WrapperFilterStore);
        this.$filterCols = computed(() => {
            const mds = this.tableState.$metaDataArray();
            return mds.filter(m => m.fieldType !== FieldType.Hidden && (m.fieldType !== FieldType.NotMapped || m.filterLogic?.filterBy) && !m.noFilter);
        });
    }
    addFilter(metaData) {
        this.filterStore.addFilter({
            key: metaData.key,
            fieldType: metaData.filterLogic?.filterType || metaData.fieldType,
            filterBy: metaData.filterLogic?.filterBy === 'use map' ? metaData.map : metaData.filterLogic?.filterBy
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GenFilterDisplayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: GenFilterDisplayerComponent, isStandalone: true, selector: "tb-filter-displayer", ngImport: i0, template: "<button color=\"primary\" stop-propagation class=\"filter-button\" mat-icon-button [matMenuTriggerFor]=\"menu\" [matTooltip]=\"'Add Filter'\">\r\n  <mat-icon class=\"filter-icon\" color=\"primary\">filter_list</mat-icon>\r\n</button>\r\n<mat-menu #menu=\"matMenu\">\r\n  @for (md of $filterCols(); track md.key)\r\n  {\r\n    <button mat-menu-item (click)=\"addFilter(md)\">\r\n      <span class=\"filter-labels\">{{md.displayName || (md.key | spaceCase)}}</span>\r\n    </button>\r\n  }\r\n</mat-menu>\r\n", styles: [".filter{margin:15px;display:inline-block}.filter-button{font-size:22px;font-weight:700}.cancel-button{margin-right:30px;font-weight:700}.filter-wrapper{margin-top:1em;margin-bottom:1em;float:right}.menu{margin-bottom:10px;width:109.1%}.filter-labels{font-size:17px;font-weight:600}.float{position:absolute;width:fit-content;z-index:101;top:10px;right:180px;max-width:90vw}.d-w{display:flex;flex-direction:row;justify-content:flex-end}\n"], dependencies: [{ kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GenFilterDisplayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-filter-displayer', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatButtonModule, MatMenuModule, MatTooltipModule, StopPropagationDirective, MatIconModule,
                        SpaceCasePipe
                    ], template: "<button color=\"primary\" stop-propagation class=\"filter-button\" mat-icon-button [matMenuTriggerFor]=\"menu\" [matTooltip]=\"'Add Filter'\">\r\n  <mat-icon class=\"filter-icon\" color=\"primary\">filter_list</mat-icon>\r\n</button>\r\n<mat-menu #menu=\"matMenu\">\r\n  @for (md of $filterCols(); track md.key)\r\n  {\r\n    <button mat-menu-item (click)=\"addFilter(md)\">\r\n      <span class=\"filter-labels\">{{md.displayName || (md.key | spaceCase)}}</span>\r\n    </button>\r\n  }\r\n</mat-menu>\r\n", styles: [".filter{margin:15px;display:inline-block}.filter-button{font-size:22px;font-weight:700}.cancel-button{margin-right:30px;font-weight:700}.filter-wrapper{margin-top:1em;margin-bottom:1em;float:right}.menu{margin-bottom:10px;width:109.1%}.filter-labels{font-size:17px;font-weight:600}.float{position:absolute;width:fit-content;z-index:101;top:10px;right:180px;max-width:90vw}.d-w{display:flex;flex-direction:row;justify-content:flex-end}\n"] }]
        }] });

class KeyDisplayPipe {
    constructor() {
        this.tableState = inject(TableStore);
        this.transform = (key) => computed(() => this.tableState.$getMetaData(key)()?.displayName || spaceCase(key));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: KeyDisplayPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: KeyDisplayPipe, isStandalone: true, name: "keyDisplay" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: KeyDisplayPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'keyDisplay' }]
        }] });

class FormatFilterTypePipe {
    transform(filterType, value) {
        if (filterType === FilterType.IsNull) {
            return value ? filterType : 'Is Not Blank';
        }
        return filterType;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FormatFilterTypePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: FormatFilterTypePipe, isStandalone: true, name: "formatFilterType" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FormatFilterTypePipe, decorators: [{
            type: Pipe,
            args: [{ name: 'formatFilterType' }]
        }] });

function isPipe(o) {
    return typeof (o.transform) === 'function';
}
function createTransformer(metaData, config, noIcons = false, forItem = false) {
    const defaultFunc = getFactory(metaData.key);
    if (metaData.map && !forItem) {
        return (value) => {
            return metaData.map(value);
        };
    }
    if (metaData.mapItem) {
        return (value) => {
            return metaData.mapItem(defaultFunc(value));
        };
    }
    if (metaData.transform) {
        if (isPipe(metaData.transform)) {
            return (value) => metaData.transform.transform(defaultFunc(value));
        }
        return metaData.fieldType === FieldType.Expression ? metaData.transform : (value) => metaData.transform(defaultFunc(value), value);
    }
    if (config.transformers && config.transformers[metaData.fieldType]) {
        var transformer = config.transformers[metaData.fieldType];
        return (value) => transformer(defaultFunc(value));
    }
    const defaultDateFormat = config.dateFormats?.dateFormat ?? 'shortDate';
    const defaultDateTimeFormat = config.dateFormats?.dateTimeFormat ?? 'short';
    switch (metaData.fieldType) {
        case FieldType.Date:
            const dateFormat = metaData.additional?.dateFormat ?? defaultDateFormat;
            return (value) => dateFormatter(defaultFunc(value), dateFormat);
        case FieldType.DateTime:
            const dateTimeFormat = metaData.additional?.dateTimeOptions?.format ?? defaultDateTimeFormat;
            return (value) => dateFormatter(defaultFunc(value), dateTimeFormat);
        case FieldType.Currency:
            return (value) => currencyFormatter(defaultFunc(value));
        case FieldType.PhoneNumber:
            return (value) => phoneFormatter(defaultFunc(value));
        case FieldType.Enum:
            return (value) => spaceCase(metaData.additional?.enumMap[defaultFunc(value)]);
        case FieldType.Boolean:
            if (noIcons) {
                return defaultFunc;
            }
            let forTrue = 'check';
            let forFalse = '';
            if (metaData.additional?.boolean?.forTrue) {
                forTrue = metaData?.additional.boolean.forTrue.icon;
            }
            if (metaData.additional?.boolean?.showForFalse === true) {
                forFalse = 'clear';
            }
            else if (metaData.additional?.boolean?.showForFalse?.icon) {
                forFalse = metaData.additional?.boolean?.showForFalse?.icon;
            }
            return (value) => defaultFunc(value) ? forTrue : forFalse;
    }
    return defaultFunc;
}
function createItemTransformer(metaData, config, noIcons = false, mutate = false) {
    const transform = createTransformer(metaData, config, noIcons);
    return (t) => {
        if (!mutate) {
            t = { ...t };
        }
        t[metaData.key] = transform(t);
    };
}
function createItemTransformers(metaDatas, config, noIcons = false, mutate = false) {
    const transformers = metaDatas.map(meta => createItemTransformer(meta, config, noIcons, true));
    return (t) => {
        if (!t)
            return t;
        if (!mutate) {
            t = { ...t };
        }
        transformers.forEach(m => m(t));
        return t;
    };
}
function dateFormatter(date, format) {
    if (!date)
        return;
    return formatDate(date, format, 'en-US');
}
function currencyFormatter(amt) {
    return formatCurrency(amt, 'en-US', '$');
}

class FormatFilterValuePipe {
    constructor() {
        this.tableState = inject(TableStore);
    }
    transform(value, key, filterType) {
        return computed(() => transform(value, this.tableState.$getMetaData(key)(), filterType));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FormatFilterValuePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: FormatFilterValuePipe, isStandalone: true, name: "formatFilterValue" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FormatFilterValuePipe, decorators: [{
            type: Pipe,
            args: [{ name: 'formatFilterValue' }]
        }] });
const transform = (value, meta, filterType) => {
    if (filterType === FilterType.IsNull) {
        return '';
    }
    if (value && (filterType === FilterType.In)) {
        if (meta.fieldType === FieldType.Enum) {
            return value.map((v) => spaceCase(meta.additional.enumMap[v])).join(', ') ?? value;
        }
        if (meta.fieldType === FieldType.Date || meta.fieldType === FieldType.DateTime) {
            return value.map((v) => mapDate(v, meta, filterType)).join(', ') ?? value;
        }
        if (meta.fieldType === FieldType.Number || meta.fieldType === FieldType.Currency) {
            return value.map((v) => mapNumber(v, meta)).join(', ') ?? value;
        }
        return value.join(', ') ?? value;
    }
    if (filterType === FilterType.NumberBetween && (meta.fieldType === FieldType.Number || meta.fieldType === FieldType.Currency)) {
        return mapNumber(value.Start, meta) + ' - ' + mapNumber(value.End, meta);
    }
    if (filterType === FilterType.DateBetween) {
        return mapDate(value.Start, meta, filterType) + ' - ' + mapDate(value.End, meta, filterType);
    }
    if (meta.fieldType === FieldType.Date || meta.fieldType === FieldType.DateTime) {
        return mapDate(value, meta, filterType);
    }
    if (meta.fieldType === FieldType.Currency) {
        return mapNumber(value, meta);
    }
    return value;
};
function mapDate(value, meta, filterType) {
    if (meta.fieldType === FieldType.Date) {
        return dateFormatter(value, 'shortDate');
    }
    if (meta.fieldType === FieldType.DateTime) {
        return (!!DateTimeFilterFuncs[filterType] ? dateFormatter(value, 'shortDate') : dateFormatter(value, 'short')) || '';
    }
    return value;
}
function mapNumber(value, meta) {
    if (meta.fieldType === FieldType.Currency) {
        return currencyFormatter(value);
    }
    return value;
}

class FilterChipsComponent {
    constructor() {
        this.tableState = inject(TableStore);
        this.filterStore = inject(WrapperFilterStore);
        this.$filters = computed(() => Object.values(this.tableState.$filters()).filter(f => isFilterInfo(f) && !f._isExternallyManaged));
        this.$currentFilters = this.filterStore.$currentFilters;
    }
    deleteByIndex(index) {
        this.filterStore.deleteByIndex(index);
    }
    addFilter(filter) {
        this.filterStore.addFilter(filter);
    }
    clearAll() {
        this.filterStore.clearAll();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FilterChipsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: FilterChipsComponent, isStandalone: true, selector: "lib-filter-list", ngImport: i0, template: "<div class=\"d-w\">\r\n\r\n  @if ($currentFilters().length)\r\n  {\r\n    <button class=\"cancel-button\" mat-icon-button matTooltip=\"Close all Filters Cards\" (click)=\"clearAll()\">\r\n      <mat-icon class=\"cancel-button\" color=\"primary\">close</mat-icon>\r\n    </button>\r\n    <div class=\"float\">\r\n      @for (filter of $currentFilters(); track filter.key)\r\n      {\r\n        <div class=\"filter\">\r\n          <tb-filter [filter]=\"filter\" (close)=\"deleteByIndex($index)\" />\r\n        </div>\r\n      }\r\n    </div>\r\n  }\r\n\r\n  <mat-chip-set>\r\n    @for (filter of $filters(); track filter.key)\r\n    {\r\n      <mat-chip (dblclick)=\"addFilter(filter)\"  (removed)=\"tableState.removeFilter(filter.filterId!)\">\r\n        {{ (filter.key | keyDisplay)()  }} {{filter.filterType | formatFilterType : filter.filterValue}} {{ (filter.filterValue | formatFilterValue: filter.key : filter.filterType)() }}\r\n        <mat-icon matChipRemove>cancel</mat-icon>\r\n      </mat-chip>\r\n    }\r\n    @if ($filters().length > 1)\r\n    {\r\n      <mat-chip  (removed)=\"tableState.clearFilters()\">\r\n        Clear All\r\n        <mat-icon matChipRemove>cancel</mat-icon>\r\n      </mat-chip>\r\n    }\r\n  </mat-chip-set>\r\n\r\n</div>\r\n", styles: [".filter{margin:15px;display:inline-block}.filter-button{font-size:22px;font-weight:700}.cancel-button{margin-right:30px;font-weight:700}.filter-wrapper{margin-top:1em;margin-bottom:1em;float:right}.menu{margin-bottom:10px;width:109.1%}.filter-labels{font-size:17px;font-weight:600}.float{position:absolute;width:fit-content;z-index:101;top:10px;right:180px;max-width:90vw}.d-w{display:flex;flex-direction:row;justify-content:flex-end}\n"], dependencies: [{ kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: FilterComponent, selector: "tb-filter", inputs: ["filter"], outputs: ["close"] }, { kind: "ngmodule", type: MatChipsModule }, { kind: "component", type: i4$1.MatChip, selector: "mat-basic-chip, [mat-basic-chip], mat-chip, [mat-chip]", inputs: ["role", "id", "aria-label", "aria-description", "value", "color", "removable", "highlighted", "disableRipple", "disabled"], outputs: ["removed", "destroyed"], exportAs: ["matChip"] }, { kind: "directive", type: i4$1.MatChipRemove, selector: "[matChipRemove]" }, { kind: "component", type: i4$1.MatChipSet, selector: "mat-chip-set", inputs: ["disabled", "role", "tabIndex"] }, { kind: "pipe", type: KeyDisplayPipe, name: "keyDisplay" }, { kind: "pipe", type: FormatFilterTypePipe, name: "formatFilterType" }, { kind: "pipe", type: FormatFilterValuePipe, name: "formatFilterValue" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: FilterChipsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-filter-list', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatButtonModule, MatTooltipModule, MatIconModule, FilterComponent,
                        MatChipsModule, KeyDisplayPipe, FormatFilterTypePipe, FormatFilterValuePipe
                    ], template: "<div class=\"d-w\">\r\n\r\n  @if ($currentFilters().length)\r\n  {\r\n    <button class=\"cancel-button\" mat-icon-button matTooltip=\"Close all Filters Cards\" (click)=\"clearAll()\">\r\n      <mat-icon class=\"cancel-button\" color=\"primary\">close</mat-icon>\r\n    </button>\r\n    <div class=\"float\">\r\n      @for (filter of $currentFilters(); track filter.key)\r\n      {\r\n        <div class=\"filter\">\r\n          <tb-filter [filter]=\"filter\" (close)=\"deleteByIndex($index)\" />\r\n        </div>\r\n      }\r\n    </div>\r\n  }\r\n\r\n  <mat-chip-set>\r\n    @for (filter of $filters(); track filter.key)\r\n    {\r\n      <mat-chip (dblclick)=\"addFilter(filter)\"  (removed)=\"tableState.removeFilter(filter.filterId!)\">\r\n        {{ (filter.key | keyDisplay)()  }} {{filter.filterType | formatFilterType : filter.filterValue}} {{ (filter.filterValue | formatFilterValue: filter.key : filter.filterType)() }}\r\n        <mat-icon matChipRemove>cancel</mat-icon>\r\n      </mat-chip>\r\n    }\r\n    @if ($filters().length > 1)\r\n    {\r\n      <mat-chip  (removed)=\"tableState.clearFilters()\">\r\n        Clear All\r\n        <mat-icon matChipRemove>cancel</mat-icon>\r\n      </mat-chip>\r\n    }\r\n  </mat-chip-set>\r\n\r\n</div>\r\n", styles: [".filter{margin:15px;display:inline-block}.filter-button{font-size:22px;font-weight:700}.cancel-button{margin-right:30px;font-weight:700}.filter-wrapper{margin-top:1em;margin-bottom:1em;float:right}.menu{margin-bottom:10px;width:109.1%}.filter-labels{font-size:17px;font-weight:600}.float{position:absolute;width:fit-content;z-index:101;top:10px;right:180px;max-width:90vw}.d-w{display:flex;flex-direction:row;justify-content:flex-end}\n"] }]
        }] });

class RouterLinkColumnComponent {
    constructor() {
        this.additional = input.required();
        this.element = input.required();
        this.queryParams = computed(() => this.additional().routerLinkOptions.queryParams(this.element()));
        this.routerLinkOptions = computed(() => this.additional().routerLinkOptions);
        this.link = input.required();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: RouterLinkColumnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "20.0.3", type: RouterLinkColumnComponent, isStandalone: true, selector: "tb-router-link-column", inputs: { additional: { classPropertyName: "additional", publicName: "additional", isSignal: true, isRequired: true, transformFunction: null }, element: { classPropertyName: "element", publicName: "element", isSignal: true, isRequired: true, transformFunction: null }, link: { classPropertyName: "link", publicName: "link", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: `
  <a target="{{additional().target}}"
    [routerLink]=" [link()]"
    [queryParams]="queryParams()"
    [fragment]="routerLinkOptions().fragment"
    [preserveFragment]="routerLinkOptions().preserveFragment"
    [queryParamsHandling]="routerLinkOptions().queryParamsHandling"
  >
    <ng-content></ng-content>
  </a>
  `, isInline: true, dependencies: [{ kind: "ngmodule", type: RouterModule }, { kind: "directive", type: i1$5.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "info", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: RouterLinkColumnComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "tb-router-link-column",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [
                        RouterModule
                    ],
                    template: `
  <a target="{{additional().target}}"
    [routerLink]=" [link()]"
    [queryParams]="queryParams()"
    [fragment]="routerLinkOptions().fragment"
    [preserveFragment]="routerLinkOptions().preserveFragment"
    [queryParamsHandling]="routerLinkOptions().queryParamsHandling"
  >
    <ng-content></ng-content>
  </a>
  `
                }]
        }] });
class LinkColumnComponent {
    constructor() {
        this.element = input.required();
        this.additional = input.required();
        this.link = input.required();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: LinkColumnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "20.0.3", type: LinkColumnComponent, isStandalone: true, selector: "tb-link-column", inputs: { element: { classPropertyName: "element", publicName: "element", isSignal: true, isRequired: true, transformFunction: null }, additional: { classPropertyName: "additional", publicName: "additional", isSignal: true, isRequired: true, transformFunction: null }, link: { classPropertyName: "link", publicName: "link", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: `
  <a target="{{additional().target}}" href="{{link()}}">
    <ng-content></ng-content>
  </a>
  `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: LinkColumnComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "tb-link-column",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: `
  <a target="{{additional().target}}" href="{{link()}}">
    <ng-content></ng-content>
  </a>
  `
                }]
        }] });

class ArrayCommaColumnComponent {
    constructor() {
        this.value = input.required();
        this.additional = input(3);
        this.displayArray = computed(() => (this.value() || []).slice(0, this.additional()));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ArrayCommaColumnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ArrayCommaColumnComponent, isStandalone: true, selector: "tb-comma-array-column", inputs: { value: { classPropertyName: "value", publicName: "value", isSignal: true, isRequired: true, transformFunction: null }, additional: { classPropertyName: "additional", publicName: "additional", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
  @for(val of displayArray(); track $index){
          {{val + (!$last ? ',' : '')}}
        }
  `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ArrayCommaColumnComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tb-comma-array-column',
                    template: `
  @for(val of displayArray(); track $index){
          {{val + (!$last ? ',' : '')}}
        }
  `,
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }] });
class ArrayNewLineColumnComponent {
    constructor() {
        this.value = input.required();
        this.additional = input(3);
        this.displayArray = computed(() => (this.value() || []).slice(0, this.additional()));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ArrayNewLineColumnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ArrayNewLineColumnComponent, isStandalone: true, selector: "tb-new-line-array-column", inputs: { value: { classPropertyName: "value", publicName: "value", isSignal: true, isRequired: true, transformFunction: null }, additional: { classPropertyName: "additional", publicName: "additional", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: `
  @for(val of displayArray(); track $index){
          {{val}}
          @if(!$last){ <br/> }
        }
  `, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ArrayNewLineColumnComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tb-new-line-array-column',
                    template: `
  @for(val of displayArray(); track $index){
          {{val}}
          @if(!$last){ <br/> }
        }
  `,
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }] });

class InitializationComponent {
    constructor() {
        this.$linkTemplate = viewChild.required('link');
        this.$routerLinkTemplate = viewChild.required('routerLink');
        this.$linkWithIconTemplate = viewChild.required('linkWithIcon');
        this.$routerLinkWithIconTemplate = viewChild.required('routerLinkWithIcon');
        this.$imageUrlTemplate = viewChild.required('imageUrl');
        this.$arrayNewLineTemplate = viewChild.required('arrayNewLine');
        this.$arrayCommaTemplate = viewChild.required('arrayComma');
        this.$defaultTemplate = viewChild.required('default');
        this.$defaultWithIcon = viewChild.required('defaultWithIcon');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: InitializationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: InitializationComponent, isStandalone: true, selector: "initialization", viewQueries: [{ propertyName: "$linkTemplate", first: true, predicate: ["link"], descendants: true, isSignal: true }, { propertyName: "$routerLinkTemplate", first: true, predicate: ["routerLink"], descendants: true, isSignal: true }, { propertyName: "$linkWithIconTemplate", first: true, predicate: ["linkWithIcon"], descendants: true, isSignal: true }, { propertyName: "$routerLinkWithIconTemplate", first: true, predicate: ["routerLinkWithIcon"], descendants: true, isSignal: true }, { propertyName: "$imageUrlTemplate", first: true, predicate: ["imageUrl"], descendants: true, isSignal: true }, { propertyName: "$arrayNewLineTemplate", first: true, predicate: ["arrayNewLine"], descendants: true, isSignal: true }, { propertyName: "$arrayCommaTemplate", first: true, predicate: ["arrayComma"], descendants: true, isSignal: true }, { propertyName: "$defaultTemplate", first: true, predicate: ["default"], descendants: true, isSignal: true }, { propertyName: "$defaultWithIcon", first: true, predicate: ["defaultWithIcon"], descendants: true, isSignal: true }], ngImport: i0, template: "<ng-template #link  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-link-column [element]=\"element\" [additional]=\"additional\" [link]=\"$any(link)\">\r\n      <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n    </tb-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n  }\r\n</ng-template>\r\n\r\n<ng-template #routerLink  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-router-link-column [element]=\"element\" [additional]=\"additional\" [link]=\"$any(link)\">\r\n      <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n    </tb-router-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n  }\r\n\r\n</ng-template>\r\n\r\n<ng-template #linkWithIcon  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-link-column [element]=\"element\" [additional]=\"additional\"  [link]=\"$any(link)\">\r\n      <mat-icon [styler]=\"styles\" [element]=\"element\">{{ value}}</mat-icon>\r\n    </tb-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n  }\r\n</ng-template>\r\n\r\n<ng-template #routerLinkWithIcon  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-link-column [element]=\"element\" [additional]=\"additional\"  [link]=\"$any(link)\">\r\n      <mat-icon [styler]=\"styles\" [element]=\"element\">{{ value}}</mat-icon>\r\n    </tb-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <mat-icon [styler]=\"styles\" [element]=\"element\">{{ value}}</mat-icon>\r\n  }\r\n</ng-template>\r\n\r\n<ng-template #imageUrl  let-value='value'>\r\n  <span>\r\n    <img height=\"75px\" width=\"75px\" [src]=\"value\" />\r\n  </span>\r\n</ng-template>\r\n\r\n<ng-template #arrayNewLine let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  <tb-new-line-array-column [value]='value' [additional]='additional' [styler]=\"styles\" [element]=\"element\"/>\r\n</ng-template>\r\n\r\n<ng-template #arrayComma let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  <tb-comma-array-column [value]='value' [additional]='additional' [styler]=\"styles\" [element]=\"element\"/>\r\n</ng-template>\r\n\r\n<ng-template #default let-value='value' let-element='element' let-styles=\"innerStyles\">\r\n  <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n</ng-template>\r\n\r\n<ng-template #defaultWithIcon  let-value='value' let-element='element' let-styles=\"innerStyles\">\r\n  <mat-icon [styler]=\"styles\" [element]=\"element\">{{value}}</mat-icon>\r\n</ng-template>\r\n", dependencies: [{ kind: "component", type: LinkColumnComponent, selector: "tb-link-column", inputs: ["element", "additional", "link"] }, { kind: "component", type: ArrayCommaColumnComponent, selector: "tb-comma-array-column", inputs: ["value", "additional"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: RouterLinkColumnComponent, selector: "tb-router-link-column", inputs: ["additional", "element", "link"] }, { kind: "component", type: ArrayNewLineColumnComponent, selector: "tb-new-line-array-column", inputs: ["value", "additional"] }, { kind: "directive", type: StylerDirective, selector: "[styler]", inputs: ["element", "styler"] }, { kind: "pipe", type: FunctionPipe, name: "func" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: InitializationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'initialization', imports: [
                        LinkColumnComponent, ArrayCommaColumnComponent, MatIcon,
                        RouterLinkColumnComponent, ArrayNewLineColumnComponent,
                        StylerDirective, FunctionPipe
                    ], template: "<ng-template #link  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-link-column [element]=\"element\" [additional]=\"additional\" [link]=\"$any(link)\">\r\n      <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n    </tb-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n  }\r\n</ng-template>\r\n\r\n<ng-template #routerLink  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-router-link-column [element]=\"element\" [additional]=\"additional\" [link]=\"$any(link)\">\r\n      <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n    </tb-router-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n  }\r\n\r\n</ng-template>\r\n\r\n<ng-template #linkWithIcon  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-link-column [element]=\"element\" [additional]=\"additional\"  [link]=\"$any(link)\">\r\n      <mat-icon [styler]=\"styles\" [element]=\"element\">{{ value}}</mat-icon>\r\n    </tb-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n  }\r\n</ng-template>\r\n\r\n<ng-template #routerLinkWithIcon  let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  @let link = additional.link | func : element;\r\n  @if(link)\r\n  {\r\n    <tb-link-column [element]=\"element\" [additional]=\"additional\"  [link]=\"$any(link)\">\r\n      <mat-icon [styler]=\"styles\" [element]=\"element\">{{ value}}</mat-icon>\r\n    </tb-link-column>\r\n  }\r\n  @else\r\n  {\r\n    <mat-icon [styler]=\"styles\" [element]=\"element\">{{ value}}</mat-icon>\r\n  }\r\n</ng-template>\r\n\r\n<ng-template #imageUrl  let-value='value'>\r\n  <span>\r\n    <img height=\"75px\" width=\"75px\" [src]=\"value\" />\r\n  </span>\r\n</ng-template>\r\n\r\n<ng-template #arrayNewLine let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  <tb-new-line-array-column [value]='value' [additional]='additional' [styler]=\"styles\" [element]=\"element\"/>\r\n</ng-template>\r\n\r\n<ng-template #arrayComma let-value='value' let-element='element' let-additional=\"additional\" let-styles=\"innerStyles\">\r\n  <tb-comma-array-column [value]='value' [additional]='additional' [styler]=\"styles\" [element]=\"element\"/>\r\n</ng-template>\r\n\r\n<ng-template #default let-value='value' let-element='element' let-styles=\"innerStyles\">\r\n  <span [styler]=\"styles\" [element]=\"element\">{{value}}</span>\r\n</ng-template>\r\n\r\n<ng-template #defaultWithIcon  let-value='value' let-element='element' let-styles=\"innerStyles\">\r\n  <mat-icon [styler]=\"styles\" [element]=\"element\">{{value}}</mat-icon>\r\n</ng-template>\r\n" }]
        }] });

class TableTemplateService {
    constructor() {
        this.environmentInjector = inject(EnvironmentInjector);
        this.tableConfig = inject(TableBuilderConfigToken);
        this.initConfig = createComponent(InitializationComponent, {
            environmentInjector: this.environmentInjector,
        });
        this.initializationComponentInstance = this.initConfig.instance;
    }
    getTemplate(metaData) {
        if (metaData.fieldType === FieldType.Array) {
            const arrayStyle = metaData.additional?.arrayStyle ?? this.tableConfig?.arrayDefaults?.arrayStyle;
            return arrayStyle === ArrayStyle.NewLine
                ? this.initializationComponentInstance.$arrayNewLineTemplate()
                : this.initializationComponentInstance.$arrayCommaTemplate();
        }
        if (metaData.fieldType === FieldType.ImageUrl) {
            return this.initializationComponentInstance.$imageUrlTemplate();
        }
        const useIcon = metaData.useIcon || metaData.fieldType === FieldType.Boolean;
        if (metaData.fieldType === FieldType.Link || metaData.additional?.link) {
            const router = metaData.additional?.link?.useRouterLink;
            if (router) {
                return useIcon
                    ? this.initializationComponentInstance.$routerLinkWithIconTemplate()
                    : this.initializationComponentInstance.$routerLinkTemplate();
            }
            return useIcon
                ? this.initializationComponentInstance.$linkWithIconTemplate()
                : this.initializationComponentInstance.$linkTemplate();
        }
        if (useIcon) {
            return this.initializationComponentInstance.$defaultWithIcon();
        }
        return this.initializationComponentInstance.$defaultTemplate();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableTemplateService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableTemplateService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableTemplateService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class ColumnHeaderMenuComponent {
    constructor() {
        this.tableState = inject(TableStore);
        this.FieldType = FieldType;
        this.FilterType = FilterType;
        this.$metaData = input.required({ alias: 'metaData' });
        this.$fieldType = computed(() => this.$metaData().filterLogic?.filterType || this.$metaData().fieldType);
        this.$trigger = viewChild(MatMenuTrigger);
        this.$metaFilterType = computed(() => {
            if (this.$metaData().additional?.filterOptions?.filterableValues) {
                return FilterType.In;
            }
            switch (this.$fieldType()) {
                case FieldType.String:
                case FieldType.Link:
                case FieldType.PhoneNumber:
                case FieldType.Array:
                case FieldType.Unknown:
                    return FilterType.StringContains;
                case FieldType.Currency:
                case FieldType.Number:
                    return FilterType.NumberEquals;
                case FieldType.Boolean:
                    return FilterType.BooleanEquals;
                case FieldType.Date:
                case FieldType.DateTime:
                    return FilterType.DateIsOn;
                case FieldType.Enum:
                    return FilterType.In;
                default: return FilterType.StringContains;
            }
        });
        this.$currentFilterType = linkedSignal(() => this.$metaFilterType());
        this.$key = computed(() => this.$metaData().key || crypto.randomUUID());
    }
    hideField(key) {
        this.tableState.hideColumn(key);
    }
    setStringFilterType() {
        if (this.$currentFilterType() === FilterType.StringContains) {
            this.$currentFilterType.set(FilterType.StringDoesNotContain);
        }
        else {
            this.$currentFilterType.set(FilterType.StringContains);
        }
    }
    setFilterType(filterType) {
        this.$currentFilterType.set(filterType);
    }
    onEnter(filter, metaData) {
        if (this.$currentFilterType() === FilterType.In && !filter.filterValue.length) {
            this.tableState.removeFilter(`header-column-${metaData.key}`);
        }
        else if (filter.filterValue != undefined && this.$currentFilterType()) {
            this.tableState.addFilter({
                fieldType: this.$fieldType(),
                filterId: `header-column-${metaData.key}`,
                filterType: this.$currentFilterType(),
                filterValue: filter.filterValue,
                key: metaData.key,
                filterBy: metaData.filterLogic?.filterBy === 'use map' ? metaData.map : metaData.filterLogic?.filterBy
            });
            this.$trigger().closeMenu();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ColumnHeaderMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ColumnHeaderMenuComponent, isStandalone: true, selector: "tb-header-menu", inputs: { $metaData: { classPropertyName: "$metaData", publicName: "metaData", isSignal: true, isRequired: true, transformFunction: null } }, viewQueries: [{ propertyName: "$trigger", first: true, predicate: MatMenuTrigger, descendants: true, isSignal: true }], ngImport: i0, template: "@let metaData = $metaData();\r\n@let fieldType = $fieldType();\r\n@let currentFilterType = $currentFilterType();\r\n\r\n<button mat-icon-button class=\"open-menu-icon-button\" disableRipple [matMenuTriggerFor]=\"menu\" [matMenuTriggerRestoreFocus]=\"false\">\r\n  <mat-icon class=\"menu-icon\">more_vert</mat-icon>\r\n</button>\r\n<mat-menu #menu=\"matMenu\" >\r\n  @if (!(fieldType === FieldType.NotMapped))\r\n  {\r\n    <button color=\"primary\" mat-menu-item (click)=\"tableState.addGroupByKey(metaData.key)\">\r\n      <mat-icon color=\"primary\">group</mat-icon>\r\n      <span>Group By</span>\r\n    </button>\r\n  }\r\n  <button color=\"primary\" mat-menu-item (click)=hideField(metaData.key)>\r\n    <mat-icon color=\"primary\">visibility_off</mat-icon>\r\n    <span>Hide Column</span>\r\n  </button>\r\n  <div (keydown)=\"$event.stopImmediatePropagation()\">\r\n    @if (!(fieldType === FieldType.NotMapped))\r\n    {\r\n      <ng-form #myForm=\"ngForm\" class=\"tb-header-filter\" (keydown.enter)=\"onEnter(myForm.value, metaData)\">\r\n        @if(currentFilterType === FilterType.Or || currentFilterType === FilterType.In)\r\n        {\r\n          <tb-in-list-filter name='filterValue' [key]='metaData.key' [ngModel]=\"undefined\"/>\r\n        }\r\n        @else if(fieldType === FieldType.Link || fieldType === FieldType.String || fieldType === FieldType.Array || fieldType === FieldType.Unknown || fieldType === FieldType.PhoneNumber)\r\n        {\r\n          <mat-form-field stop-propagation class=\"font auto-width\">\r\n            <mat-icon matPrefix class=\"search-icon\">search</mat-icon>\r\n            <mat-label>{{currentFilterType === FilterType.StringDoesNotContain ? 'Does Not Contain...' : 'Contains...'}}</mat-label>\r\n            <input matInput name=\"filterValue\" [ngModel]=\"undefined\"/>\r\n            <span matSuffix [matTooltip]=\"currentFilterType === FilterType.StringDoesNotContain ? 'Contains' : 'Does Not Contain'\">\r\n              <button mat-icon-button color=\"primary\" class=\"header-filter-icon-button\" (click)=\"setStringFilterType()\">\r\n                <mat-icon [class]=\"{'chosen-icon': currentFilterType === FilterType.StringDoesNotContain }\">\r\n                  block\r\n                </mat-icon>\r\n              </button>\r\n            </span>\r\n          </mat-form-field>\r\n        }\r\n        @else if (fieldType === FieldType.Number || fieldType === FieldType.Currency)\r\n        {\r\n          <mat-form-field class=\"auto-width\" stop-propagation>\r\n            <mat-label>{{currentFilterType === FilterType.NumberEquals ? 'Equals...' : currentFilterType === FilterType.NumberLessThan ? 'Less Than...' : 'More Than...'}}</mat-label>\r\n            <input matInput type='number'  name=\"filterValue\" [ngModel]=\"undefined\" />\r\n            <span matPrefix class=\"tb-header-prefix\">\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.NumberLessThan }\"\r\n              (click)=\"setFilterType(FilterType.NumberLessThan)\">\r\n                <mat-icon  class=\"suffix-icons\"\r\n                  >\r\n                  arrow_back_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.NumberGreaterThan }\"\r\n              (click)=\"setFilterType(FilterType.NumberGreaterThan)\" >\r\n                <mat-icon  class=\"suffix-icons\">arrow_forward_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.NumberEquals }\"\r\n              (click)=\"setFilterType(FilterType.NumberEquals)\">\r\n                <span class=\"suffix-icons\">=</span>\r\n              </button>\r\n            </span>\r\n          </mat-form-field>\r\n        }\r\n        @else if (fieldType === FieldType.Boolean)\r\n        {\r\n          <div>\r\n            <label>\r\n              <mat-icon class=\"search-icon\">filter_list</mat-icon>\r\n            </label>\r\n            <mat-radio-group #ctrl=\"matRadioGroup\" #boolField='ngModel' stop-propagation class=\"font\" name=\"filterValue\" [ngModel]=\"undefined\" >\r\n              <mat-radio-button class=\"filter-radio-button\" [value]=\"true\" (click)=\"boolField.control.setValue(true);\">True</mat-radio-button><br/>\r\n              <mat-radio-button class=\"filter-radio-button\" [value]=\"false\" (click)=\"boolField.control.setValue(false)\">False</mat-radio-button><br/>\r\n            </mat-radio-group>\r\n          </div>\r\n        }\r\n        @else if (fieldType === FieldType.Date || fieldType === FieldType.DateTime)\r\n        {\r\n          <mat-form-field class=\"font auto-width\" stop-propagation >\r\n            <span matPrefix class=\"tb-header-prefix\">\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.DateOnOrAfter }\"\r\n                (click)=\"setFilterType(FilterType.DateOnOrAfter)\">\r\n                <mat-icon  class=\"suffix-icons underline\">arrow_forward_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.DateOnOrBefore  }\"\r\n                (click)=\"setFilterType(FilterType.DateOnOrBefore)\">\r\n                <mat-icon  class=\"suffix-icons underline\">arrow_back_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.DateIsOn }\"\r\n                (click)=\"setFilterType(FilterType.DateIsOn)\">\r\n                <span  class=\"suffix-icons underline\"> =</span>\r\n              </button>\r\n            </span>\r\n            <mat-label>{{currentFilterType === FilterType.DateIsOn ? 'On...' :\r\n              currentFilterType === FilterType.DateOnOrBefore ? 'On or Before...' : 'On or After...'}}</mat-label>\r\n            <input matInput name=\"filterValue\" [ngModel]=\"undefined\" [matDatepicker]=\"calendar\"\r\n              (click)=\"calendar.open()\"/>\r\n            <mat-datepicker-toggle class=\"date-toggle header-filter-icon-button\" matSuffix preventEnter [for]=\"calendar\" />\r\n            <mat-datepicker #calendar />\r\n          </mat-form-field>\r\n        }\r\n        <button mat-button disableRipple [disabled]=\"myForm.value.filterValue == undefined\" (click)=\"onEnter(myForm.value, metaData)\">\r\n          Apply\r\n        </button>\r\n      </ng-form>\r\n    }\r\n  </div>\r\n\r\n</mat-menu>\r\n", styles: [":host{--mat-button-filled-container-height: 24px;--mat-button-filled-touch-target-display: none;--mat-button-outlined-container-height: 24px;--mat-button-outlined-touch-target-display: none;--mat-button-protected-container-height: 24px;--mat-button-protected-touch-target-display: none;--mat-button-text-container-height: 24px;--mat-button-text-touch-target-display: none;--mat-button-tonal-container-height: 24px;--mat-button-tonal-touch-target-display: none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none;margin:0}.menu-icon{font-size:16px;line-height:16px;vertical-align:top;height:16px;width:16px}.search-icon{margin-right:16px;vertical-align:middle;height:24px;width:24px;color:#0000008a;font-size:21px;line-height:1.125}.font{font-size:14px}.filter-radio-button:first-of-type{padding-left:0}.filter-radio-button{padding:10px 40px;min-width:110px}.auto-width{width:260px;margin:5px;display:block;height:55px}.open-menu-icon-button{height:28px;width:28px;padding:6px}.header-filter-icon-button{height:18px;width:18px;font-size:18px;padding:0;margin:0 2px}.header-filter-icon-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.header-filter-icon-button .chosen-icon,.header-filter-icon-button.chosen-icon ::ng-deep *{height:22px;width:22px;font-size:22px;color:green}mat-icon.mat-icon.suffix-icons.underline{height:20px;text-decoration:underline .1px solid}.chosen-icon mat-icon.mat-icon.suffix-icons.underline{height:24px}::ng-deep .mat-mdc-form-field-icon-prefix:has(.tb-header-prefix),.tb-header-prefix{padding:0;flex-basis:36%}.tb-header-filter ::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}.tb-header-filter ::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"], dependencies: [{ kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatButton, selector: "    button[matButton], a[matButton], button[mat-button], button[mat-raised-button],    button[mat-flat-button], button[mat-stroked-button], a[mat-button], a[mat-raised-button],    a[mat-flat-button], a[mat-stroked-button]  ", inputs: ["matButton"], exportAs: ["matButton", "matAnchor"] }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i2.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "component", type: InListFilterComponent, selector: "tb-in-list-filter", inputs: ["values", "key"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i1$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i1$1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i1$1.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i1$1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }, { kind: "ngmodule", type: MatRadioModule }, { kind: "directive", type: i8.MatRadioGroup, selector: "mat-radio-group", inputs: ["color", "name", "labelPosition", "value", "selected", "disabled", "required", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioGroup"] }, { kind: "component", type: i8.MatRadioButton, selector: "mat-radio-button", inputs: ["id", "name", "aria-label", "aria-labelledby", "aria-describedby", "disableRipple", "tabIndex", "checked", "value", "labelPosition", "disabled", "required", "color", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioButton"] }, { kind: "ngmodule", type: MatDatepickerModule }, { kind: "component", type: i3.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i3.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: i3.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ColumnHeaderMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-header-menu', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatMenuModule, MatIconModule, MatButtonModule, FormsModule, InListFilterComponent,
                        MatInputModule, MatTooltipModule, StopPropagationDirective, MatRadioModule, MatDatepickerModule
                    ], template: "@let metaData = $metaData();\r\n@let fieldType = $fieldType();\r\n@let currentFilterType = $currentFilterType();\r\n\r\n<button mat-icon-button class=\"open-menu-icon-button\" disableRipple [matMenuTriggerFor]=\"menu\" [matMenuTriggerRestoreFocus]=\"false\">\r\n  <mat-icon class=\"menu-icon\">more_vert</mat-icon>\r\n</button>\r\n<mat-menu #menu=\"matMenu\" >\r\n  @if (!(fieldType === FieldType.NotMapped))\r\n  {\r\n    <button color=\"primary\" mat-menu-item (click)=\"tableState.addGroupByKey(metaData.key)\">\r\n      <mat-icon color=\"primary\">group</mat-icon>\r\n      <span>Group By</span>\r\n    </button>\r\n  }\r\n  <button color=\"primary\" mat-menu-item (click)=hideField(metaData.key)>\r\n    <mat-icon color=\"primary\">visibility_off</mat-icon>\r\n    <span>Hide Column</span>\r\n  </button>\r\n  <div (keydown)=\"$event.stopImmediatePropagation()\">\r\n    @if (!(fieldType === FieldType.NotMapped))\r\n    {\r\n      <ng-form #myForm=\"ngForm\" class=\"tb-header-filter\" (keydown.enter)=\"onEnter(myForm.value, metaData)\">\r\n        @if(currentFilterType === FilterType.Or || currentFilterType === FilterType.In)\r\n        {\r\n          <tb-in-list-filter name='filterValue' [key]='metaData.key' [ngModel]=\"undefined\"/>\r\n        }\r\n        @else if(fieldType === FieldType.Link || fieldType === FieldType.String || fieldType === FieldType.Array || fieldType === FieldType.Unknown || fieldType === FieldType.PhoneNumber)\r\n        {\r\n          <mat-form-field stop-propagation class=\"font auto-width\">\r\n            <mat-icon matPrefix class=\"search-icon\">search</mat-icon>\r\n            <mat-label>{{currentFilterType === FilterType.StringDoesNotContain ? 'Does Not Contain...' : 'Contains...'}}</mat-label>\r\n            <input matInput name=\"filterValue\" [ngModel]=\"undefined\"/>\r\n            <span matSuffix [matTooltip]=\"currentFilterType === FilterType.StringDoesNotContain ? 'Contains' : 'Does Not Contain'\">\r\n              <button mat-icon-button color=\"primary\" class=\"header-filter-icon-button\" (click)=\"setStringFilterType()\">\r\n                <mat-icon [class]=\"{'chosen-icon': currentFilterType === FilterType.StringDoesNotContain }\">\r\n                  block\r\n                </mat-icon>\r\n              </button>\r\n            </span>\r\n          </mat-form-field>\r\n        }\r\n        @else if (fieldType === FieldType.Number || fieldType === FieldType.Currency)\r\n        {\r\n          <mat-form-field class=\"auto-width\" stop-propagation>\r\n            <mat-label>{{currentFilterType === FilterType.NumberEquals ? 'Equals...' : currentFilterType === FilterType.NumberLessThan ? 'Less Than...' : 'More Than...'}}</mat-label>\r\n            <input matInput type='number'  name=\"filterValue\" [ngModel]=\"undefined\" />\r\n            <span matPrefix class=\"tb-header-prefix\">\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.NumberLessThan }\"\r\n              (click)=\"setFilterType(FilterType.NumberLessThan)\">\r\n                <mat-icon  class=\"suffix-icons\"\r\n                  >\r\n                  arrow_back_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.NumberGreaterThan }\"\r\n              (click)=\"setFilterType(FilterType.NumberGreaterThan)\" >\r\n                <mat-icon  class=\"suffix-icons\">arrow_forward_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.NumberEquals }\"\r\n              (click)=\"setFilterType(FilterType.NumberEquals)\">\r\n                <span class=\"suffix-icons\">=</span>\r\n              </button>\r\n            </span>\r\n          </mat-form-field>\r\n        }\r\n        @else if (fieldType === FieldType.Boolean)\r\n        {\r\n          <div>\r\n            <label>\r\n              <mat-icon class=\"search-icon\">filter_list</mat-icon>\r\n            </label>\r\n            <mat-radio-group #ctrl=\"matRadioGroup\" #boolField='ngModel' stop-propagation class=\"font\" name=\"filterValue\" [ngModel]=\"undefined\" >\r\n              <mat-radio-button class=\"filter-radio-button\" [value]=\"true\" (click)=\"boolField.control.setValue(true);\">True</mat-radio-button><br/>\r\n              <mat-radio-button class=\"filter-radio-button\" [value]=\"false\" (click)=\"boolField.control.setValue(false)\">False</mat-radio-button><br/>\r\n            </mat-radio-group>\r\n          </div>\r\n        }\r\n        @else if (fieldType === FieldType.Date || fieldType === FieldType.DateTime)\r\n        {\r\n          <mat-form-field class=\"font auto-width\" stop-propagation >\r\n            <span matPrefix class=\"tb-header-prefix\">\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.DateOnOrAfter }\"\r\n                (click)=\"setFilterType(FilterType.DateOnOrAfter)\">\r\n                <mat-icon  class=\"suffix-icons underline\">arrow_forward_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.DateOnOrBefore  }\"\r\n                (click)=\"setFilterType(FilterType.DateOnOrBefore)\">\r\n                <mat-icon  class=\"suffix-icons underline\">arrow_back_ios</mat-icon>\r\n              </button>\r\n              <button mat-icon-button disableRipple class=\"header-filter-icon-button\" [class]=\"{'chosen-icon': currentFilterType === FilterType.DateIsOn }\"\r\n                (click)=\"setFilterType(FilterType.DateIsOn)\">\r\n                <span  class=\"suffix-icons underline\"> =</span>\r\n              </button>\r\n            </span>\r\n            <mat-label>{{currentFilterType === FilterType.DateIsOn ? 'On...' :\r\n              currentFilterType === FilterType.DateOnOrBefore ? 'On or Before...' : 'On or After...'}}</mat-label>\r\n            <input matInput name=\"filterValue\" [ngModel]=\"undefined\" [matDatepicker]=\"calendar\"\r\n              (click)=\"calendar.open()\"/>\r\n            <mat-datepicker-toggle class=\"date-toggle header-filter-icon-button\" matSuffix preventEnter [for]=\"calendar\" />\r\n            <mat-datepicker #calendar />\r\n          </mat-form-field>\r\n        }\r\n        <button mat-button disableRipple [disabled]=\"myForm.value.filterValue == undefined\" (click)=\"onEnter(myForm.value, metaData)\">\r\n          Apply\r\n        </button>\r\n      </ng-form>\r\n    }\r\n  </div>\r\n\r\n</mat-menu>\r\n", styles: [":host{--mat-button-filled-container-height: 24px;--mat-button-filled-touch-target-display: none;--mat-button-outlined-container-height: 24px;--mat-button-outlined-touch-target-display: none;--mat-button-protected-container-height: 24px;--mat-button-protected-touch-target-display: none;--mat-button-text-container-height: 24px;--mat-button-text-touch-target-display: none;--mat-button-tonal-container-height: 24px;--mat-button-tonal-touch-target-display: none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none;margin:0}.menu-icon{font-size:16px;line-height:16px;vertical-align:top;height:16px;width:16px}.search-icon{margin-right:16px;vertical-align:middle;height:24px;width:24px;color:#0000008a;font-size:21px;line-height:1.125}.font{font-size:14px}.filter-radio-button:first-of-type{padding-left:0}.filter-radio-button{padding:10px 40px;min-width:110px}.auto-width{width:260px;margin:5px;display:block;height:55px}.open-menu-icon-button{height:28px;width:28px;padding:6px}.header-filter-icon-button{height:18px;width:18px;font-size:18px;padding:0;margin:0 2px}.header-filter-icon-button ::ng-deep *{line-height:initial;font-size:initial;height:18px;width:18px;font-size:18px;bottom:initial}.header-filter-icon-button .chosen-icon,.header-filter-icon-button.chosen-icon ::ng-deep *{height:22px;width:22px;font-size:22px;color:green}mat-icon.mat-icon.suffix-icons.underline{height:20px;text-decoration:underline .1px solid}.chosen-icon mat-icon.mat-icon.suffix-icons.underline{height:24px}::ng-deep .mat-mdc-form-field-icon-prefix:has(.tb-header-prefix),.tb-header-prefix{padding:0;flex-basis:36%}.tb-header-filter ::ng-deep .mat-mdc-form-field-subscript-wrapper{line-height:0}.tb-header-filter ::ng-deep .mat-mdc-form-field-subscript-wrapper:before{height:0}.date-toggle ::ng-deep svg{position:absolute;left:0;top:0}\n"] }]
        }] });

class ColumnTotalPipe {
    transform(data, metaData) {
        const dataToCalculate = data.filter(d => !d.isGroupHeader);
        switch (metaData.additional.footer.type) {
            case 'sum':
                return sumBy(dataToCalculate, metaData.key);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ColumnTotalPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: ColumnTotalPipe, isStandalone: true, name: "columnTotal" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ColumnTotalPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'columnTotal',
                }]
        }] });

const calculateWidths = (metaData, userDefinedWidth) => {
    const definedWidth = (userDefinedWidth && `${userDefinedWidth}px`) || metaData.width;
    return definedWidth;
};
function calculateUserDefinedWidth(userDefinedWidth) {
    if (userDefinedWidth)
        return { flex: `0 0 ${userDefinedWidth}px`, maxWidth: 'none' };
    return undefined;
}
function calculateTableDefinedWidth(metaData, tableSettingsMinWidth) {
    if (metaData.width)
        return ({ flex: `0 0 ${metaData.width}`, maxWidth: 'none' });
    const style = { flex: `${1}` };
    if (tableSettingsMinWidth)
        style['minWidth'] = `${tableSettingsMinWidth}px`;
    return style;
}
const calculateFlexWidth = (metaData, userDefinedWidth, tableSettingsMinWidth) => {
    const definedWidth = calculateWidths(metaData, userDefinedWidth);
    if (definedWidth)
        return ({ flex: `0 0 ${definedWidth}`, maxWidth: 'none' });
    const style = { flex: `${1}` };
    if (tableSettingsMinWidth)
        style['minWidth'] = `${tableSettingsMinWidth}px`;
    return style;
};
const columnStyles = (metaData, userDefinedWidth, tableSettingsMinWidth) => {
    const fullMetaStyles = metaData.additional?.styles ?? {};
    const userWidth = calculateUserDefinedWidth(userDefinedWidth) ?? {};
    const tableWidth = userDefinedWidth ? {} : calculateTableDefinedWidth(metaData, tableSettingsMinWidth);
    const styles = {
        header: { ...tableWidth, ...fullMetaStyles, ...metaData.additional?.columnPartStyles?.header, ...userWidth },
        footer: { ...tableWidth, ...fullMetaStyles, ...metaData.additional?.columnPartStyles?.footer, ...userWidth },
        innerBody: { ...metaData.additional?.columnPartStyles?.innerBody },
        body: { ...tableWidth, ...fullMetaStyles, ...metaData.additional?.columnPartStyles?.body, ...userWidth },
    };
    return styles;
};
const calculateFlexWidths = (metaDatas, userDefinedWidths, tableSettingsMinWidth) => {
    return metaDataArrToDict(metaDatas, md => calculateFlexWidth(md, userDefinedWidths[md.key], tableSettingsMinWidth));
};
const columnsStyles = (metaDatas, userDefinedWidths) => {
    return metaDataArrToDict(metaDatas, md => columnStyles(md, userDefinedWidths[md.key]));
};

class ColumnBuilderComponent {
    constructor() {
        this.FieldType = FieldType;
        this.config = inject(TableBuilderConfigToken);
        this.table = inject(MatTable);
        this.state = inject(TableStore);
        this.templateService = inject(TableTemplateService);
        this.tableConfig = inject(TableBuilderConfigToken);
        this.injector = inject(Injector);
        this.$columnDef = viewChild(MatColumnDef);
        this.$bodyTemplate = viewChild('body');
        this.$metaData = signal(undefined);
        this.$additional = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return;
            const linkInfo = this.state.$getLinkInfo(metaData)();
            if (linkInfo) {
                return linkInfo;
            }
            if (metaData.fieldType === FieldType.Array) {
                return metaData.additional?.limit || this.tableConfig?.arrayDefaults?.limit;
            }
            return undefined;
        });
        this.$customCell = signal(undefined);
        this.$transform = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return;
            return createTransformer(metaData, this.config);
        });
        this.$innerTemplate = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return;
            return metaData.template || this.$customCell()?.$templateRef() || this.templateService.getTemplate(metaData);
        });
        this.$showFilters = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return;
            const settings = this.state.$tableSettings();
            return !(settings.hideColumnHeaderFilters || metaData.noFilter);
        });
        this.$outerTemplate = computed(() => {
            return this.$customCell()?.columnDef?.cell?.template ?? this.$bodyTemplate();
        });
        this.$classes = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return;
            if (metaData.fieldType === FieldType.Currency) {
                return ({
                    ['negative-currency']: (element) => element[metaData.key] < 0,
                    ...metaData.classes
                });
            }
            return metaData.classes;
        });
        this.$styles = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return;
            return columnStyles(metaData, this.state.$getUserDefinedWidth(metaData.key)(), this.state.$tableSettingsMinWidth());
        });
        this.viewInited = false;
        this.onViewInit = () => { };
        this.whenViewInited = (callback) => {
            if (this.viewInited) {
                callback();
                return;
            }
            this.onViewInit = callback;
        };
        this.getTooltip = (element) => {
            const metaData = this.$metaData();
            if (!metaData?.toolTip)
                return;
            if (typeof metaData.toolTip === 'string') {
                return metaData.toolTip;
            }
            return metaData.toolTip(element);
        };
    }
    setMetaData(md) {
        this.$metaData.set(md);
    }
    ngAfterViewInit() {
        this.table.addColumnDef(this.$columnDef());
        this.onViewInit();
        this.viewInited = true;
    }
    cellClicked(element, key, event) {
        const metaData = this.$metaData();
        if (metaData?.click) {
            metaData.click(element, key, event);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ColumnBuilderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ColumnBuilderComponent, isStandalone: true, selector: "ng-component", viewQueries: [{ propertyName: "$columnDef", first: true, predicate: MatColumnDef, descendants: true, isSignal: true }, { propertyName: "$bodyTemplate", first: true, predicate: ["body"], descendants: true, isSignal: true }], ngImport: i0, template: "@let metaData = $metaData();\r\n@let customCell = $customCell();\r\n@let styles = $styles()!;\r\n\r\n@if(metaData)\r\n{\r\n  <ng-container [matColumnDef]=\"metaData.key\">\r\n\r\n    <!-- header -->\r\n    <ng-template #myHeader matHeaderCellDef>\r\n      <mat-header-cell class=\"column-head\" cdkDrag resizeColumn [style]='styles?.header' [key]=\"metaData.key\"\r\n        [class]='metaData.additional?.columnPartClasses?.header'>\r\n        <div class=\"header-container\" cdkDragHandle>\r\n          @if(!customCell?.columnDef?.headerCell)\r\n          {\r\n              @if(metaData.fieldType !== FieldType.NotMapped || !!metaData.sortLogic?.sortBy)\r\n              {\r\n                <div mat-sort-header style=\"width: 100%\" [disabled]=\"metaData.noSort\">\r\n                  {{ metaData.displayName ?  metaData.displayName : ( metaData.key | spaceCase ) }}\r\n                </div>\r\n              }\r\n              @else if(metaData.fieldType === FieldType.NotMapped)\r\n              {\r\n                <div style=\"width: 100%\">\r\n                  {{ metaData.displayName ?  metaData.displayName : ( metaData.key | spaceCase ) }}\r\n                </div>\r\n              }\r\n              @if($showFilters())\r\n              {\r\n                <tb-header-menu #menu [metaData]='metaData' />\r\n              }\r\n          }\r\n          @else\r\n          {\r\n            <ng-container *ngTemplateOutlet=\"customCell!.columnDef!.headerCell.template; context: {metaData: metaData, styles:  styles?.header} \" />\r\n          }\r\n        </div>\r\n      </mat-header-cell>\r\n    </ng-template>\r\n  \r\n    <!-- body -->\r\n    <ng-container *matCellDef=\"let element;\">\r\n      <ng-container *ngTemplateOutlet=\"$outerTemplate()!; context: { metaData: metaData, element: element , styles: styles?.body, $implicit: element }\"/>\r\n    </ng-container>\r\n    <ng-template #body let-element='element' >\r\n      <mat-cell  [matTooltip]=\"metaData.toolTip ? (getTooltip | func : element) : ''\" \r\n        [conditionalClasses]='metaData.classes' [element]='element' [styler]='styles.body'\r\n        (click)='cellClicked(element, metaData.key, $event)' >\r\n        <ng-container *ngTemplateOutlet=\"$innerTemplate()!;\r\n          context: {\r\n            value: ($transform()! | func : element),\r\n            element: element,\r\n            additional: $additional(),\r\n            innerStyles: styles.innerBody,\r\n            $implicit: element\r\n            }; Injector: injector\" />\r\n      </mat-cell>\r\n    </ng-template>\r\n  \r\n    <!-- footer -->\r\n    <ng-template matFooterCellDef>\r\n      @if(customCell?.columnDef?.footerCell)\r\n      {\r\n        <ng-container\r\n        *ngTemplateOutlet=\"customCell!.columnDef!.footerCell.template;\r\n        context: {metaData: metaData, data: $data, styles : styles.footer }\"/>\r\n      }\r\n      @else\r\n      {\r\n        @let data = $data();\r\n        <mat-footer-cell  [style]='styles.footer' [class]='metaData.additional?.columnPartClasses?.footer'>\r\n          @if(!!data?.length && metaData.additional?.footer)\r\n          {\r\n            <span class=\"bold\">\r\n              @switch (metaData.fieldType)\r\n              {\r\n                @case (FieldType.Currency) { {{ data | columnTotal: metaData | currency }} }\r\n                @case (FieldType.Number) { {{ data | columnTotal: metaData | number }} }\r\n              }\r\n            </span>\r\n          }\r\n  \r\n        </mat-footer-cell>\r\n      }\r\n    </ng-template>\r\n  </ng-container>\r\n}", styles: [".header-container{display:flex;flex-direction:row;width:100%;align-items:center}.negative-currency{color:red}.column-head{position:relative}.bold,.group-footer{font-weight:900}.cdk-drag-preview{background:#fff;border-radius:4px;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.cdk-drag-placeholder{opacity:33%;border-right-width:0px}.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.drag-handle{color:#add8e6;cursor:move;margin-right:9px}\n"], dependencies: [{ kind: "ngmodule", type: MatTableModule }, { kind: "directive", type: i1$6.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { kind: "directive", type: i1$6.MatColumnDef, selector: "[matColumnDef]", inputs: ["matColumnDef"] }, { kind: "directive", type: i1$6.MatCellDef, selector: "[matCellDef]" }, { kind: "directive", type: i1$6.MatFooterCellDef, selector: "[matFooterCellDef]" }, { kind: "directive", type: i1$6.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { kind: "directive", type: i1$6.MatCell, selector: "mat-cell, td[mat-cell]" }, { kind: "directive", type: i1$6.MatFooterCell, selector: "mat-footer-cell, td[mat-footer-cell]" }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: ResizeColumnDirective, selector: "[resizeColumn]", inputs: ["resizeColumn", "key"] }, { kind: "pipe", type: FunctionPipe, name: "func" }, { kind: "directive", type: StylerDirective, selector: "[styler]", inputs: ["element", "styler"] }, { kind: "directive", type: ConditionalClassesDirective, selector: "[conditionalClasses]", inputs: ["element", "conditionalClasses"] }, { kind: "ngmodule", type: DragDropModule }, { kind: "directive", type: i5.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer", "cdkDragScale"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "directive", type: i5.CdkDragHandle, selector: "[cdkDragHandle]", inputs: ["cdkDragHandleDisabled"] }, { kind: "ngmodule", type: MatSortModule }, { kind: "component", type: i3$2.MatSortHeader, selector: "[mat-sort-header]", inputs: ["mat-sort-header", "arrowPosition", "start", "disabled", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }, { kind: "component", type: ColumnHeaderMenuComponent, selector: "tb-header-menu", inputs: ["metaData"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "pipe", type: ColumnTotalPipe, name: "columnTotal" }, { kind: "pipe", type: CurrencyPipe, name: "currency" }, { kind: "pipe", type: DecimalPipe, name: "number" }], viewProviders: [
            { provide: CDK_DROP_LIST, useExisting: CdkDropList },
        ], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ColumnBuilderComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, viewProviders: [
                        { provide: CDK_DROP_LIST, useExisting: CdkDropList },
                    ], imports: [
                        MatTableModule, NgTemplateOutlet, ResizeColumnDirective, FunctionPipe, StylerDirective,
                        ConditionalClassesDirective, DragDropModule, MatSortModule, SpaceCasePipe, ColumnHeaderMenuComponent,
                        MatTooltipModule, ColumnTotalPipe, CurrencyPipe, DecimalPipe
                    ], template: "@let metaData = $metaData();\r\n@let customCell = $customCell();\r\n@let styles = $styles()!;\r\n\r\n@if(metaData)\r\n{\r\n  <ng-container [matColumnDef]=\"metaData.key\">\r\n\r\n    <!-- header -->\r\n    <ng-template #myHeader matHeaderCellDef>\r\n      <mat-header-cell class=\"column-head\" cdkDrag resizeColumn [style]='styles?.header' [key]=\"metaData.key\"\r\n        [class]='metaData.additional?.columnPartClasses?.header'>\r\n        <div class=\"header-container\" cdkDragHandle>\r\n          @if(!customCell?.columnDef?.headerCell)\r\n          {\r\n              @if(metaData.fieldType !== FieldType.NotMapped || !!metaData.sortLogic?.sortBy)\r\n              {\r\n                <div mat-sort-header style=\"width: 100%\" [disabled]=\"metaData.noSort\">\r\n                  {{ metaData.displayName ?  metaData.displayName : ( metaData.key | spaceCase ) }}\r\n                </div>\r\n              }\r\n              @else if(metaData.fieldType === FieldType.NotMapped)\r\n              {\r\n                <div style=\"width: 100%\">\r\n                  {{ metaData.displayName ?  metaData.displayName : ( metaData.key | spaceCase ) }}\r\n                </div>\r\n              }\r\n              @if($showFilters())\r\n              {\r\n                <tb-header-menu #menu [metaData]='metaData' />\r\n              }\r\n          }\r\n          @else\r\n          {\r\n            <ng-container *ngTemplateOutlet=\"customCell!.columnDef!.headerCell.template; context: {metaData: metaData, styles:  styles?.header} \" />\r\n          }\r\n        </div>\r\n      </mat-header-cell>\r\n    </ng-template>\r\n  \r\n    <!-- body -->\r\n    <ng-container *matCellDef=\"let element;\">\r\n      <ng-container *ngTemplateOutlet=\"$outerTemplate()!; context: { metaData: metaData, element: element , styles: styles?.body, $implicit: element }\"/>\r\n    </ng-container>\r\n    <ng-template #body let-element='element' >\r\n      <mat-cell  [matTooltip]=\"metaData.toolTip ? (getTooltip | func : element) : ''\" \r\n        [conditionalClasses]='metaData.classes' [element]='element' [styler]='styles.body'\r\n        (click)='cellClicked(element, metaData.key, $event)' >\r\n        <ng-container *ngTemplateOutlet=\"$innerTemplate()!;\r\n          context: {\r\n            value: ($transform()! | func : element),\r\n            element: element,\r\n            additional: $additional(),\r\n            innerStyles: styles.innerBody,\r\n            $implicit: element\r\n            }; Injector: injector\" />\r\n      </mat-cell>\r\n    </ng-template>\r\n  \r\n    <!-- footer -->\r\n    <ng-template matFooterCellDef>\r\n      @if(customCell?.columnDef?.footerCell)\r\n      {\r\n        <ng-container\r\n        *ngTemplateOutlet=\"customCell!.columnDef!.footerCell.template;\r\n        context: {metaData: metaData, data: $data, styles : styles.footer }\"/>\r\n      }\r\n      @else\r\n      {\r\n        @let data = $data();\r\n        <mat-footer-cell  [style]='styles.footer' [class]='metaData.additional?.columnPartClasses?.footer'>\r\n          @if(!!data?.length && metaData.additional?.footer)\r\n          {\r\n            <span class=\"bold\">\r\n              @switch (metaData.fieldType)\r\n              {\r\n                @case (FieldType.Currency) { {{ data | columnTotal: metaData | currency }} }\r\n                @case (FieldType.Number) { {{ data | columnTotal: metaData | number }} }\r\n              }\r\n            </span>\r\n          }\r\n  \r\n        </mat-footer-cell>\r\n      }\r\n    </ng-template>\r\n  </ng-container>\r\n}", styles: [".header-container{display:flex;flex-direction:row;width:100%;align-items:center}.negative-currency{color:red}.column-head{position:relative}.bold,.group-footer{font-weight:900}.cdk-drag-preview{background:#fff;border-radius:4px;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.cdk-drag-placeholder{opacity:33%;border-right-width:0px}.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.drag-handle{color:#add8e6;cursor:move;margin-right:9px}\n"] }]
        }] });

// If we are only sorting due to a change in the Sorts[] we can 'optimize'. If the sort array was first by column a asc then by column b desc then by column c asc,
// and now it is first by column d asc then by column a desc then by column b desc then by column c asc, we dont need to rerun the tail, i.e. for culumn b and c.
// So we need to calculate the matching tail of the sort array. Then sortsToRun will be the non-matching head.
// But if any sorts were removed the only way to 'unsort' is to start by the original data and run all the existing sorts again, so 'sorts to run' will be all
// the sorts.
// We always pass allSorts to the container because if the table data changes all the sorts will need to be run.
function updateSortState(previousSorts, currentSorts) {
    currentSorts = addInitSort(currentSorts);
    if (sortsRemoved(previousSorts.allSorts, currentSorts)) {
        return ({ sortsToRun: currentSorts, allSorts: currentSorts });
    }
    const sameTailLength = getSameTailLength(previousSorts.allSorts, currentSorts);
    const sortsToRun = currentSorts.slice(0, currentSorts.length - sameTailLength);
    return ({ sortsToRun, allSorts: currentSorts });
}
function addInitSort(sorts) {
    return [...sorts, { active: initIndexSymbol, direction: 'asc' }];
}
function sortsRemoved(previousSorts, currentSorts) {
    const previousSortedColumns = previousSorts.map(s => s.active);
    const currentSortedColumns = currentSorts.map(s => s.active);
    const sortsRemoved = !!difference(previousSortedColumns, currentSortedColumns).length;
    return sortsRemoved;
}
function getSameTailLength(previousSorts, currentSorts) {
    previousSorts = [...previousSorts].reverse();
    currentSorts = [...currentSorts].reverse();
    let indexOfChange = currentSorts.findIndex((s, i) => s.active !== previousSorts[i]?.active || s.direction !== previousSorts[i]?.direction);
    if (indexOfChange === -1)
        return indexOfChange = currentSorts.length;
    return indexOfChange;
}
const initIndexSymbol = Symbol('tb_init_index');
const initialSortState = { sortsToRun: [], allSorts: [] };

class DataStore extends ComponentStore {
    constructor() {
        super({ ...defaultDataState });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DataStore, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DataStore }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: DataStore, decorators: [{
            type: Injectable
        }], ctorParameters: () => [] });

const supportsGroupBy = typeof Object.groupBy === 'function';
function getGroupedData(data, groupByKeys) {
    return tbGroupBy(data, groupByKeys);
}
let tbGroupBy = (data, groupByKeys, level = 1, parentGroupName) => {
    const currentKey = groupByKeys[0];
    const groupedDataArr = groupData(currentKey, data, level, parentGroupName);
    const remainingGroupByKeys = groupByKeys.slice(1);
    const hasChildrenGroups = !!remainingGroupByKeys.length;
    if (hasChildrenGroups) {
        //group the children by iterating over each group and grouping it by the next keys
        const groupOfGroups = groupedDataArr.map((group) => {
            const children = group.children;
            const groupGroup = {
                groupName: group.groupName,
                groupHeaderDisplay: group.groupHeaderDisplay,
                uniqueName: group.uniqueName,
                key: currentKey,
                hasTheData: false,
                isGroupHeader: true,
                padding: group.padding,
                level: group.level,
                length: group.length,
                groups: tbGroupBy(children, remainingGroupByKeys, level + 1, group.groupName),
                [initIndexSymbol]: group[initIndexSymbol],
                custom: false
            };
            return groupGroup;
        });
        return groupOfGroups;
    }
    return groupedDataArr;
};
function groupData(groupByKey, groupData, level = 1, parentGroupName) {
    const getter = getFactory(groupByKey);
    const groupedDataDict = supportsGroupBy ? Object.groupBy(groupData, d => getter(d) ?? null) : groupBy(groupData, groupByKey);
    const groupedDataArr = Object.entries(groupedDataDict).map(([name, groupData]) => {
        const uniqueName = parentGroupName ? `${parentGroupName}-${name}` : `${name}`;
        return {
            isGroupHeader: true,
            groupHeaderDisplay: name,
            hasTheData: true,
            children: groupData,
            groupName: `tb_group_${uniqueName}`,
            padding: 1 + (20 * (level - 1)),
            key: groupByKey,
            length: groupData.length,
            uniqueName,
            level,
            custom: false,
            [initIndexSymbol]: uniqueName,
        };
    });
    return groupedDataArr;
}
function setCustomGroupBy(customGroupBy) {
    tbGroupBy = customGroupBy;
}
function updateGroupByState(groupedData, { data, groups, expanded }, firstRun) {
    if (firstRun
        || dataUpdated(data, groups, expanded)
        || groupsUpdated(groups, expanded)) {
        groupedData = groups.value.length ? getGroupedData(data.value, groups.value) : data.value;
    }
    const newDisplayData = expanded.value.length === 0
        ? groupedData
        : groupedData.map(group => mapGroupHeader(group, expanded.value.flatMap(g => g.expandedHeaders))).flat();
    return ({ displayData: newDisplayData, groupedData });
}
function mapGroupHeader(obj, expandedHeaders) {
    const showChildren = expandedHeaders === true || expandedHeaders.includes(obj.uniqueName);
    const children = !showChildren ? [] :
        obj.hasTheData ? obj.children
            : obj.groups.map(a => mapGroupHeader(a, expandedHeaders));
    return [obj, ...children].flat();
}
function dataUpdated(data, groups, expandedGroups) {
    return data.timestamp > groups.timestamp && data.timestamp > expandedGroups.timestamp;
}
function groupsUpdated(groups, expandedGroups) {
    return groups.timestamp >= expandedGroups.timestamp;
}
const initialGroupByState = { displayData: [], groupedData: [] };
const getAllGroupHeaderNames = (data) => {
    const groups = getGroupHeaders(data, (d) => d.isGroupHeader);
    const a = supportsGroupBy ? Object.groupBy(groups, group => group.key) : groupBy(groups, 'key');
    return Object.entries(a).reduce((names, [key, groups]) => {
        names[key] = groups.map(g => ({ uniqueName: g.uniqueName, key: g.key }));
        return names;
    }, {});
};
const getAllGroupHeaderNamesByKeys = (data, keys) => {
    const groups = getGroupHeaders(data, (d) => d.isGroupHeader && keys.includes(d.key));
    return supportsGroupBy ? Object.groupBy(groups, group => group.key) : groupBy(groups, 'key');
};
const getGroupHeaders = (data, filterFunc, arr = []) => {
    const headers = data.filter(filterFunc);
    arr.push(...headers);
    headers.forEach(h => { if (h.hasTheData === false && !!h.groups.length)
        getGroupHeaders(h.groups, filterFunc, arr); });
    return arr;
};

class GenericTableComponent {
    constructor() {
        this.state = inject(TableStore);
        this.dataStore = inject(DataStore);
        this.viewContainer = inject(ViewContainerRef);
        this.config = inject(TableBuilderConfigToken);
        this._injector = inject(Injector);
        this.smallFooter = 10;
        this.$headerRow = viewChild(MatHeaderRowDef);
        this.$footerRow = viewChild(MatFooterRowDef);
        this.$table = viewChild(MatTable);
        this.$dropList = viewChild(CdkDropList);
        this.selection$ = output({ alias: 'selection' });
        this.$displayDataLength = input.required({ alias: 'displayDataLength' });
        this.$data = input.required({ alias: 'data' });
        this.$rows = input([], { alias: 'rows' });
        this.$columnInfos = input.required({ alias: 'columnInfos' });
        this.$dataSource = input.required({ alias: 'dataSource' });
        this.$keys = computed(() => {
            const displayed = this.state.$orderedVisibleColumns();
            const built = this.$columns();
            const keys = displayed.filter(d => !!built[d]);
            if (this.$hasSelectColumn()) {
                keys.unshift('select');
            }
            if (this.$hasIndexColumn()) {
                keys.unshift('index');
            }
            return keys;
        });
        this.keys$ = toObservable(this.$keys);
        this.$trackBy = input(undefined, { alias: 'trackBy' });
        this.$trackByFunction = computed(() => {
            const trackBy = this.$trackBy();
            if (!trackBy)
                return (index, item) => item[initIndexSymbol];
            return ((index, item) => item[trackBy]);
        });
        this.$hasFooterMeta = computed(() => this.state.$metaDataArray().some(md => !!md.additional?.footer));
        this.$hasCustomFooter = computed(() => this.$columnInfos()?.some(ci => !!ci.customCell?.columnDef?.footerCell));
        this.$footerRowStyle = computed(() => {
            const hasData = !!this.$displayDataLength();
            const metaFooter = this.$hasFooterMeta();
            const customFooter = this.$hasCustomFooter();
            const hasSelectionColumn = this.state.$props().selectionColumn;
            return customFooter || hasSelectionColumn || (hasData && metaFooter) ? 'regular-footer' : hasData ? 'no-footer' : 'small-footer';
        });
        this.$showFooterRow = computed(() => this.$footerRowStyle() !== 'no-footer');
        this.injector = Injector.create({
            providers: [
                { provide: MatTable, useFactory: () => this.$table() },
                { provide: CdkDropList, useFactory: () => this.$dropList() },
            ],
            parent: this._injector
        });
        this.$hasIndexColumn = computed(() => this.state.selectSignal(state => state.props.indexColumn)());
        this.$columns = signal({});
        this.$showHeader = computed(() => !this.state.$tableSettings().hideColumnHeader);
        this.$offset = this.dataStore.selectSignal(s => s.virtualScrollOffset);
        this.#buildColumnsEffect = effect(() => {
            const columnInfos = this.$columnInfos() || [];
            const table = this.$table();
            if (!table)
                return;
            untracked(() => {
                Object.entries(this.$columns()).forEach(([key, value]) => {
                    const columnInfo = columnInfos.find(ci => ci.metaData.key === key);
                    if (!columnInfo || columnInfo.customCell !== value.$customCell()) {
                        delete this.$columns()[key];
                        table?.removeColumnDef(value.$columnDef());
                    }
                });
                columnInfos.forEach(ci => this.buildColumn(ci));
            });
        });
        this.#buildRowsEffect = effect(() => {
            const table = this.$table();
            const rows = this.$rows();
            const keys = this.$keys();
            if (!table)
                return;
            untracked(() => {
                rows.forEach(row => {
                    table.removeRowDef(row);
                    row.columns = keys;
                    table.addRowDef(row);
                });
            });
        });
        this.#buildHeaderRowEffect = effect(() => {
            const headerRow = this.$headerRow();
            const showHeader = this.$showHeader();
            const table = this.$table();
            untracked(() => {
                if (headerRow && showHeader && table)
                    table.addHeaderRowDef(headerRow);
                else if (headerRow && table)
                    table.removeHeaderRowDef(headerRow);
            });
        });
        this.#buildFooterEffect = effect(() => {
            const footerRow = this.$footerRow();
            const showFooter = this.$showFooterRow();
            const table = this.$table();
            untracked(() => {
                if (footerRow && showFooter && table)
                    table.addFooterRowDef(footerRow);
                else if (footerRow && table)
                    table.removeFooterRowDef(footerRow);
            });
        });
        this.$usePaginator = computed(() => this.state.$tableSettings().usePaginator);
        this.$useVirtualScroll = computed(() => this.state.$viewType().includes('virtual'));
        this.$virtualStart = this.dataStore.selectSignal(d => d.virtualEnds.start);
        this.$offsetIndex = computed(() => {
            const virtualStart = this.$virtualStart();
            const pageSize = this.state.$pageSize();
            const currentPage = this.state.$currentPage();
            if (this.$useVirtualScroll()) {
                return virtualStart;
            }
            if (this.$usePaginator()) {
                return pageSize * currentPage;
            }
            return 0;
        });
        this.$hasSelectColumn = computed(() => this.state.selectSignal(state => state.props.selectionColumn)());
        this.$selection = computed(() => {
            const trackBy = this.$trackBy();
            if (trackBy) {
                return new SelectionModel(true, [], true, (a, b) => a[trackBy] === b[trackBy]);
            }
            return new SelectionModel(true, []);
        });
        this.selectionChange$ = toObservable(this.$selection).pipe(switchMap(s => s.changed));
        this.$selectionChange = toSignal(this.selectionChange$);
        this.onSelectionChangeEffect = effect(() => {
            const selectionChange = this.$selectionChange();
            if (!selectionChange)
                return;
            untracked(() => this.selection$.emit(selectionChange));
        });
        this.$isAllSelected = computed(() => {
            this.$selectionChange();
            const selected = this.$selection()?.selected;
            if (!selected?.length)
                return false;
            return this.$selectableData()?.length === selected.length;
        });
        this.$masterToggleChecked = this.$isAllSelected;
        this.$masterToggleIndeterminate = computed(() => {
            this.$selectionChange();
            return !!this.$selection()?.selected.length && !this.$masterToggleChecked();
        });
        this.$paginated = computed(() => this.state.$viewType() === 'virtual paginator' || this.state.$viewType() === 'paginator');
        this.$selectableData = computed(() => {
            const isGrouped = !!this.state.$groupByKeys().length;
            this.state.$expandGroups();
            if (this.$paginated()) {
                const previousPageRecords = this.state.$currentPage() * this.state.$pageSize();
                if (isGrouped) {
                    const onScreen = this.$dataSource().data.slice(previousPageRecords, previousPageRecords + this.state.$pageSize());
                    const nested = onScreen.flatMap((group) => (group.isGroupHeader && !this.state.$getIsExpanded(group.key, group.uniqueName)()) ? mapGroupHeader(group, true) : []);
                    return onScreen.concat(nested).filter(row => !row.isGroupHeader);
                }
                return this.$data().slice(previousPageRecords, previousPageRecords + this.state.$pageSize());
            }
            else if (this.state.$viewType() === 'all' || this.state.$viewType() === 'virtual all') {
                return this.$data();
            }
            return [];
        });
        this.$selectAllMessage = computed(() => {
            if (this.$isAllSelected())
                return `Deselect all ${this.$selection().selected.length} selected`;
            const selectable = formatNumber(this.$selectableData().length, 'en-US');
            let message = `Select all ${selectable}`;
            if (this.$paginated()) {
                message += ' on this page';
            }
            return message;
        });
        this.#onSelectableDataChangeEffect = effect(() => {
            const selectableData = this.$selectableData();
            untracked(() => {
                const selected = this.$selection()?.selected;
                if (!selected.length)
                    return;
                const trackBy = this.$trackBy();
                const trackByFunc = trackBy ? (s) => selectableData.every(d => d[trackBy] !== s[trackBy]) : s => !selectableData.includes(s);
                const removed = selected.filter(trackByFunc);
                this.$selection().deselect(...removed);
            });
        });
        this.$tableWidth = linkedSignal({
            source: this.state.$getUserDefinedTableWidth,
            computation: (currentUserDefinedWidth, { source: previousUserDefinedWidth } = { value: null, source: 0 }) => {
                if (currentUserDefinedWidth) {
                    return ({ width: `${currentUserDefinedWidth}px`, minWidth: 'initial' });
                }
                if (wasReset()) {
                    return ({ width: 'initial' });
                }
                return {};
                function wasReset() {
                    return (previousUserDefinedWidth ?? 0) >= 0 && currentUserDefinedWidth == null;
                }
            }
        });
        this.getGroupHeaderTransform = (key, val) => computed(() => {
            if (val == undefined || val === 'null')
                return 'BLANK';
            try {
                return createTransformer(this.state.$getMetaData(key)(), this.config, true, true)({ [`${key}`]: val }) || val;
            }
            catch (error) {
                return signal(val);
            }
        });
        this.$rowHeight = computed(() => {
            if (this.state.$userDefinedRowHeight()) {
                return this.state.$userDefinedRowHeight() + 'px';
            }
            const notPersistedTableSettings = this.state.$notPersistedTableSettings();
            if (this.state.$isVirtual() && notPersistedTableSettings.virtualSettings?.enforceRowHeight) {
                const height = notPersistedTableSettings.virtualSettings.rowHeight;
                return parseTbSizeToPixels(height) + 'px';
            }
            if (notPersistedTableSettings.rowHeight) {
                return parseTbSizeToPixels(notPersistedTableSettings.rowHeight) + 'px';
            }
            return undefined;
        });
        this.$headerHeight = computed(() => {
            if (this.state.$userDefinedHeaderHeight()) {
                return this.state.$userDefinedHeaderHeight() + 'px';
            }
            const notPersistedTableSettings = this.state.$notPersistedTableSettings();
            if (this.state.$isVirtual() && notPersistedTableSettings.virtualSettings?.enforceHeaderHeight) {
                const height = notPersistedTableSettings.virtualSettings.headerHeight;
                return parseTbSizeToPixels(height) + 'px';
            }
            if (notPersistedTableSettings.headerHeight) {
                return parseTbSizeToPixels(notPersistedTableSettings.headerHeight) + 'px';
            }
            return undefined;
        });
        this.$groupHeaderHeight = computed(() => {
            const groupHeaderHeight = this.state.$notPersistedTableSettings().groupHeaderHeight;
            if (groupHeaderHeight) {
                return parseTbSizeToPixels(groupHeaderHeight) + 'px';
            }
            return this.$rowHeight();
        });
        this.$footerHeight = computed(() => {
            const footerStyle = this.$footerRowStyle();
            switch (footerStyle) {
                case 'regular-footer':
                    return this.$rowHeight();
                case 'small-footer':
                    return `${this.smallFooter}px`;
                default:
                    return '0px';
            }
        });
        this.$stickyFooter = computed(() => this.state.$props().stickyFooter || this.state.$isVirtual());
        this.$rowStyles = computed(() => this.state.$tableSettings().rowStyles || {});
        this.$rowClasses = computed(() => this.state.$tableSettings().rowClasses || {});
        this.allOfGroupSelected = (uniqueName) => computed(() => {
            //make sure signal is marked dirty when selection or over all data changes
            this.$selectionChange();
            this.$data();
            const header = this.$dataSource().data.find(d => isGroupHeader(d) && d.uniqueName === uniqueName);
            const children = mapGroupHeader(header, true).filter(i => !isGroupHeader(i));
            if (!children.length)
                return { containsAll: false, containsSome: false, length: 0 };
            let containsAll = true;
            let containsSome = false;
            for (var a of children) {
                const contains = this.$selection().isSelected(a);
                if (contains)
                    containsSome = true;
                else
                    containsAll = false;
                if (!containsAll && containsSome)
                    break;
            }
            return { containsAll, containsSome, length: children.length };
        });
        this.toggleGroup = (uniqueName, allSelected) => {
            const header = this.$dataSource().data.find(d => isGroupHeader(d) && d.uniqueName === uniqueName);
            const children = mapGroupHeader(header, true).filter(i => !isGroupHeader(i));
            if (allSelected) {
                this.$selection().deselect(...children);
            }
            else {
                this.$selection().select(...children);
            }
        };
        this.toggleGroupMessage = (amountOfItems, allSelected) => {
            if (allSelected)
                return `Deselect all in this group`;
            const selectable = formatNumber(amountOfItems, 'en-US');
            return `Select all ${selectable} in this group`;
        };
    }
    drop(event) {
        this.state.setUserDefinedOrder({ newOrder: event.currentIndex, oldOrder: event.previousIndex });
    }
    #buildColumnsEffect;
    #buildRowsEffect;
    #buildHeaderRowEffect;
    #buildFooterEffect;
    rowClicked(t, event) {
        const tbs = this.state.$tableSettings();
        if (tbs.rowClick)
            tbs.rowClick(t, event);
    }
    isGroupHeader(_, row) {
        return row.isGroupHeader;
    }
    setExpanded(key, groupUniqueName, isExpanded) {
        this.state.updateExpandedGroups({ key, isExpanded, groupUniqueName });
    }
    buildColumn(column) {
        const alreadyBuiltColumn = this.$columns()[column.metaData.key];
        if (alreadyBuiltColumn) {
            alreadyBuiltColumn.setMetaData(column.metaData);
        }
        else {
            const component = this.viewContainer.createComponent(ColumnBuilderComponent, {
                index: 0,
                injector: this.injector
            });
            component.instance.$customCell.set(column.customCell);
            component.instance.setMetaData(column.metaData);
            component.instance.$data = this.$data;
            component.instance.whenViewInited(() => {
                this.$columns.update(columnsDict => ({
                    ...columnsDict,
                    [column.metaData.key]: component.instance
                }));
            });
        }
    }
    #onSelectableDataChangeEffect;
    /** Selects all rows if they are not all selected; otherwise clear selection. */
    masterToggle() {
        if (this.$isAllSelected()) {
            this.$selection().clear();
        }
        else {
            this.$selection().select(...this.$selectableData());
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GenericTableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: GenericTableComponent, isStandalone: true, selector: "tb-generic-table", inputs: { $displayDataLength: { classPropertyName: "$displayDataLength", publicName: "displayDataLength", isSignal: true, isRequired: true, transformFunction: null }, $data: { classPropertyName: "$data", publicName: "data", isSignal: true, isRequired: true, transformFunction: null }, $rows: { classPropertyName: "$rows", publicName: "rows", isSignal: true, isRequired: false, transformFunction: null }, $columnInfos: { classPropertyName: "$columnInfos", publicName: "columnInfos", isSignal: true, isRequired: true, transformFunction: null }, $dataSource: { classPropertyName: "$dataSource", publicName: "dataSource", isSignal: true, isRequired: true, transformFunction: null }, $trackBy: { classPropertyName: "$trackBy", publicName: "trackBy", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { selection$: "selection" }, viewQueries: [{ propertyName: "$headerRow", first: true, predicate: MatHeaderRowDef, descendants: true, isSignal: true }, { propertyName: "$footerRow", first: true, predicate: MatFooterRowDef, descendants: true, isSignal: true }, { propertyName: "$table", first: true, predicate: MatTable, descendants: true, isSignal: true }, { propertyName: "$dropList", first: true, predicate: CdkDropList, descendants: true, isSignal: true }], ngImport: i0, template: "<mat-table\r\n  #table\r\n  cdkDropList\r\n  cdkDropListLockAxis='x'\r\n  cdkDropListOrientation=\"horizontal\"\r\n  class=\"table-drag-list\"\r\n  [dataSource]=\"$dataSource()\"\r\n  [trackBy]=\"$trackByFunction()\"\r\n  [style]=\"$tableWidth()\"\r\n  (cdkDropListDropped)=\"drop($event)\"\r\n>\r\n\r\n  <!-- select column -->\r\n  <ng-container matColumnDef=\"select\">\r\n    @let selection = $selection();\r\n    <mat-header-cell *matHeaderCellDef  class=\"select-column\">\r\n      <mat-checkbox [checked]=\"!!($masterToggleChecked())\"\r\n                    [indeterminate]=\"$masterToggleIndeterminate()\"\r\n                    [matTooltip]=\"$selectAllMessage()\"\r\n                    (change)=\"$event ? masterToggle() : null\" />\r\n    </mat-header-cell>\r\n\r\n    <mat-cell *matCellDef=\"let row\" class=\"select-column\">\r\n      <mat-checkbox\r\n        [checked]=\"selection.isSelected(row)\"\r\n        (click)=\"$event.stopPropagation()\"\r\n        (change)=\"$event ? selection.toggle(row) : null\"/>\r\n    </mat-cell>\r\n\r\n    <mat-footer-cell *matFooterCellDef class=\"select-column\">\r\n      {{ selection.selected.length }}\r\n    </mat-footer-cell>\r\n  </ng-container>\r\n\r\n\r\n  <!-- index column -->\r\n  <ng-container matColumnDef=\"index\">\r\n    <mat-header-cell *matHeaderCellDef class=\"f-mat-header-cell\" class=\"index-column\">#\r\n    </mat-header-cell>\r\n    <mat-cell *matCellDef=\"let i = index; let t\" class=\"index-column\">\r\n      {{ 1 + i + $offsetIndex() }}\r\n    </mat-cell>\r\n    <mat-footer-cell *matFooterCellDef class=\"index-column\" />\r\n  </ng-container>\r\n\r\n  <!-- Grouping -->\r\n  <ng-container matColumnDef=\"groupHeader\">\r\n    <mat-cell *matCellDef=\"let row\">\r\n      @let expanded = (state.$getIsExpanded | func : row.key : row.uniqueName );\r\n      <div [style.paddingLeft]=\"row.padding + 'px !important'\">\r\n        @if($hasSelectColumn())\r\n        {\r\n          @let contains = (allOfGroupSelected | func : row.uniqueName)();\r\n          <mat-checkbox [checked]=\"!!contains.containsAll\"\r\n            [indeterminate]=\"!!contains.containsSome && !contains.containsAll\"\r\n            [matTooltip]=\"toggleGroupMessage | func : contains.length : contains.containsAll\"\r\n            (change)=\"$event ? toggleGroup(row.uniqueName, contains.containsAll) : null\" />\r\n        }\r\n        <button mat-icon-button (click)=\"setExpanded(row.key, row.uniqueName, !expanded());\">\r\n          @if (!expanded())\r\n          {\r\n            <mat-icon>chevron_right</mat-icon>\r\n          }\r\n          @else\r\n          {\r\n            <mat-icon>expand_more</mat-icon>\r\n          }\r\n        </button>\r\n        {{ row.custom ? row.groupHeaderDisplay : ((getGroupHeaderTransform | func : row.key :  row.groupHeaderDisplay)() + ` (${row.length})`) }}\r\n      </div>\r\n      <div style=\"flex-grow: 1\">\r\n        <ng-container *ngTemplateOutlet=\"state.$props().groupHeaderTemplate!; context: { element: row }\" />\r\n      </div>\r\n    </mat-cell>\r\n  </ng-container>\r\n\r\n  <mat-row\r\n    *matRowDef=\"let row; columns: $keys(); let i = index\"\r\n    [style.height]=\"$rowHeight()\"\r\n    [style.min-height]=\"$rowHeight()\"\r\n    [styler]=\"$rowStyles()\"\r\n    [element]=\"row\"\r\n    [conditionalClasses]=\"$rowClasses()\"\r\n    (click)=\"rowClicked(row, $event)\"\r\n  />\r\n\r\n  <!-- group row -->\r\n  <mat-row *matRowDef=\"let row; columns: ['groupHeader']; when: isGroupHeader\"\r\n           style=\"background-color: unset;\"\r\n           [style.height]=\"state.$props().groupHeaderHeight ? state.$props().groupHeaderHeight + 'px' : $groupHeaderHeight()\" [style.min-height]=\"state.$props().groupHeaderHeight ? state.$props().groupHeaderHeight + 'px' : $groupHeaderHeight()\"/>\r\n</mat-table>\r\n\r\n<mat-header-row *matHeaderRowDef=\"$keys(); sticky: state.$props().isSticky\" [style.height]=\"$headerHeight()\"\r\n  [style.min-height]=\"$headerHeight()\" [style.top.px]=\"($offset()! * -1)\"/>\r\n<mat-footer-row *matFooterRowDef=\"$keys(); sticky: $stickyFooter() \" [style.height]=\"$footerHeight()\"\r\n  [style.min-height]=\"$footerHeight()\"\r\n  [style.bottom.px]=\"$stickyFooter() ? ($offset()) : undefined\"/>\r\n", styles: [":host{--mat-paginator-container-size: var(tb-paginator-container-size, initial)}.select-column{min-width:var(--tb-min-select-column-width, 42px)}.index-column{min-width:var(--tb-min-index-column-width, 42px)}.mat-mdc-row:nth-child(odd){background-color:var(--tb-odd-row-background-color, #cdeefe)}.page-amounts{color:#0000008a;font-family:Roboto,Helvetica Neue,sans-serif;font-size:12px;margin-right:.2rem}:host::ng-deep .table-drag-list.cdk-drop-list-dragging .drag-header:not(.cdk-drag-placeholder){transition:transform .25s cubic-bezier(0,0,.2,1)}:host::ng-deep .mdc-data-table__cell,:host::ng-deep .mdc-data-table__header-cell{padding:var(--tb-cell-padding, 0 0 0 .2rem);line-height:var(--tb-cell-line-height, normal)}::ng-deep .op-date-time-input{line-height:3rem;font-size:.9rem;font-family:Roboto,Helvetica Neue,sans-serif;padding-left:.2rem;width:12rem}\n"], dependencies: [{ kind: "ngmodule", type: MatTableModule }, { kind: "component", type: i1$6.MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { kind: "directive", type: i1$6.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { kind: "directive", type: i1$6.MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { kind: "directive", type: i1$6.MatColumnDef, selector: "[matColumnDef]", inputs: ["matColumnDef"] }, { kind: "directive", type: i1$6.MatCellDef, selector: "[matCellDef]" }, { kind: "directive", type: i1$6.MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }, { kind: "directive", type: i1$6.MatFooterCellDef, selector: "[matFooterCellDef]" }, { kind: "directive", type: i1$6.MatFooterRowDef, selector: "[matFooterRowDef]", inputs: ["matFooterRowDef", "matFooterRowDefSticky"] }, { kind: "directive", type: i1$6.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { kind: "directive", type: i1$6.MatCell, selector: "mat-cell, td[mat-cell]" }, { kind: "directive", type: i1$6.MatFooterCell, selector: "mat-footer-cell, td[mat-footer-cell]" }, { kind: "component", type: i1$6.MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { kind: "component", type: i1$6.MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }, { kind: "component", type: i1$6.MatFooterRow, selector: "mat-footer-row, tr[mat-footer-row]", exportAs: ["matFooterRow"] }, { kind: "ngmodule", type: DragDropModule }, { kind: "directive", type: i5.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep", "cdkDropListElementContainer"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "ngmodule", type: MatCheckboxModule }, { kind: "component", type: i1$2.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "aria-expanded", "aria-controls", "aria-owns", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "pipe", type: FunctionPipe, name: "func" }, { kind: "directive", type: StylerDirective, selector: "[styler]", inputs: ["element", "styler"] }, { kind: "directive", type: ConditionalClassesDirective, selector: "[conditionalClasses]", inputs: ["element", "conditionalClasses"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GenericTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-generic-table', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatTableModule, DragDropModule, MatCheckboxModule, MatButtonModule, MatIconModule, NgTemplateOutlet,
                        MatTooltipModule, FunctionPipe, StylerDirective, ConditionalClassesDirective
                    ], template: "<mat-table\r\n  #table\r\n  cdkDropList\r\n  cdkDropListLockAxis='x'\r\n  cdkDropListOrientation=\"horizontal\"\r\n  class=\"table-drag-list\"\r\n  [dataSource]=\"$dataSource()\"\r\n  [trackBy]=\"$trackByFunction()\"\r\n  [style]=\"$tableWidth()\"\r\n  (cdkDropListDropped)=\"drop($event)\"\r\n>\r\n\r\n  <!-- select column -->\r\n  <ng-container matColumnDef=\"select\">\r\n    @let selection = $selection();\r\n    <mat-header-cell *matHeaderCellDef  class=\"select-column\">\r\n      <mat-checkbox [checked]=\"!!($masterToggleChecked())\"\r\n                    [indeterminate]=\"$masterToggleIndeterminate()\"\r\n                    [matTooltip]=\"$selectAllMessage()\"\r\n                    (change)=\"$event ? masterToggle() : null\" />\r\n    </mat-header-cell>\r\n\r\n    <mat-cell *matCellDef=\"let row\" class=\"select-column\">\r\n      <mat-checkbox\r\n        [checked]=\"selection.isSelected(row)\"\r\n        (click)=\"$event.stopPropagation()\"\r\n        (change)=\"$event ? selection.toggle(row) : null\"/>\r\n    </mat-cell>\r\n\r\n    <mat-footer-cell *matFooterCellDef class=\"select-column\">\r\n      {{ selection.selected.length }}\r\n    </mat-footer-cell>\r\n  </ng-container>\r\n\r\n\r\n  <!-- index column -->\r\n  <ng-container matColumnDef=\"index\">\r\n    <mat-header-cell *matHeaderCellDef class=\"f-mat-header-cell\" class=\"index-column\">#\r\n    </mat-header-cell>\r\n    <mat-cell *matCellDef=\"let i = index; let t\" class=\"index-column\">\r\n      {{ 1 + i + $offsetIndex() }}\r\n    </mat-cell>\r\n    <mat-footer-cell *matFooterCellDef class=\"index-column\" />\r\n  </ng-container>\r\n\r\n  <!-- Grouping -->\r\n  <ng-container matColumnDef=\"groupHeader\">\r\n    <mat-cell *matCellDef=\"let row\">\r\n      @let expanded = (state.$getIsExpanded | func : row.key : row.uniqueName );\r\n      <div [style.paddingLeft]=\"row.padding + 'px !important'\">\r\n        @if($hasSelectColumn())\r\n        {\r\n          @let contains = (allOfGroupSelected | func : row.uniqueName)();\r\n          <mat-checkbox [checked]=\"!!contains.containsAll\"\r\n            [indeterminate]=\"!!contains.containsSome && !contains.containsAll\"\r\n            [matTooltip]=\"toggleGroupMessage | func : contains.length : contains.containsAll\"\r\n            (change)=\"$event ? toggleGroup(row.uniqueName, contains.containsAll) : null\" />\r\n        }\r\n        <button mat-icon-button (click)=\"setExpanded(row.key, row.uniqueName, !expanded());\">\r\n          @if (!expanded())\r\n          {\r\n            <mat-icon>chevron_right</mat-icon>\r\n          }\r\n          @else\r\n          {\r\n            <mat-icon>expand_more</mat-icon>\r\n          }\r\n        </button>\r\n        {{ row.custom ? row.groupHeaderDisplay : ((getGroupHeaderTransform | func : row.key :  row.groupHeaderDisplay)() + ` (${row.length})`) }}\r\n      </div>\r\n      <div style=\"flex-grow: 1\">\r\n        <ng-container *ngTemplateOutlet=\"state.$props().groupHeaderTemplate!; context: { element: row }\" />\r\n      </div>\r\n    </mat-cell>\r\n  </ng-container>\r\n\r\n  <mat-row\r\n    *matRowDef=\"let row; columns: $keys(); let i = index\"\r\n    [style.height]=\"$rowHeight()\"\r\n    [style.min-height]=\"$rowHeight()\"\r\n    [styler]=\"$rowStyles()\"\r\n    [element]=\"row\"\r\n    [conditionalClasses]=\"$rowClasses()\"\r\n    (click)=\"rowClicked(row, $event)\"\r\n  />\r\n\r\n  <!-- group row -->\r\n  <mat-row *matRowDef=\"let row; columns: ['groupHeader']; when: isGroupHeader\"\r\n           style=\"background-color: unset;\"\r\n           [style.height]=\"state.$props().groupHeaderHeight ? state.$props().groupHeaderHeight + 'px' : $groupHeaderHeight()\" [style.min-height]=\"state.$props().groupHeaderHeight ? state.$props().groupHeaderHeight + 'px' : $groupHeaderHeight()\"/>\r\n</mat-table>\r\n\r\n<mat-header-row *matHeaderRowDef=\"$keys(); sticky: state.$props().isSticky\" [style.height]=\"$headerHeight()\"\r\n  [style.min-height]=\"$headerHeight()\" [style.top.px]=\"($offset()! * -1)\"/>\r\n<mat-footer-row *matFooterRowDef=\"$keys(); sticky: $stickyFooter() \" [style.height]=\"$footerHeight()\"\r\n  [style.min-height]=\"$footerHeight()\"\r\n  [style.bottom.px]=\"$stickyFooter() ? ($offset()) : undefined\"/>\r\n", styles: [":host{--mat-paginator-container-size: var(tb-paginator-container-size, initial)}.select-column{min-width:var(--tb-min-select-column-width, 42px)}.index-column{min-width:var(--tb-min-index-column-width, 42px)}.mat-mdc-row:nth-child(odd){background-color:var(--tb-odd-row-background-color, #cdeefe)}.page-amounts{color:#0000008a;font-family:Roboto,Helvetica Neue,sans-serif;font-size:12px;margin-right:.2rem}:host::ng-deep .table-drag-list.cdk-drop-list-dragging .drag-header:not(.cdk-drag-placeholder){transition:transform .25s cubic-bezier(0,0,.2,1)}:host::ng-deep .mdc-data-table__cell,:host::ng-deep .mdc-data-table__header-cell{padding:var(--tb-cell-padding, 0 0 0 .2rem);line-height:var(--tb-cell-line-height, normal)}::ng-deep .op-date-time-input{line-height:3rem;font-size:.9rem;font-family:Roboto,Helvetica Neue,sans-serif;padding-left:.2rem;width:12rem}\n"] }]
        }] });

function downloadData(data, filename, mimeType) {
    const url = URL.createObjectURL(new Blob([data], { type: mimeType }));
    const downloadLink = document.createElement('a');
    downloadLink.download = filename;
    downloadLink.href = url;
    downloadLink.style.display = 'none';
    document.body.appendChild(downloadLink);
    downloadLink.click();
    document.body.removeChild(downloadLink);
    URL.revokeObjectURL(url);
}

class ExportToCsvService {
    constructor() {
        this.state = inject(TableStore);
        this.config = inject(TableBuilderConfigToken);
        this.datePipe = inject(DatePipe);
        this.$exportSettings = computed(() => {
            const globalSettings = this.config?.defaultTableSettings?.tableSettings?.exportSettings
                || this.config?.export
                || {};
            const tableSettings = (this.state.$notPersistedTableSettings()?.exportSettings || {});
            return merge$1({}, globalSettings, tableSettings);
        });
        this.exportToCsv = (data) => {
            const hiddenKeys = this.state.selectSignal(s => s.hiddenKeys)();
            const meta = this.state.$metaDataArray().filter(md => !md.noExport && !hiddenKeys.includes(md.key));
            const extraLinkCols = this.getExtraLinkCols(meta);
            const csv = this.csvData(data, [...meta, ...extraLinkCols]);
            downloadData(csv, 'export.csv', 'text/csv');
        };
        this.getExtraLinkCols = (meta) => {
            return meta.filter(md => {
                if (!md.additional?.link)
                    return;
                const exportForCol = merge$1({}, this.$exportSettings(), md.additional?.export);
                return exportForCol.mapLink === 'add link' || exportForCol.mapLink === 'add excel';
            }).map(md => {
                const exportForCol = merge$1({}, this.$exportSettings(), md.additional?.export);
                const newCol = cloneDeep(md);
                newCol.additional.export ??= {};
                newCol.additional.export.mapLink = exportForCol.mapLink === 'add link' ? 'as link' : 'as excel',
                    newCol.displayName = newCol.additional.export.linkColumnName || ((newCol.displayName || newCol.key) + ' - (Link)');
                return newCol;
            });
        };
        this.csvData = (data, metaData) => {
            const res = data.map(row => metaData.map(meta => this.metaToField(meta, row)).join(','));
            res.unshift(metaData.map(meta => meta.displayName || meta.key).join(','));
            return res.join('\n');
        };
        this.metaToField = (meta, row) => {
            const metaExport = meta.additional?.export;
            if (metaExport?.mapForExport)
                return metaExport.mapForExport(row);
            const exportForCol = merge$1({}, this.$exportSettings(), metaExport);
            let val = getFactory(meta.key)(row);
            if (val == null && !meta.transform)
                return val;
            if (meta.transform && meta.fieldType !== FieldType.Expression) {
                const transform = meta.transform;
                return isPipe(transform) ? transform.transform(val) : transform(val);
            }
            if (meta.additional?.link && exportForCol.mapLink === 'as link' || exportForCol.mapLink === 'as excel') {
                let mapper = this.state.$getLinkInfo(meta)()?.link;
                if (mapper) {
                    let mapped = mapper(row);
                    if (exportForCol.linkDomainPrefix) {
                        const bet = mapped.startsWith('/') ? '' : '/';
                        mapped = `${exportForCol.linkDomainPrefix}${bet}${mapped}`;
                    }
                    if (exportForCol.mapLink === 'as excel') {
                        mapped = this.cleanValForCsv(`=HYPERLINK("${mapped}", "${mapped}")`);
                    }
                    return mapped;
                }
            }
            val = this.cleanValForCsv(this.stringByType(meta, row, val, exportForCol));
            return val;
        };
    }
    stringByType(meta, row, val, exportForCol) {
        if (meta.map) {
            return meta.map(row);
        }
        switch (meta.fieldType) {
            case FieldType.Date:
                const dateFormat = meta.additional?.export?.dateFormat || exportForCol?.dateFormat || meta.additional?.dateFormat;
                return this.transformDate(val, dateFormat);
            case FieldType.DateTime:
                const dateTimeFormat = meta.additional?.export?.dateTimeFormat || exportForCol?.dateTimeFormat || meta.additional?.dateTimeOptions?.format;
                return this.transformDate(val, dateTimeFormat);
            case FieldType.String:
                const prepend = meta.additional?.export?.prepend || exportForCol?.prepend || '';
                return prepend + val;
            case FieldType.Array:
                const style = meta.additional.arrayStyle ?? this.config.arrayDefaults?.arrayStyle;
                const limit = meta.additional.limit ?? this.config.arrayDefaults?.limit;
                return val.slice(0, limit).join(style === ArrayStyle.NewLine ? '\n' : ', ');
            case FieldType.Expression:
                return meta.transform(row);
            case FieldType.Enum:
                return exportForCol?.mapEnumToString ? spaceCase(meta.additional.enumMap[val]) : val;
        }
        return val;
    }
    cleanValForCsv(val) {
        if (typeof val === 'string' && (val.includes(',') || val.includes('"') || val.includes('\n'))) {
            val = val.replaceAll('"', '""');
            val = '"' + val + '"';
        }
        return val;
    }
    transformDate(val, dateFormat) {
        if (this.config.transformers && this.config.transformers[FieldType.Date]) {
            return this.config.transformers[FieldType.Date](val);
        }
        return this.datePipe.transform(val, dateFormat);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ExportToCsvService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ExportToCsvService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ExportToCsvService, decorators: [{
            type: Injectable
        }] });

function createLinkCreatorDict(metaDatas) {
    return metaDatas.reduce((acc, md) => {
        if (md.additional?.link || md.fieldType === FieldType.Link) {
            acc[md.key] = createLinkCreator(md);
        }
        return acc;
    }, {});
}
function createLinkCreator(metaData) {
    const target = metaData.additional?.link?.target || '_blank';
    const useRouterLink = metaData.additional?.link?.useRouterLink || false;
    const hasRoute = !!metaData.additional?.link?.interpolatedRoute;
    const qp = useRouterLink ?
        metaData.additional.link.routerLinkOptions?.queryParams?.reduce((map, [key, value]) => {
            map[key] = typeof value === 'function' ? value : parseInterpolated(value);
            return map;
        }, {})
        : undefined;
    const routerLinkOptions = useRouterLink ? {
        queryParams: (element) => metaData.additional.link.routerLinkOptions?.queryParams?.reduce((map, [key, value]) => {
            map[key] = qp[key](element);
            return map;
        }, {}) ?? null,
        fragment: metaData.additional.link?.routerLinkOptions?.fragment,
        preserveFragment: metaData.additional.link.routerLinkOptions?.preserveFragment ?? false,
        queryParamsHandling: metaData.additional.link.routerLinkOptions?.queryParamsHandling ?? '',
    }
        : undefined;
    if (hasRoute) {
        const value = metaData.additional.link.interpolatedRoute;
        return ({
            link: typeof value === 'function' ? (element) => value(element) : parseInterpolated(value),
            target,
            useRouterLink,
            routerLinkOptions,
        });
    }
    else {
        const slashIfNeeded = !metaData.additional?.link?.base?.endsWith('/') ? '/' : '';
        const base = metaData.additional.link?.base;
        const getKey = key(metaData);
        return ({
            link: (element) => `${base}${slashIfNeeded}${getKey(element)}`,
            target,
            useRouterLink,
            routerLinkOptions,
        });
    }
}
const key = (metaData) => metaData.additional.link?.urlKey ?
    getFactory(metaData.additional.link.urlKey)
    :
        getFactory(metaData.key);
function parseInterpolated(input) {
    // Match either content inside curly braces or content between curly braces
    const parts = input.split(/({[\w.]+})/);
    const result = parts
        .filter(part => part !== '') // Remove empty strings
        .map(part => {
        if (part.startsWith('{') && part.endsWith('}')) {
            // For interpolated values, remove the curly braces
            return {
                type: 'interpolated',
                val: getFactory(part.slice(1, -1))
            };
        }
        else {
            return {
                type: 'string',
                val: part
            };
        }
    });
    return function (val) {
        return result.map(part => part.type === 'string' ? part.val : part.val(val)).join('');
    };
}

class TableBuilderStateStore extends ComponentStore {
    constructor() {
        super(loadGlobalStorageState() || defaultStorageState);
        //selectors
        this.$selectLocalTableProfile = (profileKey) => this.selectSignal(state => state.localProfiles[profileKey]);
        this.$selectLocalTableStateForView = (tableId) => this.selectSignal(this.$selectLocalTableProfile(tableId), (profile) => {
            if (profile?.current) {
                return profile.states[profile.current];
            }
            if (profile?.localSavedState)
                return profile.localSavedState;
            return null;
        });
        this.$selectLocalProfileCurrentKey = (key) => this.selectSignal(this.$selectLocalTableProfile(key), (profile) => profile?.current);
        this.$selectLocalProfileDefaultKey = (key) => this.selectSignal(this.$selectLocalTableProfile(key), (profile) => profile?.default);
        this.$selectLocalProfileKeys = (tableId) => this.selectSignal(this.$selectLocalTableProfile(tableId), (profile) => Object.keys(profile?.states || {}));
        // reducers
        this.saveTableSettingsToLocalAndStorage = (tableId, stateName, tableState, asDefault) => {
            this.saveTableStateToStorage(tableId, stateName, tableState, asDefault);
            this.saveTableStateToLocal({ tableId, tableState, stateName, asDefault });
        };
        this.saveTableStateToLocal = this.updater((state, props) => {
            let profile = state.localProfiles[props.tableId];
            if (!profile?.states) {
                profile = { states: {} };
            }
            if (!props.stateName) {
                profile = { ...profile, localSavedState: props.tableState };
            }
            else {
                profile = { ...profile, states: { ...profile.states, [props.stateName]: props.tableState } };
            }
            if (props.asDefault) {
                profile.default = props.stateName;
            }
            return { ...state, localProfiles: { ...state.localProfiles, [props.tableId]: profile } };
        });
        this.saveTableStateToStorage = (tableId, stateName, tableState, asDefault = false) => {
            const globalSavedState = JSON.parse(localStorage.getItem('global-state-storage') ?? JSON.stringify(defaultStorageState));
            globalSavedState.localProfiles[tableId] ??= { states: {} };
            globalSavedState.localProfiles[tableId].states[stateName] = tableState;
            if (asDefault) {
                globalSavedState.localProfiles[tableId].default = stateName;
            }
            localStorage.setItem('global-state-storage', JSON.stringify(globalSavedState));
        };
        this.addNewStateToLocalAndStorage = (tableId, newStateName, tableState, asDefault) => {
            this.saveTableSettingsToLocalAndStorage(tableId, newStateName, tableState, asDefault);
            this.setLocalCurrentState({ tableId: tableId, currentStateKey: newStateName });
        };
        this.setLocalCurrentState = this.updater((state, props) => {
            const profile = state.localProfiles[props.tableId] || { states: {} };
            profile.current = props.currentStateKey;
            return { ...state, localProfiles: { ...state.localProfiles, [props.tableId]: { ...profile } } };
        });
        this.setDefaultInLocalAndStorage = (tableId, newDefault) => {
            this.setDefaultInLocal({ default: newDefault, key: tableId });
            this.setDefaultInStorage(tableId, newDefault);
        };
        this.setDefaultInLocal = this.updater((state, props) => {
            if (state.localProfiles[props.key]?.states[props.default]) {
                return ({ ...state, localProfiles: { ...state.localProfiles, [props.key]: { ...state.localProfiles[props.key], default: props.default } } });
            }
            return state;
        });
        this.unsetDefaultFromLocalAndStorage = (tableId) => {
            this.unsetDefaultFromLocal(tableId);
            this.unsetDefaultFromStorage(tableId);
        };
        this.unsetDefaultFromLocal = (tableId) => {
            this.patchState(tables => {
                const profile = { ...tables.localProfiles[tableId] };
                if (profile) {
                    delete profile.default;
                }
                return { ...tables, localProfiles: { ...tables.localProfiles, [tableId]: profile } };
            });
        };
        this.unsetDefaultFromStorage = (tableId) => {
            const globalSavedState = JSON.parse(localStorage.getItem('global-state-storage') ?? JSON.stringify(defaultStorageState));
            if (globalSavedState.localProfiles[tableId]) {
                delete globalSavedState.localProfiles[tableId].default;
                localStorage.setItem('global-state-storage', JSON.stringify(globalSavedState));
            }
        };
        this.setDefaultInStorage = (tableId, stateName) => {
            const tableProfile = this.$selectLocalTableProfile(tableId)();
            const globalSavedState = JSON.parse(localStorage.getItem('global-state-storage') ?? JSON.stringify(defaultStorageState));
            let savedProfile = globalSavedState.localProfiles[stateName];
            if (!savedProfile?.states) {
                savedProfile = { default: stateName, states: tableProfile.states };
            }
            else {
                savedProfile.default = stateName;
            }
            globalSavedState.localProfiles[tableId] = savedProfile;
            localStorage.setItem('global-state-storage', JSON.stringify(globalSavedState));
        };
        this.deleteLocalProfilesState = this.updater((state, props) => {
            let profile = state.localProfiles[props.key];
            if (profile) {
                const current = profile.current === props.stateKey ? profile.default : profile.current;
                profile = { ...profile, current, states: { ...profile.states } };
                delete profile.states[props.stateKey];
                if (current === props.stateKey) {
                    profile.current = undefined;
                }
                return { ...state, localProfiles: { ...state.localProfiles, [props.key]: profile } };
            }
            else {
                return state;
            }
        });
        this.deleteProfileFromLocalAndStorage = (key, stateKey) => {
            const globalSavedState = JSON.parse(localStorage.getItem('global-state-storage') ?? JSON.stringify(defaultStorageState));
            if (!globalSavedState.localProfiles[key]) {
                return;
            }
            else {
                delete (globalSavedState.localProfiles[key].states ?? {})[stateKey];
            }
            if (globalSavedState.localProfiles[key].default === stateKey) {
                globalSavedState.localProfiles[key].default = undefined;
            }
            localStorage.setItem('global-state-storage', JSON.stringify(globalSavedState));
            this.deleteLocalProfilesState({ key, stateKey });
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderStateStore, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderStateStore, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderStateStore, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: () => [] });
function loadGlobalStorageState() {
    const storage = localStorage.getItem('global-state-storage');
    if (storage) {
        const s = JSON.parse(storage);
        s.localProfiles ??= {};
        for (const key in s.localProfiles) {
            const profile = s.localProfiles[key];
            s.localProfiles[key] = { ...profile, current: profile.default };
        }
        return { ...defaultStorageState, ...s };
    }
}
const defaultStorageState = {
    localProfiles: {}
};

//The idea of this is that if filters were only added, and none were removed or changed, then we only need to tag more rows to not be shown. We don't need to remove any 'dont show' tags.
// So if filters were only added this method will return the added filters, if filters were removed or changed this method will return undefined.
const updateFilterInfoState = (previousState, filterInfos) => {
    filterInfos = filterNonActiveOrNotReadyFilters(filterInfos);
    const currentState = {
        allFilters: filterInfos,
        onlyAddedFilters: filterInfoOnlyAdded(previousState.allFilters, filterInfos)
    };
    return currentState;
};
const mapFilterInfoStateToPredicateState = (s) => {
    const mappedAddOnly = s.onlyAddedFilters
        ?
            Object.entries(s.onlyAddedFilters).filter(([, v]) => needsFilterCreation(v)).reduce((obj, [key, value]) => {
                obj[key] = createFilterFunc(value);
                return obj;
            }, {})
        : {};
    const mappedAll = Object.entries(s.allFilters).filter(([, v]) => needsFilterCreation(v))
        .filter(([, v]) => !isCustomFilter(v) || !!v.predicate)
        .map(([key, value]) => {
        return mappedAddOnly[key] || createFilterFunc(value);
    });
    return ({
        allFilters: mappedAll,
        onlyAddedFilters: s.onlyAddedFilters ? Object.values(mappedAddOnly) : undefined
    });
};
const updateFilterPredicateState = (previousState, filters) => {
    const currentState = {
        allFilters: filters,
        onlyAddedFilters: predicatesOnlyAdded(previousState.allFilters, filters)
    };
    return currentState;
};
const updateFilterState = (filterInfos, predicates) => {
    const infos = mapFilterInfoStateToPredicateState(filterInfos.value);
    const filtersState = {
        allFilters: [...infos.allFilters, ...predicates.value.allFilters]
    };
    if (filterInfos.timestamp > predicates.timestamp && !!filterInfos.value.onlyAddedFilters) {
        filtersState.onlyAddedFilters = infos.onlyAddedFilters;
    }
    else {
        filtersState.onlyAddedFilters = predicates.value.onlyAddedFilters;
    }
    return filtersState;
};
const filterNonActiveOrNotReadyFilters = (filtersDict) => Object.entries(filtersDict).reduce((obj, [key, value]) => {
    if (value.active !== false && (!isCustomFilter(value) || !!value.predicate)) {
        obj[key] = value;
    }
    return obj;
}, {});
function filterInfoOnlyAdded(previousFilterInfos, currentFilterInfos) {
    const previousKeys = Object.keys(previousFilterInfos);
    const currentKeys = Object.keys(currentFilterInfos);
    const keysInBoth = intersection(previousKeys, currentKeys);
    const someRemoved = previousKeys.length > keysInBoth.length;
    if (someRemoved || !previousKeys.length) {
        return undefined;
    }
    if (filtersInfosUpdated(previousFilterInfos, currentFilterInfos)) {
        return undefined;
    }
    const addedFilters = difference(currentKeys, keysInBoth).reduce((dict, key) => {
        dict[key] = currentFilterInfos[key];
        return dict;
    }, {});
    return addedFilters;
}
function predicatesOnlyAdded(previousPredicates, currentPredicates) {
    if (!previousPredicates.length) {
        return undefined;
    }
    const predicateFiltersRemoved = difference(previousPredicates, currentPredicates).length;
    if (predicateFiltersRemoved) {
        return undefined;
    }
    return difference(currentPredicates, previousPredicates);
}
function filtersInfosUpdated(previousFilterInfos, currentFilterInfos) {
    return !Object.entries(previousFilterInfos).every(([key, val]) => {
        return currentFilterInfos[key].filterType === val.filterType && currentFilterInfos[key].filterValue === val.filterValue;
    });
}
function patchDirectiveFromState(directive, stateFilter) {
    if (isFilterInfo(stateFilter)) {
        const filterDirective = directive;
        filterDirective.setFilterValue(stateFilter.filterValue);
        filterDirective.update();
    }
    if (isCustomFilter(stateFilter)) {
        directive.active = stateFilter.active ?? false;
    }
}

const _sortAndFilterData = (data, sortState, filterState) => combineLatest([
    data.pipe(timestamp()),
    sortState.pipe(timestamp()),
    filterState.pipe(timestamp())
]).pipe(scan((mappedData, [data, sort, f], index) => {
    return mapDataSortsAndFilters(data, f, sort, index === 0, mappedData);
}, [])).pipe(map$1((resultData) => resultData.filter(item => !item[tbNoShowSymbol])), defaultShareReplay());
const mapDataSortsAndFilters = (allData, filters, sort, firstRun, filteredAndSortedData) => {
    const fresh = firstRun || (allData.timestamp > sort.timestamp && allData.timestamp > filters.timestamp);
    const sortChanged = !fresh && sort.timestamp > filters.timestamp;
    const filterRemoved = !fresh && !sortChanged && !filters.value.onlyAddedFilters;
    const runAllOnAllData = fresh || filterRemoved;
    const resetFilters = !fresh && filterRemoved;
    if (runAllOnAllData) {
        const filteredData = filterData(sortData(allData.value, sort.value.allSorts), filters.value.allFilters, resetFilters);
        return filteredData;
    }
    if (sortChanged) {
        return (sortData(filteredAndSortedData, sort.value.sortsToRun));
    }
    return (filterData(filteredAndSortedData, filters.value.onlyAddedFilters || filters.value.allFilters, resetFilters));
};
const sortAndFilterData = (data, filters, sort, firstRun, resultData) => {
    const markedAndSortedData = mapDataSortsAndFilters(data, filters, sort, firstRun, resultData);
    const filteredData = markedAndSortedData.filter(item => !item[tbNoShowSymbol]);
    return filteredData;
};
const createDataCleaners = (metadatas, mutate = false) => {
    const transforms = createCleaners(metadatas);
    return (data) => {
        if (!mutate) {
            data = { ...data };
        }
        for (const transform of transforms) {
            transform(data);
        }
        return data;
    };
};
const createCleaners = (metadatas) => {
    return metadatas.reduce((transforms, metaData) => {
        const getter = getFactory(metaData.key);
        const setter = metaData.key.includes('.') ? (t, val) => set(t, metaData.key, val) : (t, val) => t[metaData.key] = val;
        switch (metaData.fieldType) {
            case FieldType.Currency:
            case FieldType.Number: {
                const transform = (t) => {
                    const val = getter(t);
                    const num = Number(val);
                    setter(t, isNaN(num) || val == null ? null : num);
                };
                transforms.push(transform);
                break;
            }
            case FieldType.Date: {
                const transform = (t) => {
                    const val = getter(t);
                    const date = Date.parse(val);
                    let mappedDate;
                    if (isNaN(date)) {
                        mappedDate = null;
                    }
                    else {
                        mappedDate = new Date(date);
                        mappedDate.setHours(0, 0, 0, 0);
                    }
                    setter(t, mappedDate);
                };
                transforms.push(transform);
                break;
            }
            case FieldType.DateTime: {
                const transform = (t) => {
                    const val = getter(t);
                    const date = Date.parse(val);
                    let mappedDate;
                    if (isNaN(date)) {
                        mappedDate = null;
                    }
                    else {
                        mappedDate = new Date(date);
                        if (!metaData.additional?.dateTimeOptions?.includeMilliseconds) {
                            if (metaData.additional?.dateTimeOptions?.includeSeconds) {
                                mappedDate.setMilliseconds(0);
                            }
                            else {
                                mappedDate.setSeconds(0, 0);
                            }
                        }
                    }
                    setter(t, mappedDate);
                };
                transforms.push(transform);
            }
        }
        return transforms;
    }, []);
};

class PaginatorComponent {
    constructor() {
        this.state = inject(TableStore);
        this.data = inject(DataStore);
        this.$paginator = viewChild(MatPaginator);
        this.$dataLength = this.data.selectSignal(d => d.sortedFilteredDataLength);
        this.$viewableDataLength = this.data.selectSignal(d => d.sortedFilteredGroupedDataLength);
        this.pageEvent$ = toObservable(this.$paginator).pipe(notNull(), switchMap(p => p.page));
        this.$pageEvent = toSignal(this.pageEvent$);
        this.$pageIndexChangeEvent = computed(() => this.$pageEvent()?.pageIndex);
        this.$pageSizeChangeEvent = computed(() => this.$pageEvent()?.pageSize);
        this.$currentPageData = computed(() => {
            const pageEvent = this.$pageEvent();
            if (!pageEvent)
                return;
            const paginator = this.$paginator();
            // Reset because initial page event does not have page length
            pageEvent.pageIndex = paginator.pageIndex;
            pageEvent.pageSize = paginator.pageSize;
            pageEvent.length = paginator.length;
            const pageDetails = mapPaginationEventToCurrentPageDetails(pageEvent);
            const dataLength = this.$dataLength();
            return ({ ...pageDetails, total: dataLength });
        });
        this.#onPageIndexEffect = effect(() => {
            const index = this.$pageIndexChangeEvent();
            if (index === undefined)
                return;
            untracked(() => this.state.setCurrentPage(index));
        });
        this.#onPageSizeEffect = effect(() => {
            const size = this.$pageSizeChangeEvent();
            const initialized = this.state.$initializationState() >= InitializationState.Ready;
            if (!size || !initialized)
                return;
            untracked(() => this.state.setUserDefinedPageSize(size));
        });
        this.#onMetaPageSizeEffect = effect(() => {
            const paginator = this.$paginator();
            if (!paginator)
                return;
            const metaPageSize = this.state.$pageSize();
            const initialized = this.state.$initializationState() >= InitializationState.Ready;
            untracked(() => initialized && paginator._changePageSize(metaPageSize));
        });
        this.onDataLengthEffect = effect(() => {
            const paginator = this.$paginator();
            const dataLength = this.$viewableDataLength();
            untracked(() => {
                if (paginator) {
                    paginator.length = dataLength;
                    const maxIndex = Math.max(0, Math.ceil(dataLength / paginator.pageSize) - 1);
                    if (paginator.pageIndex > maxIndex) {
                        paginator.pageIndex = maxIndex;
                        this.state.setCurrentPage(maxIndex);
                    }
                }
            });
        });
        this.$collapseFooter = computed(() => this.state.selectSignal(state => state.persistedTableSettings.collapseFooter)());
        this.$showAllOption = this.state.selectSignal(s => s.notPersistedTableSettings?.paginatorSettings?.includeAllInOptions);
        this.$showAll = this.state.$showAll;
    }
    #onPageIndexEffect;
    #onPageSizeEffect;
    #onMetaPageSizeEffect;
    showAll() {
        const showAll = !this.$showAll();
        this.state.setUserDefinedShowAll(showAll);
        if (showAll) {
            this.state.toggleCollapseFooter({ collapseFooter: true });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: PaginatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: PaginatorComponent, isStandalone: true, selector: "tb-paginator", viewQueries: [{ propertyName: "$paginator", first: true, predicate: MatPaginator, descendants: true, isSignal: true }], ngImport: i0, template: `
  <div class="paginator-row">
    @if($currentPageData(); as pageData)
    {
      <div [class]="{ 'hide' : ! $collapseFooter(), 'page-amounts':true}">
        @if(!$showAll()){ {{pageData.currentStart}} - {{pageData.currentEnd}} of }{{pageData.total}}
      </div>
    }
    <mat-paginator [pageSizeOptions]="[5, 10, 20, 50, 100, 500]" showFirstLastButtons
      [class]="{ 'hide' : $collapseFooter() || $showAll() }">
    </mat-paginator>
    @if ($showAllOption() && !$collapseFooter())
    {
      <button mat-button (click)="showAll()">
        <span [style.text-decoration]="$showAll() ? 'line-through' : ''" >All</span>
      </button>
    }
  </div>
  `, isInline: true, styles: [":host{--mat-paginator-container-size: var(tb-paginator-container-size, initial)}.select-column{min-width:var(--tb-min-select-column-width, 42px)}.index-column{min-width:var(--tb-min-index-column-width, 42px)}.mat-mdc-row:nth-child(odd){background-color:var(--tb-odd-row-background-color, #cdeefe)}.page-amounts{color:#0000008a;font-family:Roboto,Helvetica Neue,sans-serif;font-size:12px;margin-right:.2rem}:host::ng-deep .table-drag-list.cdk-drop-list-dragging .drag-header:not(.cdk-drag-placeholder){transition:transform .25s cubic-bezier(0,0,.2,1)}:host::ng-deep .mdc-data-table__cell,:host::ng-deep .mdc-data-table__header-cell{padding:var(--tb-cell-padding, 0 0 0 .2rem);line-height:var(--tb-cell-line-height, normal)}::ng-deep .op-date-time-input{line-height:3rem;font-size:.9rem;font-family:Roboto,Helvetica Neue,sans-serif;padding-left:.2rem;width:12rem}\n", ".collapse-icon{font-size:16px;height:16px;color:#3f51b5;align-self:flex-start}.collapse-icon:hover{cursor:pointer}.hide{display:none}.paginator-row{display:flex;align-items:center}\n"], dependencies: [{ kind: "ngmodule", type: MatPaginatorModule }, { kind: "component", type: i1$7.MatPaginator, selector: "mat-paginator", inputs: ["color", "pageIndex", "length", "pageSize", "pageSizeOptions", "hidePageSize", "showFirstLastButtons", "selectConfig", "disabled"], outputs: ["page"], exportAs: ["matPaginator"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatButton, selector: "    button[matButton], a[matButton], button[mat-button], button[mat-raised-button],    button[mat-flat-button], button[mat-stroked-button], a[mat-button], a[mat-raised-button],    a[mat-flat-button], a[mat-stroked-button]  ", inputs: ["matButton"], exportAs: ["matButton", "matAnchor"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: PaginatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-paginator', imports: [MatPaginatorModule, MatButtonModule], template: `
  <div class="paginator-row">
    @if($currentPageData(); as pageData)
    {
      <div [class]="{ 'hide' : ! $collapseFooter(), 'page-amounts':true}">
        @if(!$showAll()){ {{pageData.currentStart}} - {{pageData.currentEnd}} of }{{pageData.total}}
      </div>
    }
    <mat-paginator [pageSizeOptions]="[5, 10, 20, 50, 100, 500]" showFirstLastButtons
      [class]="{ 'hide' : $collapseFooter() || $showAll() }">
    </mat-paginator>
    @if ($showAllOption() && !$collapseFooter())
    {
      <button mat-button (click)="showAll()">
        <span [style.text-decoration]="$showAll() ? 'line-through' : ''" >All</span>
      </button>
    }
  </div>
  `, changeDetection: ChangeDetectionStrategy.OnPush, styles: [":host{--mat-paginator-container-size: var(tb-paginator-container-size, initial)}.select-column{min-width:var(--tb-min-select-column-width, 42px)}.index-column{min-width:var(--tb-min-index-column-width, 42px)}.mat-mdc-row:nth-child(odd){background-color:var(--tb-odd-row-background-color, #cdeefe)}.page-amounts{color:#0000008a;font-family:Roboto,Helvetica Neue,sans-serif;font-size:12px;margin-right:.2rem}:host::ng-deep .table-drag-list.cdk-drop-list-dragging .drag-header:not(.cdk-drag-placeholder){transition:transform .25s cubic-bezier(0,0,.2,1)}:host::ng-deep .mdc-data-table__cell,:host::ng-deep .mdc-data-table__header-cell{padding:var(--tb-cell-padding, 0 0 0 .2rem);line-height:var(--tb-cell-line-height, normal)}::ng-deep .op-date-time-input{line-height:3rem;font-size:.9rem;font-family:Roboto,Helvetica Neue,sans-serif;padding-left:.2rem;width:12rem}\n", ".collapse-icon{font-size:16px;height:16px;color:#3f51b5;align-self:flex-start}.collapse-icon:hover{cursor:pointer}.hide{display:none}.paginator-row{display:flex;align-items:center}\n"] }]
        }] });
const mapPaginationEventToCurrentPageDetails = (pageData) => {
    return ({
        currentStart: (pageData.pageIndex * pageData.pageSize) + 1,
        currentEnd: Math.min(pageData.length, ((pageData.pageIndex + 1) * pageData.pageSize)),
        total: pageData.length
    });
};

class TableBuilderDataSource extends MatTableDataSource {
    #$dataSrc;
    setData(data) {
        this.#$dataSrc.set(data);
    }
    constructor(state, data) {
        super([]);
        this.#$dataSrc = signal([]);
        this.$dataSize = signal({ start: 0, end: 0 }, {
            equal: (a, b) => a.start === b.start && a.end === b.end
        });
        this._ = effect(() => {
            const data = this.#$dataSrc();
            const dataSize = this.$dataSize();
            untracked(() => this.data = data.slice(dataSize.start, dataSize.end));
        });
        const $currentPage = state.$currentPage;
        const $pageSize = state.$pageSize;
        const $virtualEnds = data.selectSignal(d => d.virtualEnds);
        const $dataLength = computed(() => this.#$dataSrc().length);
        this.$dataSize = computed(() => {
            const viewType = state.$viewType();
            const dataLength = $dataLength();
            const currentPage = $currentPage();
            const pageSize = $pageSize();
            const virtualEnds = $virtualEnds();
            const previousPageRecords = currentPage * pageSize;
            if (viewType === 'virtual paginator') {
                return ({ start: virtualEnds.start + previousPageRecords, end: Math.min(virtualEnds.end, pageSize) + previousPageRecords });
            }
            if (viewType === 'paginator') {
                return ({ start: previousPageRecords, end: previousPageRecords + pageSize });
            }
            if (viewType === 'all') {
                return ({ start: 0, end: dataLength });
            }
            return ({ start: virtualEnds.start, end: virtualEnds.end });
        });
    }
    connect() {
        return super.connect();
    }
    disconnect() {
        if (this.subscription) {
            this.subscription.unsubscribe();
            this.subscription = undefined;
        }
        super.disconnect();
    }
}

function mergeCustomCellMetaData(metaData1, metaData2) {
    if (!metaData2) {
        metaData1.noExport = true;
        return metaData1;
    }
    if (!metaData1.displayName)
        metaData1.displayName = metaData2.displayName;
    if (!metaData1.preSort)
        metaData1.preSort = metaData2.preSort;
    if (!metaData1.order)
        metaData1.order = metaData2.order;
    if (!metaData1.width)
        metaData1.width = metaData2.width;
    if (metaData2.fieldType)
        metaData1.fieldType = metaData2.fieldType;
    metaData1.noExport = metaData2.noExport;
    return ({ ...metaData2, ...metaData1 });
}

class GroupByListComponent {
    constructor() {
        this.tableStore = inject(TableStore);
        this.$groups = computed(() => {
            const dict = this.tableStore.$metaData();
            return this.tableStore.$groupByKeys().map(gbk => ({
                key: gbk,
                name: dict[gbk].displayName || gbk
            }));
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GroupByListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: GroupByListComponent, isStandalone: true, selector: "group-by-list", ngImport: i0, template: "<span class=\"tb-group-label\">Group By:</span>\r\n<mat-chip-set>\r\n  @for (groupBy of $groups(); track groupBy.key)\r\n  {\r\n    @if($index > 0)\r\n    {\r\n      <mat-icon class=\"nested-arrow\">arrow_right</mat-icon>\r\n    }\r\n    <mat-chip (removed)=\"tableStore.removeGroupByKey(groupBy.key)\">\r\n      {{groupBy.name | spaceCase}}\r\n      <mat-icon matChipRemove>cancel</mat-icon>\r\n    </mat-chip>\r\n  }\r\n</mat-chip-set>\r\n", styles: [".tb-group-label{font-weight:bolder;padding-right:15px}:host{display:flex;padding-left:8px;align-items:center}:host mat-chip-set mat-chip{margin:0}:host mat-chip-set .nested-arrow{display:flex;width:15px;justify-content:center}\n"], dependencies: [{ kind: "ngmodule", type: MatChipsModule }, { kind: "component", type: i4$1.MatChip, selector: "mat-basic-chip, [mat-basic-chip], mat-chip, [mat-chip]", inputs: ["role", "id", "aria-label", "aria-description", "value", "color", "removable", "highlighted", "disableRipple", "disabled"], outputs: ["removed", "destroyed"], exportAs: ["matChip"] }, { kind: "directive", type: i4$1.MatChipRemove, selector: "[matChipRemove]" }, { kind: "component", type: i4$1.MatChipSet, selector: "mat-chip-set", inputs: ["disabled", "role", "tabIndex"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: GroupByListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'group-by-list', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatChipsModule, MatIconModule, SpaceCasePipe
                    ], template: "<span class=\"tb-group-label\">Group By:</span>\r\n<mat-chip-set>\r\n  @for (groupBy of $groups(); track groupBy.key)\r\n  {\r\n    @if($index > 0)\r\n    {\r\n      <mat-icon class=\"nested-arrow\">arrow_right</mat-icon>\r\n    }\r\n    <mat-chip (removed)=\"tableStore.removeGroupByKey(groupBy.key)\">\r\n      {{groupBy.name | spaceCase}}\r\n      <mat-icon matChipRemove>cancel</mat-icon>\r\n    </mat-chip>\r\n  }\r\n</mat-chip-set>\r\n", styles: [".tb-group-label{font-weight:bolder;padding-right:15px}:host{display:flex;padding-left:8px;align-items:center}:host mat-chip-set mat-chip{margin:0}:host mat-chip-set .nested-arrow{display:flex;width:15px;justify-content:center}\n"] }]
        }] });

class ProfilesMenuComponent {
    constructor() {
        this.stateService = inject(TableBuilderStateStore);
        this.tableStore = inject(TableStore);
        this.$tableId = input.required({ alias: 'tableId' });
        this.$isMatMenuChild = input(false, { alias: 'isMatMenuChild' });
        this.trigger = viewChild('trigger');
        this.menu = viewChild.required(MatMenu);
        this.allProfilesPanelOpened = signal(false);
        this.newProfilePanelOpened = signal(false);
        this.$currentProfile = computed(() => this.stateService.$selectLocalProfileCurrentKey(this.$tableId())());
        this.$defaultProfile = computed(() => this.stateService.$selectLocalProfileDefaultKey(this.$tableId())());
        this.$keys = computed(() => this.stateService.$selectLocalProfileKeys(this.$tableId())());
        this.defaultName = 'My Profile';
        this.position$ = new Subject();
        this.setPosition = (e) => {
            const rect = e.getBoundingClientRect();
            if (rect.top === 0)
                return;
            const a = {
                right: `${(window.innerWidth - rect.right)}px`,
                top: `${rect.top}px`,
            };
            return a;
        };
    }
    saveState(key) {
        const tableState = this.tableStore.$savableState();
        this.stateService.saveTableSettingsToLocalAndStorage(this.$tableId(), key, tableState);
    }
    addState(key, asDefault) {
        const tableState = this.tableStore.$savableState();
        this.stateService.addNewStateToLocalAndStorage(this.$tableId(), key, tableState, asDefault);
    }
    setDefault(key) {
        this.stateService.setDefaultInLocalAndStorage(this.$tableId(), key);
    }
    unsetDefault() {
        this.stateService.unsetDefaultFromLocalAndStorage(this.$tableId());
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ProfilesMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ProfilesMenuComponent, isStandalone: true, selector: "tb-profiles-menu", inputs: { $tableId: { classPropertyName: "$tableId", publicName: "tableId", isSignal: true, isRequired: true, transformFunction: null }, $isMatMenuChild: { classPropertyName: "$isMatMenuChild", publicName: "isMatMenuChild", isSignal: true, isRequired: false, transformFunction: null } }, viewQueries: [{ propertyName: "trigger", first: true, predicate: ["trigger"], descendants: true, isSignal: true }, { propertyName: "menu", first: true, predicate: MatMenu, descendants: true, isSignal: true }], ngImport: i0, template: "@if(!$isMatMenuChild())\r\n{\r\n  <button #trigger=\"matMenuTrigger\" color=\"primary\" mat-icon-button [matMenuTriggerFor]=\"menu\" [matTooltip]=\"'Profiles'\">\r\n    <mat-icon color=\"primary\">people</mat-icon>\r\n  </button>\r\n}\r\n<mat-menu #menu=\"matMenu\" (closed)=\"addedKey.value = null; allProfilesPanelOpened.set(false); newProfilePanelOpened.set(false)\">\r\n  @if(!!$currentProfile())\r\n  {\r\n    <div mat-menu-item mat-stroked-button [matTooltip]=\"'Save Profile'\" (click)=\"saveState($currentProfile()!)\">\r\n      <mat-icon color=\"primary\">save</mat-icon>\r\n      <span>{{$currentProfile()}}</span>\r\n    </div>\r\n  }\r\n  @else\r\n  {\r\n    <div class=\"profile-line\">\r\n      <button color=\"primary\" class=\"first-in-line first-button\" mat-stroked-button (click)=\"addState(defaultName, m.checked);\">\r\n        <mat-icon class=\"save-for-default-icon button-save-icon\" color=\"primary\">save</mat-icon>\r\n        <span>Save as <span class=\"current-name\">{{defaultName}}</span> </span>\r\n      </button>\r\n      <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Created As Default'\" (click)=\"m.toggle()\" >\r\n        <mat-icon style=\"color: green;\">{{m.checked ? 'star' : 'star_border'}}</mat-icon>\r\n      </button>\r\n      <mat-checkbox #m class=\"display-none\" [checked]=\"true\" />\r\n    </div>\r\n  }\r\n  @if (allProfilesPanelOpened()) {<hr class=\"divider\"/>}\r\n  <div mat-menu-item stop-propagation [class]=\"{ hide: !$keys().length, 'all-profile-row': true }\" (click)=\"allProfilesPanelOpened.set(!allProfilesPanelOpened())\">\r\n    <div class=\"all-profiles\">\r\n      <span>All Profiles</span>\r\n      <span class=\"arrow\" [class]=\"`${(allProfilesPanelOpened() ? 'all-profile-arrow-close' : 'all-profile-arrow-open')} all-profile-arrow`\"></span>\r\n    </div>\r\n  </div>\r\n  <div [class]=\"{ hide: !allProfilesPanelOpened(), panel: true }\">\r\n    @for (key of $keys() ; track key)\r\n    {\r\n      <div class=\"profile-line\" [class]=\"key === $currentProfile() ? 'current-in-list' : 'not-current-in-list'\">\r\n        <button class=\"menu-item first-in-line\" mat-stroked-button [matTooltip]=\"'Select Profile'\" (click)='stateService.setLocalCurrentState({ tableId: $tableId(), currentStateKey: key})'>\r\n          <span>{{key}}</span>\r\n        </button>\r\n        @if(key !== $defaultProfile())\r\n        {\r\n          <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Default'\" (click)=\"setDefault(key)\">\r\n            <mat-icon style=\"color: green;\">star_border</mat-icon>\r\n          </button>\r\n        }\r\n        @else\r\n        {\r\n          <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Default'\" (click)=\"unsetDefault()\">\r\n            <mat-icon style=\"color: green;\">star</mat-icon>\r\n          </button>\r\n        }\r\n        <button color=\"warn\" class=\"last-in-line\" stop-propagation mat-icon-button [matTooltip]=\"'Delete Profile'\" (click)='stateService.deleteProfileFromLocalAndStorage($tableId(), key)'>\r\n          <mat-icon color='warn'>delete_forever</mat-icon>\r\n        </button>\r\n      </div>\r\n    }\r\n    <hr class=\"divider\"/>\r\n  </div>\r\n  <div class=\"add-new-profile-row\" mat-menu-item stop-propagation (click)=\"newProfilePanelOpened.set(!newProfilePanelOpened()); addedKey.focus()\">Add New Profile</div>\r\n  <div [class]=\"{ hide: !newProfilePanelOpened(), panel: true }\" >\r\n    <div class=\"profile-line\" stop-propagation>\r\n      <div class=\"new-name-input\">\r\n        <i class=\"input-hint\">Enter New Name</i>\r\n        <input #addedKey=\"matInput\" matInput [name]=\"'key'\" />\r\n      </div>\r\n      <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Created As Default'\" (click)=\"m2.toggle()\" >\r\n        <mat-icon style=\"color: green;\">{{m2.checked ? 'star' : 'star_border'}}</mat-icon>\r\n      </button>\r\n      <mat-checkbox #m2 class=\"display-none\" [ngModel]=\"!$defaultProfile()\" />\r\n    </div>\r\n    <button class=\"add-button\" color=\"primary\" mat-raised-button [matTooltip]=\"'Create New Profile'\" [disabled]=\"!addedKey.value\" (click)=\"addState(addedKey.value, m2.checked); addedKey.value = null\">\r\n      Add\r\n    </button>\r\n  </div>\r\n</mat-menu>\r\n", styles: [":host ::ng-deep .mat-expansion-panel-header{padding:0}.current-name{color:var(tb-current-profile, blue)}.menu-item{display:inline-flex;width:initial;flex-grow:1}.profile-line{display:flex;justify-content:space-between;align-items:center}.first-in-line{--f-b: 2rem;margin-left:var(--mat-menu-item-with-icon-leading-spacing)}.first-in-line.first-button{height:var(--f-b);margin:.2rem}.first-in-line .button-save-icon{height:var(--f-b);width:var(--f-b);font-size:var(--f-b)}.main-save-button{height:4rem;width:4rem;padding:.5rem}.main-save-button mat-icon{height:3rem;width:3rem;font-size:3rem}.save-for-default-icon{margin:0}.display-none{display:none}.last-in-line{padding-right:var(--mat-menu-item-with-icon-trailing-spacing)}.default-cursor{cursor:default}.as-def{padding-left:var(--mat-menu-item-with-icon-leading-spacing)}.divider{margin:.2px 0}.add-key{max-width:8.5rem;margin-left:2px}.add-key ::ng-deep .mdc-text-field{padding:0}.panel{transition:height .1s}.hide{height:0;min-height:0;overflow:hidden}.open-panel-button{width:100%;height:2.5rem}.current-in-list{border-left:3px solid blue;background-color:#0000ff0d}.not-current-in-list{border-left:3px solid rgba(255,255,255,0)}.add-new-profile-row,.all-profile-row{border-top:rgba(128,128,128,.25) solid 1px}.all-profiles{display:flex;justify-content:space-between}.all-profiles:has(.all-profile-arrow-close){align-items:center}.all-profile-arrow{display:inline-block;height:.7rem;width:.7rem;border-color:#000;transform:rotate(-45deg)}.all-profile-arrow-open{border-left:solid 2px;border-bottom:solid 2px}.all-profile-arrow-close{border-right:solid 2px;border-top:solid 2px}.new-name-input{margin-left:3px;display:flex;flex-direction:column}.new-name-input .input-hint{font-size:smaller;font-weight:200;color:gray}.add-button{height:20px;line-height:20px;margin:3px 0 0 3px}\n"], dependencies: [{ kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "component", type: MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "component", type: MatButton, selector: "    button[matButton], a[matButton], button[mat-button], button[mat-raised-button],    button[mat-flat-button], button[mat-stroked-button], a[mat-button], a[mat-raised-button],    a[mat-flat-button], a[mat-stroked-button]  ", inputs: ["matButton"], exportAs: ["matButton", "matAnchor"] }, { kind: "directive", type: MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "aria-expanded", "aria-controls", "aria-owns", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }, { kind: "ngmodule", type: MatInputModule }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ProfilesMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-profiles-menu', imports: [MatIcon, MatTooltip, MatIconButton, MatMenuModule, MatButton, MatInput,
                        MatCheckbox, StopPropagationDirective, MatInputModule, FormsModule
                    ], template: "@if(!$isMatMenuChild())\r\n{\r\n  <button #trigger=\"matMenuTrigger\" color=\"primary\" mat-icon-button [matMenuTriggerFor]=\"menu\" [matTooltip]=\"'Profiles'\">\r\n    <mat-icon color=\"primary\">people</mat-icon>\r\n  </button>\r\n}\r\n<mat-menu #menu=\"matMenu\" (closed)=\"addedKey.value = null; allProfilesPanelOpened.set(false); newProfilePanelOpened.set(false)\">\r\n  @if(!!$currentProfile())\r\n  {\r\n    <div mat-menu-item mat-stroked-button [matTooltip]=\"'Save Profile'\" (click)=\"saveState($currentProfile()!)\">\r\n      <mat-icon color=\"primary\">save</mat-icon>\r\n      <span>{{$currentProfile()}}</span>\r\n    </div>\r\n  }\r\n  @else\r\n  {\r\n    <div class=\"profile-line\">\r\n      <button color=\"primary\" class=\"first-in-line first-button\" mat-stroked-button (click)=\"addState(defaultName, m.checked);\">\r\n        <mat-icon class=\"save-for-default-icon button-save-icon\" color=\"primary\">save</mat-icon>\r\n        <span>Save as <span class=\"current-name\">{{defaultName}}</span> </span>\r\n      </button>\r\n      <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Created As Default'\" (click)=\"m.toggle()\" >\r\n        <mat-icon style=\"color: green;\">{{m.checked ? 'star' : 'star_border'}}</mat-icon>\r\n      </button>\r\n      <mat-checkbox #m class=\"display-none\" [checked]=\"true\" />\r\n    </div>\r\n  }\r\n  @if (allProfilesPanelOpened()) {<hr class=\"divider\"/>}\r\n  <div mat-menu-item stop-propagation [class]=\"{ hide: !$keys().length, 'all-profile-row': true }\" (click)=\"allProfilesPanelOpened.set(!allProfilesPanelOpened())\">\r\n    <div class=\"all-profiles\">\r\n      <span>All Profiles</span>\r\n      <span class=\"arrow\" [class]=\"`${(allProfilesPanelOpened() ? 'all-profile-arrow-close' : 'all-profile-arrow-open')} all-profile-arrow`\"></span>\r\n    </div>\r\n  </div>\r\n  <div [class]=\"{ hide: !allProfilesPanelOpened(), panel: true }\">\r\n    @for (key of $keys() ; track key)\r\n    {\r\n      <div class=\"profile-line\" [class]=\"key === $currentProfile() ? 'current-in-list' : 'not-current-in-list'\">\r\n        <button class=\"menu-item first-in-line\" mat-stroked-button [matTooltip]=\"'Select Profile'\" (click)='stateService.setLocalCurrentState({ tableId: $tableId(), currentStateKey: key})'>\r\n          <span>{{key}}</span>\r\n        </button>\r\n        @if(key !== $defaultProfile())\r\n        {\r\n          <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Default'\" (click)=\"setDefault(key)\">\r\n            <mat-icon style=\"color: green;\">star_border</mat-icon>\r\n          </button>\r\n        }\r\n        @else\r\n        {\r\n          <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Default'\" (click)=\"unsetDefault()\">\r\n            <mat-icon style=\"color: green;\">star</mat-icon>\r\n          </button>\r\n        }\r\n        <button color=\"warn\" class=\"last-in-line\" stop-propagation mat-icon-button [matTooltip]=\"'Delete Profile'\" (click)='stateService.deleteProfileFromLocalAndStorage($tableId(), key)'>\r\n          <mat-icon color='warn'>delete_forever</mat-icon>\r\n        </button>\r\n      </div>\r\n    }\r\n    <hr class=\"divider\"/>\r\n  </div>\r\n  <div class=\"add-new-profile-row\" mat-menu-item stop-propagation (click)=\"newProfilePanelOpened.set(!newProfilePanelOpened()); addedKey.focus()\">Add New Profile</div>\r\n  <div [class]=\"{ hide: !newProfilePanelOpened(), panel: true }\" >\r\n    <div class=\"profile-line\" stop-propagation>\r\n      <div class=\"new-name-input\">\r\n        <i class=\"input-hint\">Enter New Name</i>\r\n        <input #addedKey=\"matInput\" matInput [name]=\"'key'\" />\r\n      </div>\r\n      <button stop-propagation mat-icon-button [matTooltip]=\"'Toggle Profile Being Created As Default'\" (click)=\"m2.toggle()\" >\r\n        <mat-icon style=\"color: green;\">{{m2.checked ? 'star' : 'star_border'}}</mat-icon>\r\n      </button>\r\n      <mat-checkbox #m2 class=\"display-none\" [ngModel]=\"!$defaultProfile()\" />\r\n    </div>\r\n    <button class=\"add-button\" color=\"primary\" mat-raised-button [matTooltip]=\"'Create New Profile'\" [disabled]=\"!addedKey.value\" (click)=\"addState(addedKey.value, m2.checked); addedKey.value = null\">\r\n      Add\r\n    </button>\r\n  </div>\r\n</mat-menu>\r\n", styles: [":host ::ng-deep .mat-expansion-panel-header{padding:0}.current-name{color:var(tb-current-profile, blue)}.menu-item{display:inline-flex;width:initial;flex-grow:1}.profile-line{display:flex;justify-content:space-between;align-items:center}.first-in-line{--f-b: 2rem;margin-left:var(--mat-menu-item-with-icon-leading-spacing)}.first-in-line.first-button{height:var(--f-b);margin:.2rem}.first-in-line .button-save-icon{height:var(--f-b);width:var(--f-b);font-size:var(--f-b)}.main-save-button{height:4rem;width:4rem;padding:.5rem}.main-save-button mat-icon{height:3rem;width:3rem;font-size:3rem}.save-for-default-icon{margin:0}.display-none{display:none}.last-in-line{padding-right:var(--mat-menu-item-with-icon-trailing-spacing)}.default-cursor{cursor:default}.as-def{padding-left:var(--mat-menu-item-with-icon-leading-spacing)}.divider{margin:.2px 0}.add-key{max-width:8.5rem;margin-left:2px}.add-key ::ng-deep .mdc-text-field{padding:0}.panel{transition:height .1s}.hide{height:0;min-height:0;overflow:hidden}.open-panel-button{width:100%;height:2.5rem}.current-in-list{border-left:3px solid blue;background-color:#0000ff0d}.not-current-in-list{border-left:3px solid rgba(255,255,255,0)}.add-new-profile-row,.all-profile-row{border-top:rgba(128,128,128,.25) solid 1px}.all-profiles{display:flex;justify-content:space-between}.all-profiles:has(.all-profile-arrow-close){align-items:center}.all-profile-arrow{display:inline-block;height:.7rem;width:.7rem;border-color:#000;transform:rotate(-45deg)}.all-profile-arrow-open{border-left:solid 2px;border-bottom:solid 2px}.all-profile-arrow-close{border-right:solid 2px;border-top:solid 2px}.new-name-input{margin-left:3px;display:flex;flex-direction:column}.new-name-input .input-hint{font-size:smaller;font-weight:200;color:gray}.add-button{height:20px;line-height:20px;margin:3px 0 0 3px}\n"] }]
        }] });

class SortMenuComponentStore extends ComponentStore {
    constructor() {
        super({ notSorted: [], sorted: [] });
        this.tableState = inject(TableStore);
        this.setStoreStateEffect = effect(() => {
            const metaData = this.tableState.$metaData();
            if (!metaData)
                return;
            this.tableState.$selectSorted();
            untracked(() => this.setStateFromTableStore());
        });
        this.setStateFromTableStore = () => {
            const metaData = this.tableState.$metaData();
            const sorted = [...this.tableState.$selectSorted()].map(s => ({
                ...s,
                displayName: metaData[s.active]?.displayName
            }));
            const notSorted = this.tableState.$metaDataArray()
                .filter(md => (md.fieldType !== FieldType.NotMapped || md.sortLogic?.sortBy) && !md.noSort && !sorted.some(s => s.active === md.key))
                .map(meta => ({ active: meta.key, displayName: meta.displayName }));
            this.setState({ sorted, notSorted });
        };
        this.setSorted = this.updater((state, sorted) => ({ ...state, sorted }));
        this.setNotSorted = this.updater((state, notSorted) => ({ ...state, notSorted }));
        this.$sorted = this.selectSignal(state => state.sorted);
        this.$notSorted = this.selectSignal(state => state.notSorted);
        this.setDirection = this.updater((state, sort) => {
            const index = state.sorted.findIndex(s => s.active === sort.active);
            const sorted = [...state.sorted];
            sorted.splice(index, 1, sort);
            return ({ ...state, sorted });
        });
        this.reset = () => {
            this.setStateFromTableStore();
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SortMenuComponentStore, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SortMenuComponentStore }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SortMenuComponentStore, decorators: [{
            type: Injectable
        }], ctorParameters: () => [] });

class SortMenuComponent {
    constructor() {
        this.SortDirection = SortDirection;
        this.tableState = inject(TableStore);
        this.store = inject(SortMenuComponentStore);
        this.$sorted = computed(() => [...this.store.$sorted()]);
        this.$notSorted = computed(() => [...this.store.$notSorted()]);
        this.$dirty = signal(false);
        this.apply = () => {
            this.$dirty.set(false);
            this.tableState.setAllSort(this.store.$sorted());
        };
    }
    reset() {
        this.$dirty.set(false);
        this.store.reset();
    }
    dropIntoSorted(event) {
        this.$dirty.set(true);
        const sorted = [...event.container.data];
        if (event.previousContainer === event.container) {
            moveItemInArray(sorted, event.previousIndex, event.currentIndex);
            this.store.setSorted(sorted);
        }
        else {
            const notSorted = [...event.previousContainer.data];
            transferArrayItem(notSorted, sorted, event.previousIndex, event.currentIndex);
            sorted[event.currentIndex] = { ...sorted[event.currentIndex], direction: SortDirection.asc };
            this.store.setSorted(sorted);
            this.store.setNotSorted(notSorted);
        }
    }
    dropIntoNotSorted(event) {
        if (event.previousContainer === event.container) {
            return;
        }
        else {
            this.$dirty.set(true);
            const sorted = [...event.previousContainer.data];
            const notSorted = [...event.container.data];
            transferArrayItem(sorted, notSorted, event.previousIndex, event.currentIndex);
            notSorted[event.currentIndex] = { ...notSorted[event.currentIndex] };
            this.store.setNotSorted(notSorted);
            this.store.setSorted(sorted);
        }
    }
    setDirection(sort) {
        this.$dirty.set(true);
        this.store.setDirection(sort);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SortMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: SortMenuComponent, isStandalone: true, selector: "tb-sort-menu", providers: [SortMenuComponentStore], ngImport: i0, template: "@let dirty = $dirty();\r\n@let sorted = $sorted();\r\n@let notSorted = $notSorted();\r\n\r\n<!-- Menu Trigger -->\r\n<span matTooltip=\"Sort\">\r\n  <button color=\"primary\" mat-icon-button [matMenuTriggerFor]=\"menu\">\r\n    <mat-icon color=\"primary\">swap_vert</mat-icon>\r\n  </button>\r\n</span>\r\n\r\n<!-- Menu -->\r\n<mat-menu #menu=\"matMenu\"  class=\"my-mat-menu\" (closed)=\"reset()\">\r\n  <div mat-menu-item class=\"menu-button\">\r\n    <div class=\"close-button-wrapper\">\r\n      <span matTooltip=\"Close\">\r\n        <mat-icon>close</mat-icon>\r\n      </span>\r\n      @if(dirty)\r\n      {\r\n        <span matTooltip=\"Undo\" stop-propagation (click)=\"reset()\">\r\n          <mat-icon>undo</mat-icon>\r\n        </span>\r\n      }\r\n        \r\n    </div>\r\n  </div>\r\n\r\n  <!-- Apply Button -->\r\n  <div class=\"apply-button-wrapper\">\r\n    <button mat-button color=\"primary\" stop-propagation\r\n      [class.apply-border]=\"dirty\" [disabled]=\"!dirty\"\r\n      (click)=\"apply()\">\r\n        Apply @if (dirty) { Unsaved Changes }\r\n    </button>\r\n  </div>\r\n\r\n  <!-- Default Sorting Text -->\r\n  @if (!sorted.length)\r\n  {\r\n    <div class=\"tip\" >\r\n      Sorting List\r\n    </div>\r\n  }\r\n\r\n  <!-- Sorted Menu List -->\r\n  <div #sortedGroup=\"cdkDropList\"\r\n    class=\"list\"\r\n    cdkDropList\r\n    [cdkDropListConnectedTo]=\"[notSortedGroup]\"\r\n    [cdkDropListData]=\"sorted\"\r\n    (cdkDropListDropped)=\"dropIntoSorted($event)\">\r\n\r\n    <!-- Menu Item Wrapper -->\r\n    @for (sort of sorted; track sort.active)\r\n    {\r\n      <!-- Menu Item Headers -->\r\n      @if (sorted.length > 1)\r\n      {\r\n        <span class=\"description sort-header\">{{$index === 0 ? 'First By' : 'Then By'}}</span>\r\n      }\r\n\r\n      <!-- Menu Item -->\r\n      <div mat-menu-item   cdkDrag class=\"menu-item\">\r\n        <div class=\"sort-item\">\r\n          <span class=\"sorted-name\">\r\n            {{sort.displayName || (sort.active | spaceCase)}}\r\n            <span class=\"direction-text\">{{sort.direction}}</span>\r\n          </span>\r\n\r\n          <!-- Sort Direction Buttons -->\r\n          <div class=\"up-down-buttons-wrapper\">\r\n            <button  class=\"up-down-button up-button\" stop-propagation\r\n            (click)=\"setDirection({active:sort.active,direction:SortDirection.asc,displayName:sort.displayName})\">\r\n              <mat-icon class=\"up-down-icon\" [class]=\"sort.direction !== SortDirection.asc ? 'light-arrow' : 'dark-arrow'\">\r\n              arrow_upward\r\n              </mat-icon>\r\n            </button>\r\n\r\n            <button class=\"up-down-button\" stop-propagation\r\n            (click)=\"setDirection({active:sort.active,direction:SortDirection.desc,displayName:sort.displayName})\">\r\n              <mat-icon class=\"up-down-icon\" [class]=\"sort.direction === SortDirection.asc ? 'light-arrow' : 'dark-arrow'\">\r\n                arrow_downward\r\n              </mat-icon>\r\n            </button>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    }\r\n\r\n  </div>\r\n\r\n  <!-- Default Not Sorted Text -->\r\n  @if(!notSorted.length)\r\n  {\r\n    <div class=\"tip\" >\r\n      Not Sorted List\r\n    </div>\r\n  }\r\n\r\n  <!-- Not Sorted Menu List -->\r\n  <div #notSortedGroup=\"cdkDropList\"\r\n    class=\"list\"\r\n    cdkDropList\r\n    [cdkDropListConnectedTo]=\"[sortedGroup]\"\r\n    [cdkDropListData]=\"notSorted\"\r\n    (cdkDropListDropped)=\"dropIntoNotSorted($event)\">\r\n    @for (sort of notSorted; track sort.active)\r\n    {\r\n      <div mat-menu-item class=\"menu-item\" cdkDrag>\r\n        <span class=\"not-sorted-name\">{{sort.displayName || (sort.active | spaceCase)}}</span>\r\n      </div>\r\n    }\r\n  </div>\r\n</mat-menu>\r\n", styles: [".cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.list{padding:5px 2px;border-bottom:solid 1px #ccc;color:#000000de;background:#fff}.light-arrow{color:#93b1ea78}.dark-arrow{color:#224e9c}.up-down-button{background-color:#fff;border-radius:30%;border-color:#0ff;padding:1px 1px 0;border-width:.5px;cursor:pointer;height:27px}.mat-icon.up-down-icon{margin-right:0;font-size:20px;font-weight:lighter}.sort-item{display:flex;align-items:center;justify-content:space-between}.up-down-buttons-wrapper{margin-left:2rem}.up-button{margin-right:.3rem}.mat-mdc-menu-item.menu-item,.mat-mdc-menu-item.menu-button{min-height:initial;padding:0 3px;line-height:25px;height:30px}.mat-mdc-menu-item.menu-item{cursor:move}.sorted-name{color:#224e9c;font-size:17px;font-weight:700}.not-sorted-name{color:#93b1ea;font-size:17px;font-weight:700}.apply-border{border:#224e9c solid .5px}.apply-border:hover{background-color:#faebd7}.apply-button-wrapper{display:grid;justify-content:center}.sort-header{font-size:10px;font-style:italic}.tip{padding:0 3px;color:#d3d3d3}.direction-text{font-size:small;font-weight:400}.close-button-wrapper{display:flex;flex-direction:row-reverse}\n"], dependencies: [{ kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatButton, selector: "    button[matButton], a[matButton], button[mat-button], button[mat-raised-button],    button[mat-flat-button], button[mat-stroked-button], a[mat-button], a[mat-raised-button],    a[mat-flat-button], a[mat-stroked-button]  ", inputs: ["matButton"], exportAs: ["matButton", "matAnchor"] }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }, { kind: "ngmodule", type: DragDropModule }, { kind: "directive", type: i5.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep", "cdkDropListElementContainer"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i5.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer", "cdkDragScale"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "pipe", type: SpaceCasePipe, name: "spaceCase" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: SortMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-sort-menu', providers: [SortMenuComponentStore], changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        MatTooltipModule, MatButtonModule, MatIconModule, MatMenuModule, StopPropagationDirective, DragDropModule,
                        SpaceCasePipe
                    ], template: "@let dirty = $dirty();\r\n@let sorted = $sorted();\r\n@let notSorted = $notSorted();\r\n\r\n<!-- Menu Trigger -->\r\n<span matTooltip=\"Sort\">\r\n  <button color=\"primary\" mat-icon-button [matMenuTriggerFor]=\"menu\">\r\n    <mat-icon color=\"primary\">swap_vert</mat-icon>\r\n  </button>\r\n</span>\r\n\r\n<!-- Menu -->\r\n<mat-menu #menu=\"matMenu\"  class=\"my-mat-menu\" (closed)=\"reset()\">\r\n  <div mat-menu-item class=\"menu-button\">\r\n    <div class=\"close-button-wrapper\">\r\n      <span matTooltip=\"Close\">\r\n        <mat-icon>close</mat-icon>\r\n      </span>\r\n      @if(dirty)\r\n      {\r\n        <span matTooltip=\"Undo\" stop-propagation (click)=\"reset()\">\r\n          <mat-icon>undo</mat-icon>\r\n        </span>\r\n      }\r\n        \r\n    </div>\r\n  </div>\r\n\r\n  <!-- Apply Button -->\r\n  <div class=\"apply-button-wrapper\">\r\n    <button mat-button color=\"primary\" stop-propagation\r\n      [class.apply-border]=\"dirty\" [disabled]=\"!dirty\"\r\n      (click)=\"apply()\">\r\n        Apply @if (dirty) { Unsaved Changes }\r\n    </button>\r\n  </div>\r\n\r\n  <!-- Default Sorting Text -->\r\n  @if (!sorted.length)\r\n  {\r\n    <div class=\"tip\" >\r\n      Sorting List\r\n    </div>\r\n  }\r\n\r\n  <!-- Sorted Menu List -->\r\n  <div #sortedGroup=\"cdkDropList\"\r\n    class=\"list\"\r\n    cdkDropList\r\n    [cdkDropListConnectedTo]=\"[notSortedGroup]\"\r\n    [cdkDropListData]=\"sorted\"\r\n    (cdkDropListDropped)=\"dropIntoSorted($event)\">\r\n\r\n    <!-- Menu Item Wrapper -->\r\n    @for (sort of sorted; track sort.active)\r\n    {\r\n      <!-- Menu Item Headers -->\r\n      @if (sorted.length > 1)\r\n      {\r\n        <span class=\"description sort-header\">{{$index === 0 ? 'First By' : 'Then By'}}</span>\r\n      }\r\n\r\n      <!-- Menu Item -->\r\n      <div mat-menu-item   cdkDrag class=\"menu-item\">\r\n        <div class=\"sort-item\">\r\n          <span class=\"sorted-name\">\r\n            {{sort.displayName || (sort.active | spaceCase)}}\r\n            <span class=\"direction-text\">{{sort.direction}}</span>\r\n          </span>\r\n\r\n          <!-- Sort Direction Buttons -->\r\n          <div class=\"up-down-buttons-wrapper\">\r\n            <button  class=\"up-down-button up-button\" stop-propagation\r\n            (click)=\"setDirection({active:sort.active,direction:SortDirection.asc,displayName:sort.displayName})\">\r\n              <mat-icon class=\"up-down-icon\" [class]=\"sort.direction !== SortDirection.asc ? 'light-arrow' : 'dark-arrow'\">\r\n              arrow_upward\r\n              </mat-icon>\r\n            </button>\r\n\r\n            <button class=\"up-down-button\" stop-propagation\r\n            (click)=\"setDirection({active:sort.active,direction:SortDirection.desc,displayName:sort.displayName})\">\r\n              <mat-icon class=\"up-down-icon\" [class]=\"sort.direction === SortDirection.asc ? 'light-arrow' : 'dark-arrow'\">\r\n                arrow_downward\r\n              </mat-icon>\r\n            </button>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    }\r\n\r\n  </div>\r\n\r\n  <!-- Default Not Sorted Text -->\r\n  @if(!notSorted.length)\r\n  {\r\n    <div class=\"tip\" >\r\n      Not Sorted List\r\n    </div>\r\n  }\r\n\r\n  <!-- Not Sorted Menu List -->\r\n  <div #notSortedGroup=\"cdkDropList\"\r\n    class=\"list\"\r\n    cdkDropList\r\n    [cdkDropListConnectedTo]=\"[sortedGroup]\"\r\n    [cdkDropListData]=\"notSorted\"\r\n    (cdkDropListDropped)=\"dropIntoNotSorted($event)\">\r\n    @for (sort of notSorted; track sort.active)\r\n    {\r\n      <div mat-menu-item class=\"menu-item\" cdkDrag>\r\n        <span class=\"not-sorted-name\">{{sort.displayName || (sort.active | spaceCase)}}</span>\r\n      </div>\r\n    }\r\n  </div>\r\n</mat-menu>\r\n", styles: [".cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.list{padding:5px 2px;border-bottom:solid 1px #ccc;color:#000000de;background:#fff}.light-arrow{color:#93b1ea78}.dark-arrow{color:#224e9c}.up-down-button{background-color:#fff;border-radius:30%;border-color:#0ff;padding:1px 1px 0;border-width:.5px;cursor:pointer;height:27px}.mat-icon.up-down-icon{margin-right:0;font-size:20px;font-weight:lighter}.sort-item{display:flex;align-items:center;justify-content:space-between}.up-down-buttons-wrapper{margin-left:2rem}.up-button{margin-right:.3rem}.mat-mdc-menu-item.menu-item,.mat-mdc-menu-item.menu-button{min-height:initial;padding:0 3px;line-height:25px;height:30px}.mat-mdc-menu-item.menu-item{cursor:move}.sorted-name{color:#224e9c;font-size:17px;font-weight:700}.not-sorted-name{color:#93b1ea;font-size:17px;font-weight:700}.apply-border{border:#224e9c solid .5px}.apply-border:hover{background-color:#faebd7}.apply-button-wrapper{display:grid;justify-content:center}.sort-header{font-size:10px;font-style:italic}.tip{padding:0 3px;color:#d3d3d3}.direction-text{font-size:small;font-weight:400}.close-button-wrapper{display:flex;flex-direction:row-reverse}\n"] }]
        }] });

class ResetMenuComponent {
    constructor() {
        this.menu = viewChild.required(MatMenu);
        this.tableContainer = inject(TableContainerComponent);
        this.state = this.tableContainer.state;
        this.onStateReset$ = output({ alias: 'onStateReset' });
        this.$filtersSet = computed(() => {
            return Object.values(this.state.$filters())
                .filter(f => (isCustomFilter(f) && f.active) || f.filterValue != undefined)
                .length;
        });
        this.$sortSet = computed(() => {
            const sorts = this.state.$selectSorted();
            if (!sorts.length)
                return false;
            const preSorts = this.state.$preSort();
            if (!preSorts.length)
                return true;
            return !sortsAreSame(preSorts, sorts);
        });
        this.$groupBySet = computed(() => this.state.$groupByKeys().length);
        this.$hiddenSet = computed(() => this.state.$hiddenKeys().length);
        this.$orderSet = computed(() => Object.keys(this.state.$userDefinedOrder()).length);
        this.$widthsSet = computed(() => Object.keys(this.state.$getUserDefinedWidths()).length);
        this.$rowHeightSet = this.state.$userDefinedRowHeight;
        this.headerHeightSet = this.state.$userDefinedHeaderHeight;
        this.pageSizeSet = computed(() => this.state.$userDefinedPageSize() && this.state.$userDefinedPageSize() !== this.state.selectSignal(s => s.pageSize)());
        this.showAllSet = this.state.selectSignal(s => s.userDefined.showAll);
        this.$set = computed(() => {
            const arr = [];
            if (this.$filtersSet()) {
                arr.push('Filters');
            }
            if (this.$sortSet()) {
                arr.push('Sorting');
            }
            if (this.$groupBySet()) {
                arr.push('Group By');
            }
            if (this.$hiddenSet()) {
                arr.push('Hidden Columns');
            }
            if (this.$orderSet()) {
                arr.push('Column Order');
            }
            if (this.$widthsSet()) {
                arr.push('Column Widths');
            }
            if (this.$rowHeightSet()) {
                arr.push('Row Height');
            }
            if (this.headerHeightSet()) {
                arr.push('Header Height');
            }
            if (this.pageSizeSet()) {
                arr.push('Page Size');
            }
            if (this.showAllSet()) {
                arr.push('Show All');
            }
            return arr;
        });
        this.resetable = resetable;
    }
    resetState() {
        this.tableContainer.$customFilterDirectives().forEach(cf => cf.reset());
        this.tableContainer.$filterDirectives().forEach(cf => cf.reset());
        this.state.resetState();
        this.onStateReset$.emit(null);
    }
    reset(s) {
        this.state.resetPart(s);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ResetMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ResetMenuComponent, isStandalone: true, selector: "lib-reset-menu", outputs: { onStateReset$: "onStateReset" }, viewQueries: [{ propertyName: "menu", first: true, predicate: MatMenu, descendants: true, isSignal: true }], ngImport: i0, template: "<mat-menu #menu2=\"matMenu\">\r\n  @if($set().length > 1)\r\n  {\r\n    <button mat-menu-item (click)=\"state.resetState()\">All</button>\r\n  }\r\n  @for (item of $set(); track $index)\r\n  {\r\n    <button mat-menu-item (click)=\"state.resetPart(item)\">Reset {{item}}</button>\r\n  }\r\n</mat-menu>", styles: [":host{display:contents}\n"], dependencies: [{ kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "ngmodule", type: MatButtonModule }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ResetMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-reset-menu', imports: [MatMenuModule, MatButtonModule], changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-menu #menu2=\"matMenu\">\r\n  @if($set().length > 1)\r\n  {\r\n    <button mat-menu-item (click)=\"state.resetState()\">All</button>\r\n  }\r\n  @for (item of $set(); track $index)\r\n  {\r\n    <button mat-menu-item (click)=\"state.resetPart(item)\">Reset {{item}}</button>\r\n  }\r\n</mat-menu>", styles: [":host{display:contents}\n"] }]
        }] });

class TableHeaderMenuComponent {
    constructor() {
        this.menu = viewChild.required(MatMenu);
        this.exportToCsvService = inject(ExportToCsvService);
        this.tableContainer = inject(TableContainerComponent);
        this.state = this.tableContainer.state;
        this.$rowHeightNum = computed(() => +(this.tableContainer.$genericTable()?.$rowHeight()?.replace('px', '') || 0) || undefined);
        this.$headerHeightNum = computed(() => +(this.tableContainer.$genericTable()?.$headerHeight()?.replace('px', '') || 0) || undefined);
    }
    exportToCsv() {
        this.exportToCsvService.exportToCsv(this.tableContainer.$data());
    }
    updateHeight(v, element) {
        if (+element.value < 10)
            element.value = '10';
        if (+element.value > 100)
            element.value = '100';
        if (v === 'row')
            this.state.setUserDefinedRowHeight(+element.value);
        if (v === 'header')
            this.state.setUserDefinedHeaderHeight(+element.value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableHeaderMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: TableHeaderMenuComponent, isStandalone: true, selector: "lib-table-header-menu", viewQueries: [{ propertyName: "menu", first: true, predicate: MatMenu, descendants: true, isSignal: true }], ngImport: i0, template: "<span [matTooltip]=\"!r.$set().length ? 'Nothing To Reset' : ''\">\r\n  <button #d=\"matMenuItem\" mat-menu-item [matMenuTriggerFor]=\"r.menu()\" [disabled]=\"!r.$set().length\">\r\n    <mat-icon color=\"primary\">autorenew</mat-icon>\r\n    <span>Reset</span>\r\n  </button>\r\n</span>\r\n@if (!tableContainer.state.$tableSettings().hideExport)\r\n{\r\n  <button mat-menu-item (click)=\"exportToCsv()\">\r\n    <mat-icon color=\"primary\">file_download</mat-icon>\r\n    <span>Export Table</span>\r\n  </button>\r\n}\r\n@if (tableContainer.$tableId(); as tableId)\r\n{\r\n  <button stop-propagation mat-menu-item [matMenuTriggerFor]=\"pm.menu()\">\r\n    <mat-icon color=\"primary\">people</mat-icon>\r\n    <span>Profiles</span>\r\n  </button>\r\n  <tb-profiles-menu #pm class=\"profiles-menu\" [tableId]=\"tableId\" [isMatMenuChild]=\"true\" />\r\n}\r\n\r\n\r\n<div mat-menu-item>\r\n  <div class=\"height-input-wrapper\">\r\n    <span>Row Height</span>\r\n    <input #i class=\"input\" stop-propagation type=\"number\" \r\n      placeholder=\"Set Size\"\r\n      [value]=\"$rowHeightNum()\"\r\n      [min]=\"10\"\r\n      [max]=\"100\" (change)=\"updateHeight('row', i)\" />\r\n  </div>\r\n</div>\r\n@if(!state.$tableSettings().hideHeader)\r\n{\r\n  <div mat-menu-item>\r\n    <div class=\"height-input-wrapper\">\r\n      <span>Header Height</span>\r\n      <input #i2 class=\"input\" stop-propagation type=\"number\"\r\n      placeholder=\"Set Size\"\r\n      [value]=\"$headerHeightNum()\"\r\n      [min]=\"10\"\r\n      [max]=\"100\" (change)=\"updateHeight('header', i2)\"/>\r\n    </div>\r\n  </div>\r\n}\r\n<lib-reset-menu #r/>\r\n\r\n", styles: [".input{appearance:none;outline:none;background:none;box-shadow:none;margin:0;font:inherit;color:inherit;border:1px solid black;border-radius:4px;width:50px;padding:0 0 0 4px}.input::placeholder{font-size:12px}.height-input-wrapper{display:flex;gap:4px}\n"], dependencies: [{ kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: ProfilesMenuComponent, selector: "tb-profiles-menu", inputs: ["tableId", "isMatMenuChild"] }, { kind: "component", type: ResetMenuComponent, selector: "lib-reset-menu", outputs: ["onStateReset"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: StopPropagationDirective, selector: "[stop-propagation]" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableHeaderMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-table-header-menu', imports: [MatMenuModule, MatIcon, ProfilesMenuComponent, ResetMenuComponent, MatTooltip, StopPropagationDirective], template: "<span [matTooltip]=\"!r.$set().length ? 'Nothing To Reset' : ''\">\r\n  <button #d=\"matMenuItem\" mat-menu-item [matMenuTriggerFor]=\"r.menu()\" [disabled]=\"!r.$set().length\">\r\n    <mat-icon color=\"primary\">autorenew</mat-icon>\r\n    <span>Reset</span>\r\n  </button>\r\n</span>\r\n@if (!tableContainer.state.$tableSettings().hideExport)\r\n{\r\n  <button mat-menu-item (click)=\"exportToCsv()\">\r\n    <mat-icon color=\"primary\">file_download</mat-icon>\r\n    <span>Export Table</span>\r\n  </button>\r\n}\r\n@if (tableContainer.$tableId(); as tableId)\r\n{\r\n  <button stop-propagation mat-menu-item [matMenuTriggerFor]=\"pm.menu()\">\r\n    <mat-icon color=\"primary\">people</mat-icon>\r\n    <span>Profiles</span>\r\n  </button>\r\n  <tb-profiles-menu #pm class=\"profiles-menu\" [tableId]=\"tableId\" [isMatMenuChild]=\"true\" />\r\n}\r\n\r\n\r\n<div mat-menu-item>\r\n  <div class=\"height-input-wrapper\">\r\n    <span>Row Height</span>\r\n    <input #i class=\"input\" stop-propagation type=\"number\" \r\n      placeholder=\"Set Size\"\r\n      [value]=\"$rowHeightNum()\"\r\n      [min]=\"10\"\r\n      [max]=\"100\" (change)=\"updateHeight('row', i)\" />\r\n  </div>\r\n</div>\r\n@if(!state.$tableSettings().hideHeader)\r\n{\r\n  <div mat-menu-item>\r\n    <div class=\"height-input-wrapper\">\r\n      <span>Header Height</span>\r\n      <input #i2 class=\"input\" stop-propagation type=\"number\"\r\n      placeholder=\"Set Size\"\r\n      [value]=\"$headerHeightNum()\"\r\n      [min]=\"10\"\r\n      [max]=\"100\" (change)=\"updateHeight('header', i2)\"/>\r\n    </div>\r\n  </div>\r\n}\r\n<lib-reset-menu #r/>\r\n\r\n", styles: [".input{appearance:none;outline:none;background:none;box-shadow:none;margin:0;font:inherit;color:inherit;border:1px solid black;border-radius:4px;width:50px;padding:0 0 0 4px}.input::placeholder{font-size:12px}.height-input-wrapper{display:flex;gap:4px}\n"] }]
        }] });

class TableVirtualScrollStrategy {
    constructor(scrollContainer, dataStore) {
        this.indexChange = new Subject();
        this.scrolledIndexChange = this.indexChange.pipe(distinctUntilChanged());
        this.$dataLengthChange = linkedSignal({
            source: () => this.$dataLength(),
            computation: (curr, previous) => ({ curr, previous: previous == undefined ? curr : previous.source })
        });
        this.$rowHeightChange = linkedSignal({
            source: () => this.$rowHeight(),
            computation: (curr, previous) => {
                return ({ curr, previous: previous == undefined ? curr : previous.source });
            }
        });
        this.$headerHeightChange = linkedSignal({
            source: () => this.$headerHeight(),
            computation: (curr, previous) => ({ curr, previous: previous == undefined ? curr : previous.source })
        });
        this.contentScrolled$ = new Subject();
        this.sub = subscriber(this.contentScrolled$.pipe(debounceTime(20), distinctUntilChanged()), offset => {
            this.updateContent('scroll');
        });
        this.#onDataLengthChange = effect(() => {
            const dataLengthChange = this.$dataLengthChange();
            untracked(() => {
                if (dataLengthChange.curr === dataLengthChange.previous)
                    return;
                this.updateContent('data length');
            });
        });
        this.#onHeaderChange = effect(() => {
            const headerHeightChange = this.$headerHeightChange();
            untracked(() => {
                if (headerHeightChange.curr === headerHeightChange.previous)
                    return;
                this.updateContent('header height');
            });
        });
        this.#onRowChange = effect(() => {
            const rowHeightChange = this.$rowHeightChange();
            untracked(() => {
                if (rowHeightChange.curr === rowHeightChange.previous)
                    return;
                this.updateContent('row height');
            });
        });
        this.$currentRange = signal({ start: 0, end: 0 });
        this.$rowHeight = scrollContainer.computedRowHeight;
        this.$headerHeight = scrollContainer.computedHeaderHeight;
        this.viewport = scrollContainer.viewport;
        this.dataStore = dataStore;
        this.$dataLength = scrollContainer.$dataLength;
    }
    onContentScrolled() {
        this.contentScrolled$.next(this.viewport().measureScrollOffset());
    }
    #onDataLengthChange;
    #onHeaderChange;
    #onRowChange;
    updateContent(trigger) {
        const viewport = this.viewport && this.viewport();
        if (!viewport || !this.$rowHeight) {
            return;
        }
        const currentContentHeight = +viewport._totalContentHeight().replace('px', '');
        const newContentHeight = this.$dataLength() * this.$rowHeight();
        if (currentContentHeight !== newContentHeight) {
            viewport.setTotalContentSize(newContentHeight);
            this.update(trigger, viewport, true);
            return;
        }
        this.update(trigger, viewport);
    }
    update(trigger, viewport, needsScroll = false) {
        if (!viewport.getViewportSize())
            return;
        const rowHeightChangeEvent = this.$rowHeightChange();
        const rowHeight = rowHeightChangeEvent.curr;
        const rowHeightAdjustment = trigger === 'row height' ? rowHeightChangeEvent.curr / rowHeightChangeEvent.previous : 1;
        const amountOfRows = Math.ceil((viewport.getViewportSize() - this.$headerHeight()) / rowHeight);
        const f = viewport.measureScrollOffset();
        const offset = viewport.measureScrollOffset() * rowHeightAdjustment;
        const buffer = 35 + Math.round((40 - rowHeight) / 10);
        const skip = Math.round(offset / rowHeight);
        const index = skip % 2 === 0 ? skip : skip - 1;
        const start = Math.max(0, index - buffer);
        const end = Math.min(this.$dataLength(), index + amountOfRows + buffer);
        if (start > this.$dataLength()) {
            this.viewport().scrollToOffset(0);
        }
        else if (f !== offset) {
            if (offset < f)
                viewport.scrollToOffset(offset);
            else
                setTimeout(() => {
                    viewport.scrollToOffset(offset);
                }, 0);
        }
        if (this.$currentRange().start === start && this.$currentRange().end === end) {
            return;
        }
        this.$currentRange.set({ start, end });
        viewport.setRenderedContentOffset(rowHeight * start);
        this.dataStore.patchState({ virtualScrollOffset: offset });
        viewport.setRenderedRange({ start, end });
        this.indexChange.next(index);
    }
    attach(viewport) { }
    onDataLengthChanged() { }
    detach() { }
    onContentRendered() { }
    onRenderedOffsetChanged() { }
    scrollToIndex(index, behavior) { }
}

class VirtualScrollContainer {
    constructor() {
        this.state = inject(TableStore);
        this.dataStore = inject(DataStore);
        this.viewport = viewChild.required(CdkVirtualScrollViewport);
        this.genericTable = contentChild(GenericTableComponent);
        this.tableContainer = inject(TableContainerComponent);
        this.defaultOptions = new VirtualScrollOptions();
        this.$usePaginator = this.state.selectSignal(s => s.notPersistedTableSettings.usePaginator);
        this.$pageSize = this.state.$pageSize;
        this.$currentPage = this.state.$currentPage;
        this.$showAll = this.state.$showAll;
        this.$stateDataLength = this.dataStore.selectSignal(s => s.sortedFilteredGroupedDataLength);
        this.viewPort$ = toObservable(this.viewport).pipe(notNull());
        this.$scrolledIndexChange = toSignal(this.viewPort$.pipe(switchMap$1(v => v.scrolledIndexChange)));
        this.$renderedRange = toSignal(this.viewPort$.pipe(switchMap$1(v => v.renderedRangeStream)));
        this.$virtualScrollOptions = computed(() => {
            if (this.state.$initializationState() >= InitializationState.Ready)
                return this.state.$tableSettings().virtualSettings;
            else
                return undefined;
        });
        this.$optionsSet = computed(() => !!this.$virtualScrollOptions());
        this.$dataLength = computed(() => {
            const paginated = this.$usePaginator() && !this.$showAll();
            const pageSize = this.$pageSize();
            const pageNumber = this.$currentPage();
            const dataLen = this.$stateDataLength();
            if (paginated)
                return Math.min(dataLen - (pageNumber * pageSize), pageSize);
            return dataLen;
        });
        this.#setViewportEffect = effect(() => {
            const viewport = this.viewport();
            const options = this.$optionsSet();
            untracked(() => {
                if (!!viewport && !!options) {
                    this.setSize(this.viewport().elementRef, 'initial');
                }
            });
        });
        this.#onRenderedRangeEffect = effect(() => {
            const renderedRange = this.$renderedRange();
            const viewport = this.viewport();
            if (!renderedRange)
                return;
            untracked(() => {
                this.dataStore.patchState({
                    virtualEnds: {
                        start: renderedRange.start,
                        end: renderedRange.end,
                    }
                });
                if (!viewport)
                    return;
                this.setSize(viewport.elementRef, 'rendered range');
            });
        });
        this.resizeHandler = () => {
            if (this.viewport() && this.$virtualScrollOptions()?.dynamicHeight) {
                this.setSize(this.viewport().elementRef, 'resize');
            }
        };
        this.computedRowHeight = computed(() => {
            const virtualScrollOptions = this.state.$tableSettings().virtualSettings;
            const rowHeight = this.state.$userDefinedRowHeight() || virtualScrollOptions?.rowHeight || this.state.$tableSettings().rowHeight || this.defaultOptions.rowHeight;
            return parseTbSizeToPixels(rowHeight) || 0;
        });
        this.computedHeaderHeight = computed(() => {
            if (this.state.$tableSettings().hideHeader)
                return 0;
            const virtualScrollOptions = this.state.$tableSettings().virtualSettings;
            const headerHeight = this.state.$userDefinedHeaderHeight() || virtualScrollOptions?.headerHeight || this.state.$tableSettings().headerHeight || this.defaultOptions.headerHeight;
            return parseTbSizeToPixels(headerHeight) || 0;
        });
        this.computedFooterHeight = computed(() => {
            return parseFloat(this.genericTable()?.$footerHeight()?.replace('px', '') || '0');
        });
        this.computedBuffer = computed(() => {
            const virtualScrollOptions = this.state.$tableSettings().virtualSettings;
            if (!virtualScrollOptions.dynamicalHeightBuffer)
                return 0;
            return parseTbSizeToPixels(virtualScrollOptions.dynamicalHeightBuffer) || 0;
        });
        this.scrollStrategy = new TableVirtualScrollStrategy(this, this.dataStore);
        addEventListener('resize', this.resizeHandler);
    }
    #setViewportEffect;
    #onRenderedRangeEffect;
    ngOnDestroy() {
        removeEventListener('resize', this.resizeHandler);
    }
    setSize(el, trigger) {
        const virtualScrollOptions = this.$virtualScrollOptions();
        if (!virtualScrollOptions)
            return;
        if (virtualScrollOptions.dynamicHeight) {
            this.calcDynamic(el);
            return;
        }
        const rowHeight = this.computedRowHeight();
        let amountOfVisibleItems = virtualScrollOptions?.amountOfVisibleItems || this.defaultOptions.amountOfVisibleItems;
        amountOfVisibleItems = Math.min(amountOfVisibleItems, this.$dataLength());
        let height = (rowHeight * amountOfVisibleItems);
        const footerHeight = this.computedFooterHeight();
        const headerHeight = this.computedHeaderHeight();
        height += (footerHeight + headerHeight);
        const maxViewPortHeightPx = parseTbSizeToPixels(virtualScrollOptions.maxViewPortHeight) || 0;
        if (virtualScrollOptions?.maxViewPortHeight && maxViewPortHeightPx)
            height = maxViewPortHeightPx;
        this.setHeight(height, el);
    }
    calcDynamic(el) {
        const virtualScrollOptions = this.$virtualScrollOptions();
        if (!virtualScrollOptions)
            return;
        const t = this.tableContainer.elementRef.nativeElement.querySelector(`#${TableContainerComponent.headerId}`);
        const rect = t?.getBoundingClientRect();
        const windowHeight = window.innerHeight;
        const distanceFromBottom = windowHeight - rect.bottom;
        const rowHeight = this.computedRowHeight();
        const footerHeight = this.computedFooterHeight();
        const headerHeight = this.computedHeaderHeight();
        const buffer = this.computedBuffer();
        const horizontalScrollPadding = el.nativeElement.scrollWidth > el.nativeElement.clientWidth ? 17 : 0;
        const maxViewPortHeightPx = parseTbSizeToPixels(virtualScrollOptions.maxViewPortHeight) || 0;
        let tableSize = distanceFromBottom;
        if (virtualScrollOptions?.maxViewPortHeight && maxViewPortHeightPx < tableSize) {
            tableSize = maxViewPortHeightPx;
        }
        const available = (distanceFromBottom - footerHeight)
            - headerHeight
            - (this.$usePaginator() ? 20 : 0)
            - buffer
            - horizontalScrollPadding;
        const amountOfRowsThatWillFit = Math.floor(available / rowHeight);
        const minAmountOfRows = virtualScrollOptions?.amountOfVisibleItems || this.defaultOptions.amountOfVisibleItems;
        const amountOfVisibleItems = Math.min(Math.max(amountOfRowsThatWillFit, minAmountOfRows), this.$dataLength());
        let height = (rowHeight * amountOfVisibleItems);
        height += (footerHeight + headerHeight + horizontalScrollPadding);
        this.setHeight(height, el);
    }
    setHeight(height, el) {
        const vsViewport = el.nativeElement;
        vsViewport.setAttribute('style', `height: ${height}px !important;`);
        this.viewport()?.checkViewportSize();
        const virtualScrollOffset = this.viewport()?.getOffsetToRenderedContentStart() ?? 0;
        this.dataStore.patchState({ virtualScrollOffset });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: VirtualScrollContainer, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.2.0", version: "20.0.3", type: VirtualScrollContainer, isStandalone: true, selector: "tb-virtual-scroll-container", queries: [{ propertyName: "genericTable", first: true, predicate: GenericTableComponent, descendants: true, isSignal: true }], viewQueries: [{ propertyName: "viewport", first: true, predicate: CdkVirtualScrollViewport, descendants: true, isSignal: true }], ngImport: i0, template: `
    <cdk-virtual-scroll-viewport>
      <ng-content/>
    </cdk-virtual-scroll-viewport>
  `, isInline: true, dependencies: [{ kind: "ngmodule", type: ScrollingModule }, { kind: "component", type: i1$8.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }], viewProviders: [
            {
                provide: VIRTUAL_SCROLL_STRATEGY,
                useFactory: (c) => c.scrollStrategy,
                deps: [forwardRef(() => VirtualScrollContainer)],
            },
        ], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: VirtualScrollContainer, decorators: [{
            type: Component,
            args: [{
                    selector: 'tb-virtual-scroll-container',
                    template: `
    <cdk-virtual-scroll-viewport>
      <ng-content/>
    </cdk-virtual-scroll-viewport>
  `,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    imports: [ScrollingModule],
                    viewProviders: [
                        {
                            provide: VIRTUAL_SCROLL_STRATEGY,
                            useFactory: (c) => c.scrollStrategy,
                            deps: [forwardRef(() => VirtualScrollContainer)],
                        },
                    ],
                }]
        }], ctorParameters: () => [] });

function buildInAllValuesFilter(config, previousMeta, currentMeta, data, metaTimestamp, dataTimestamp, currentAllFilters) {
    const currentAll = currentMeta.filter(m => m.additional?.filterOptions?.filterableValues === 'all values');
    if (dataTimestamp > metaTimestamp) {
        return currentAll.reduce((dict, md) => {
            dict[md.key] = buildFilter(data, md, config);
            return dict;
        }, {});
    }
    const previousAll = previousMeta.filter(m => m.additional?.filterOptions?.filterableValues === 'all values');
    const newCurrent = currentAll.filter(c => previousAll.every(p => c.key !== p.key));
    if (newCurrent.length) {
        const c = { ...currentAllFilters };
        newCurrent.forEach(md => c[md.key] = buildFilter(data, md, config));
        return c;
    }
    return currentAllFilters;
}
function buildFilter(data, metaData, config) {
    const map = createTransformer(metaData, config, true, true);
    return [...new Map(data.map(v => {
            const mappedV = map(v);
            return [mappedV?.toString(), mappedV];
        })).values()].filter(v => v != undefined).sort();
}

class TableContainerComponent {
    constructor() {
        this.state = inject(TableStore);
        this.dataStore = inject(DataStore);
        this.wrapper = inject(TableWrapperDirective, { optional: true });
        this.stateService = inject(TableBuilderStateStore);
        this.injector = inject(Injector);
        this.elementRef = inject(ElementRef);
        this.exportToCsvService = inject(ExportToCsvService);
        this.config = inject(TableBuilderConfigToken);
        this.dataSource = new TableBuilderDataSource(this.state, this.dataStore);
        this.$filterDirectives = contentChildren(TableFilterDirective, { descendants: true });
        this.$customFilterDirectives = contentChildren(TableCustomFilterDirective, { descendants: true });
        this.$paginatorComponent = viewChild(PaginatorComponent);
        this.$genericTable = viewChild(GenericTableComponent);
        this._$customRows = contentChildren((MatRowDef));
        this.$customRows = computed(() => [...this._$customRows()]);
        this.$customCells = contentChildren(CustomCellDirective);
        this.$menu = viewChild.required(MatMenu);
        this.menuInjector = Injector.create({
            providers: [{ provide: MatMenu, useFactory: () => this.$menu() }],
            parent: this.injector
        });
        this.$tableBuilder = input.required({ alias: 'tableBuilder' });
        this.$tableIdInput = input(undefined, { alias: 'tableId' });
        this.$trackByInput = input(undefined, { alias: 'trackBy' });
        this.$inputFilters = input([], { alias: 'inputFilters' });
        this.$filterInfoInputs = computed(() => this.$inputFilters().filter(i => !isFunction(i)));
        this.$indexColumnInput = input(false, { alias: 'indexColumn' });
        this.$selectionColumnInput = input(false, { alias: 'selectionColumn' });
        this.$stickyHeaderInput = input(true, { alias: 'stickyHeader' });
        this.$stickyFooterInput = input(false, { alias: 'stickyFooter' });
        this.$groupHeaderTemplate = input(undefined, { alias: 'groupHeaderTemplate' });
        this.$groupHeaderHeight = input(undefined, { alias: 'groupHeaderHeight' });
        this.$pageSize = input(undefined, { alias: 'pageSize' });
        this.selection$ = output({ alias: 'selection' });
        this.onStateReset$ = output({ alias: 'onStateReset' });
        this.onSaveState$ = output({ alias: 'onSaveState' });
        this.state$ = outputFromObservable(toObservable(this.state.$savableState), { alias: 'state' });
        this.$data = computed(() => this.$sortedAndFilteredData()?.value || []);
        this.data$ = outputFromObservable(toObservable(this.$data), { alias: 'data' });
        this.$displayData = computed(() => this.$tableBuilder() && this.$filteredSortedAndGrouped()?.displayData);
        this.expandAllGroups = () => {
            const groupHeaders = getAllGroupHeaderNames(this.$displayData());
            this.state.expandAllOfGroup({ groupHeadersByKey: groupHeaders });
        };
        this.collapseAllGroups = () => this.state.collapseAll();
        this.exportToCsv = () => this.exportToCsvService.exportToCsv(this.$data());
        this.$myColumns = computed(() => {
            return this.state.$metaDataArray().map(metaData => ({
                metaData,
                customCell: this.$customCells().filter(cc => cc.$inited()).find(cc => cc.$customCell() === metaData.key)
            }));
        });
        this.$useVirtual = this.state.$isVirtual;
        this.$collapsedFooter = this.state.$footerCollapsed;
        this.$collapsedHeader = this.state.$headerCollapsed;
        this.$displayDataLength = computed(() => this.$displayData()?.length || 0);
        this.$tableBuilderSettings = computed(() => this.$tableBuilder().$settings());
        this.$trackBy = computed(() => this.$trackByInput() || this.$tableBuilderSettings()?.tableSettings?.trackBy);
        this.$tableId = computed(() => this.$tableIdInput() || this.$tableBuilderSettings()?.tableSettings?.tableId);
        this.$includeSelectionColumn = computed(() => this.$selectionColumnInput() || !!this.$tableBuilderSettings()?.tableSettings?.includeSelectionColumn);
        this.$includeIndexColumn = computed(() => this.$indexColumnInput() || !!this.$tableBuilderSettings()?.tableSettings?.includeIndexColumn);
        this.$stickyHeader = computed(() => {
            const settings = this.$tableBuilderSettings()?.columnHeaderSettings?.stickyHeaderRow;
            if (settings != null) {
                return settings;
            }
            return this.$stickyHeaderInput();
        });
        this.$stickyFooter = computed(() => this.$stickyFooterInput() || !!this.$tableBuilderSettings()?.columnFooterSettings?.stickyFooterRow);
        this.$props = computed(() => {
            const indexColumn = this.$includeIndexColumn();
            const selectionColumn = this.$includeSelectionColumn();
            const stickHeader = this.$stickyHeader();
            const stickyFooter = this.$stickyFooter();
            const groupHeaderTemplate = this.$groupHeaderTemplate();
            const groupHeaderHeight = this.$groupHeaderHeight();
            return ({ indexColumn, selectionColumn, isSticky: stickHeader, stickyFooter, groupHeaderTemplate, groupHeaderHeight });
        });
        this.#initTableBuilder = effect(() => {
            const tb = this.$tableBuilder();
            untracked(() => {
                if (tb) {
                    tb?.prep(this.injector);
                    tb.container.set(this);
                }
            });
        });
        this.#initializeTableSettingsFromTableBuilderAndPersistedStateEffect = effect(() => {
            const metaLoaded = this.$isInitializationState(InitializationState.MetaDataLoaded)();
            if (!metaLoaded)
                return;
            const persistedState = this.$persistedState();
            const tbSettings = this.$tableBuilderSettings();
            untracked(() => {
                this.state.setTableSettings(tbSettings);
                if (persistedState) {
                    persistedState.persistedTableSettings = new PersistedTableSettings(persistedState.persistedTableSettings);
                    this.state.updateStateFromPersistedState(persistedState);
                }
                this.state.setInitializationState(InitializationState.Ready);
            });
        });
        this.#setPageSizeFromInputEffect = effect(() => {
            const pageSize = this.$pageSize();
            const userDefinedPageSize = this.state.$userDefinedPageSize();
            if (pageSize && !userDefinedPageSize) {
                untracked(() => this.state.setPageSize(pageSize));
            }
        });
        this.#patchedFilters = [];
        this.#patchSavableFilterDirectivesFromPersistedStateEffect = effect(() => {
            const loaded = this.$isInitializationState(InitializationState.TableSettingsLoaded)();
            const filterDirectives = this.$allFilterDirectives();
            if (!loaded || !filterDirectives.length)
                return;
            const stateFilters = this.state.$filters();
            untracked(() => {
                filterDirectives.filter(f => f.savable && !this.#patchedFilters.includes(f.filterId)).forEach(f => {
                    this.#patchedFilters.push(f.filterId);
                    const filter = stateFilters[f.filterId];
                    patchDirectiveFromState(f, filter);
                    this.state.addFilter(f.filter$);
                });
            });
        });
        this.#patchSavableFilterInputsFromPersistedStateEffect = effect(() => {
            const loaded = this.$isInitializationState(InitializationState.TableSettingsLoaded)();
            const inputFilters = this.$filterInfoInputs();
            if (!loaded || !inputFilters.length)
                return;
            untracked(() => {
                const stateFilters = this.state.$filters();
                inputFilters.filter(f => f.filterId).forEach(f => {
                    const patched = this.#patchedFilters.includes(f.filterId);
                    const stateFilter = stateFilters[f.filterId];
                    if (patched || !stateFilter) {
                        this.state.addFilter(f);
                    }
                    else if (isCustomFilter(f)) {
                        stateFilter.predicate = f.predicate;
                        this.state.addFilter(stateFilter);
                    }
                    this.#patchedFilters.push(f.filterId);
                });
            });
        });
        this.#addPropsToStoreFromInputsEffect = effect(() => {
            const props = this.$props();
            untracked(() => this.state.setProps(props));
        });
        this.#addMetaDataToStoreEffect = effect(() => {
            const allMetaDatas = this.$allMetaDatas();
            if (!allMetaDatas)
                return;
            untracked(() => {
                this.state.setMetaData(allMetaDatas);
                this.state.setLinkMaps(createLinkCreatorDict(allMetaDatas));
            });
        });
        this.#setFilteredDataLengthEffect = effect(() => {
            const tableBuilder = this.$tableBuilder();
            const data = this.$sortedAndFilteredData();
            if (!tableBuilder || !data)
                return;
            untracked(() => {
                this.dataStore.patchState({ sortedFilteredDataLength: data.value.length });
            });
        });
        this.#setDataSourceDataEffect = effect(() => {
            const tableBuilder = this.$tableBuilder();
            const flat = this.$filteredSortedAndGrouped();
            if (!tableBuilder || !flat)
                return;
            untracked(() => {
                const data = flat.displayData;
                this.dataSource.setData(data);
                this.dataStore.patchState({ sortedFilteredGroupedDataLength: data.length });
            });
        });
        this.#destroyRef = inject(DestroyRef).onDestroy(() => {
            const tableId = this.$tableId();
            if (tableId) {
                this.stateService.saveTableStateToLocal({ tableId, tableState: this.state.$savableState() });
            }
        });
        this.$persistedState = computed(() => {
            const tableId = this.$tableId();
            if (tableId) {
                return this.stateService.$selectLocalTableStateForView(tableId)();
            }
            return undefined;
        });
        this.$allFilterDirectives = computed(() => {
            if (this.wrapper) {
                return [...this.$filterDirectives(), ...this.$customFilterDirectives(), ...this.wrapper.$registrations()];
            }
            return [...this.$filterDirectives(), ...this.$customFilterDirectives()];
        });
        this.$tableBuilderMetaData = computed(() => this.$tableBuilder()?.$metaData());
        this.$allMetaDatas = computed(() => {
            const tableBuilderMetaData = this.$tableBuilderMetaData();
            if (!tableBuilderMetaData)
                return;
            const customCellMetaDatas = this.$customCells().filter(cc => cc.$inited()).map(cc => cc.$metaData()).filter(d => !!d);
            const mappedCustomCellMetaDatas = customCellMetaDatas.map(md => mergeCustomCellMetaData(md, tableBuilderMetaData.find(item => item.key === md.key)));
            return [...tableBuilderMetaData, ...mappedCustomCellMetaDatas];
        });
        this.$allMetaDataTimeStamped = linkedSignal({
            source: this.$allMetaDatas,
            computation: (curr, previous) => {
                return { timestamp: Date.now(), value: curr || [], previous: previous?.value.value || [] };
            }
        });
        this.#setUpAllValuesFilters = effect(() => {
            const data = this.$allDataTimeStamped();
            const allMeta = this.$allMetaDataTimeStamped();
            if (!data)
                return;
            untracked(() => {
                const currentAll = computed(() => this.state.selectSignal(s => s.allFilters)())();
                const mapped = buildInAllValuesFilter(this.config, allMeta.previous, allMeta.value, data.value, allMeta.timestamp, data.timestamp, currentAll);
                this.state.patchState({ allFilters: mapped });
            });
        });
        this.$preds = computed(() => {
            const predicateInputFilters = this.$inputFilters().filter(isFunction);
            const notSavableFilterDirectives = this.$allFilterDirectives()
                .filter(d => !d.savable)
                .map(d => d.$filter())
                .filter(d => !!d && needsFilterCreation(d))
                .map(d => createFilterFunc(d));
            return [...predicateInputFilters, ...notSavableFilterDirectives];
        });
        this.$predicateFiltersState = linkedSignal({
            source: this.$preds,
            computation: (curr, previous) => {
                if (!previous?.value)
                    return ({ value: updateFilterPredicateState({ allFilters: [] }, curr), timestamp: Date.now() });
                return ({ value: updateFilterPredicateState(previous.value.value, curr), timestamp: Date.now() });
            }
        });
        this.$savableFiltersState = linkedSignal({
            source: this.state.$filters,
            computation: (curr, previous) => {
                if (!previous?.value)
                    return ({ value: updateFilterInfoState({ allFilters: {} }, curr), timestamp: Date.now() });
                return ({ value: updateFilterInfoState(previous.value.value, curr), timestamp: Date.now() });
            }
        });
        this.$allFilterStatesTimeStamped = computed(() => {
            if (!this.$isInitializationState(InitializationState.Ready)())
                return undefined;
            return ({ value: updateFilterState(this.$savableFiltersState(), this.$predicateFiltersState()), timestamp: Date.now() });
        });
        this.$sortStateTimeStamped = linkedSignal({
            source: computed(() => this.$isInitializationState(InitializationState.Ready)() && this.state.$getSorts()),
            computation: (curr, prev) => {
                if (!curr)
                    return undefined;
                if (!prev?.value)
                    return ({ value: updateSortState(initialSortState, curr), timestamp: Date.now() });
                return ({ value: updateSortState(prev.value.value, curr), timestamp: Date.now() });
            }
        });
        this.$allData = computed(() => (this.$tableBuilder()?.$initialized() && this.$tableBuilder()?.$data()) || []);
        this.$allDataTimeStamped = computed(() => {
            const data = this.$allData();
            if (!data)
                return undefined;
            return ({
                value: data,
                timestamp: Date.now()
            });
        });
        this.$allTimeStamped = computed(() => {
            const data = this.$allDataTimeStamped();
            const sort = this.$sortStateTimeStamped();
            const filter = this.$allFilterStatesTimeStamped();
            if (!data?.value || !sort?.value || !filter?.value)
                return undefined;
            return ({
                data,
                sort,
                filter
            });
        });
        this.$sortedAndFilteredData = linkedSignal({
            source: this.$allTimeStamped,
            computation: (values, prev) => {
                const init = this.$isInitializationState(InitializationState.Ready);
                if (!values || !init)
                    return undefined;
                const { data, filter, sort } = values;
                const val = prev?.value?.value || data.value;
                const filteredData = sortAndFilterData(data, filter, sort, !prev?.value, val);
                return ({ value: filteredData, timestamp: Date.now() });
            }
        });
        this.$timestampedGroups = computed(() => ({ value: this.state.$groupByKeys(), timestamp: Date.now() }));
        this.$timestampedExpanded = computed(() => ({ value: this.state.$expandGroups(), timestamp: Date.now() }));
        this.$dataAndGroupsTimestamped = computed(() => {
            const data = this.$sortedAndFilteredData();
            const groups = this.$timestampedGroups();
            const expanded = this.$timestampedExpanded();
            if (!data)
                return undefined;
            return ({
                data,
                groups,
                expanded
            });
        });
        this.$filteredSortedAndGrouped = linkedSignal({
            source: this.$dataAndGroupsTimestamped,
            computation: (curr, prev) => {
                if (!curr)
                    return undefined;
                const val = prev?.value?.groupedData || [];
                return updateGroupByState(val, curr, !prev?.value);
            }
        });
        this.$isInitializationState = (state) => computed(() => this.state.selectSignal(s => s.initializationState >= state)());
        this.headerId = TableContainerComponent.headerId;
    }
    clearSelections() {
        this.$genericTable()?.$selection().clear(true);
    }
    firstPage() {
        this.$paginatorComponent()?.$paginator()?.firstPage();
    }
    lastPage() {
        this.$paginatorComponent()?.$paginator()?.lastPage();
    }
    #initTableBuilder;
    #initializeTableSettingsFromTableBuilderAndPersistedStateEffect;
    #setPageSizeFromInputEffect;
    #patchedFilters;
    #patchSavableFilterDirectivesFromPersistedStateEffect;
    #patchSavableFilterInputsFromPersistedStateEffect;
    #addPropsToStoreFromInputsEffect;
    #addMetaDataToStoreEffect;
    #setFilteredDataLengthEffect;
    #setDataSourceDataEffect;
    #destroyRef;
    #setUpAllValuesFilters;
    static { this.headerId = 'tb-header-wrapper'; }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableContainerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: TableContainerComponent, isStandalone: true, selector: "tb-table-container", inputs: { $tableBuilder: { classPropertyName: "$tableBuilder", publicName: "tableBuilder", isSignal: true, isRequired: true, transformFunction: null }, $tableIdInput: { classPropertyName: "$tableIdInput", publicName: "tableId", isSignal: true, isRequired: false, transformFunction: null }, $trackByInput: { classPropertyName: "$trackByInput", publicName: "trackBy", isSignal: true, isRequired: false, transformFunction: null }, $inputFilters: { classPropertyName: "$inputFilters", publicName: "inputFilters", isSignal: true, isRequired: false, transformFunction: null }, $indexColumnInput: { classPropertyName: "$indexColumnInput", publicName: "indexColumn", isSignal: true, isRequired: false, transformFunction: null }, $selectionColumnInput: { classPropertyName: "$selectionColumnInput", publicName: "selectionColumn", isSignal: true, isRequired: false, transformFunction: null }, $stickyHeaderInput: { classPropertyName: "$stickyHeaderInput", publicName: "stickyHeader", isSignal: true, isRequired: false, transformFunction: null }, $stickyFooterInput: { classPropertyName: "$stickyFooterInput", publicName: "stickyFooter", isSignal: true, isRequired: false, transformFunction: null }, $groupHeaderTemplate: { classPropertyName: "$groupHeaderTemplate", publicName: "groupHeaderTemplate", isSignal: true, isRequired: false, transformFunction: null }, $groupHeaderHeight: { classPropertyName: "$groupHeaderHeight", publicName: "groupHeaderHeight", isSignal: true, isRequired: false, transformFunction: null }, $pageSize: { classPropertyName: "$pageSize", publicName: "pageSize", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { selection$: "selection", onStateReset$: "onStateReset", onSaveState$: "onSaveState", state$: "state", data$: "data" }, providers: [TableStore, ExportToCsvService, WrapperFilterStore, DataStore], queries: [{ propertyName: "$filterDirectives", predicate: TableFilterDirective, descendants: true, isSignal: true }, { propertyName: "$customFilterDirectives", predicate: TableCustomFilterDirective, descendants: true, isSignal: true }, { propertyName: "_$customRows", predicate: (MatRowDef), isSignal: true }, { propertyName: "$customCells", predicate: CustomCellDirective, isSignal: true }], viewQueries: [{ propertyName: "$paginatorComponent", first: true, predicate: PaginatorComponent, descendants: true, isSignal: true }, { propertyName: "$genericTable", first: true, predicate: GenericTableComponent, descendants: true, isSignal: true }, { propertyName: "$menu", first: true, predicate: MatMenu, descendants: true, isSignal: true }], ngImport: i0, template: "@let tableId = $tableId();\r\n@let tableSettings = state.$tableSettings();\r\n\r\n<ng-content select=\"[before]\" />\r\n<ng-container multiSort>\r\n  <div class=\"tb-header-wrapper\" [id]=\"headerId\">\r\n    <div class=\"title\">\r\n      @if ((!$collapsedHeader()) || tableSettings.showTitleWhenHeaderCollapsed)\r\n      {\r\n        <ng-content select=\".tb-header-title\"/>\r\n      }\r\n    </div>\r\n    @if(state.$groupByKeys().length)\r\n    {\r\n      <group-by-list />\r\n    }\r\n    <div class=\"flx-row-end\">\r\n      <lib-filter-list />\r\n      @if (!tableSettings.hideHeader)\r\n      {\r\n        @if (!$collapsedHeader())\r\n        {\r\n          <ng-container *ngTemplateOutlet=\"headerMenu\"/>\r\n          <button mat-icon-button color='primary' [matMenuTriggerFor]=\"mainMenu\">\r\n            <mat-icon>more_vert</mat-icon>\r\n          </button>\r\n          <mat-menu #mainMenu='matMenu' [xPosition]=\"'before'\">\r\n            <lib-table-header-menu #l/>\r\n          </mat-menu>\r\n\r\n        }\r\n        @else\r\n        {\r\n          <mat-icon color=\"primary\" class=\"flat-menu-button pointer\" [matMenuTriggerFor]=\"mainMenu\">more_horiz</mat-icon>\r\n          <mat-menu #mainMenu='matMenu'>\r\n            <div class=\"collapsed-head-row\">\r\n              <ng-container *ngTemplateOutlet=\"headerMenu; injector menuInjector\"/>\r\n            </div>\r\n            <lib-table-header-menu />\r\n          </mat-menu>\r\n        }\r\n        <mat-icon class=\"collapse-icon header\" [matTooltip]=\"$collapsedHeader() ? 'expand' : 'collapse'\"\r\n          (click)=\"state.toggleCollapseHeader()\">\r\n          {{$collapsedHeader() ? 'expand_less' : 'expand_more'}}\r\n        </mat-icon>\r\n      }\r\n\r\n    </div>\r\n  </div>\r\n\r\n  @if($useVirtual())\r\n  {\r\n    <tb-virtual-scroll-container class=\"scrollable\">\r\n      <tb-generic-table [rows]=\"$customRows()\" [data]=\"$data()!\" [displayDataLength]=\"$displayDataLength()\"\r\n        [columnInfos]='$myColumns()' [trackBy]=\"$trackBy()\" [dataSource]=\"dataSource\" (selection)='selection$.emit($event)' />\r\n    </tb-virtual-scroll-container>\r\n  }\r\n  @else\r\n  {\r\n    <tb-generic-table [rows]=\"$customRows()\" [data]=\"$data()!\" [displayDataLength]=\"$displayDataLength()\"\r\n      [columnInfos]='$myColumns()' [trackBy]=\"$trackBy()\" [dataSource]=\"dataSource\"  (selection)='selection$.emit($event)' />\r\n  }\r\n  @if(tableSettings.usePaginator)\r\n  {\r\n    <div class=\"paginator\">\r\n      <tb-paginator #tbPaginator />\r\n\r\n      <mat-icon class=\"collapse-icon footer\" [matTooltip]=\"$collapsedFooter() ? 'expand' : 'collapse'\"\r\n        (click)=\"state.toggleCollapseFooter()\">\r\n        {{$collapsedFooter() ? 'expand_more' : 'expand_less'}}\r\n      </mat-icon>\r\n    </div>\r\n  }\r\n\r\n  <ng-template #headerMenu>\r\n    @if (!tableSettings.hideFilter) {<tb-filter-displayer/>}\r\n    @if (!tableSettings.hideColumnSettings) {<tb-col-displayer/>}\r\n    @if (!tableSettings.hideSort) {<tb-sort-menu/>}\r\n    @if (!!tableId && !$collapsedHeader()) {<tb-profiles-menu [tableId]=\"tableId\"/>}\r\n  </ng-template>\r\n\r\n</ng-container>\r\n", styles: [".tb-header-wrapper{display:flex;flex-direction:row;width:100%}.flx-row-end{display:flex;flex-direction:row;justify-content:flex-end;align-items:center;margin-left:auto}.flat-menu{line-height:initial;height:initial}.pointer{cursor:pointer}.add-key{width:90%}.paginator{display:flex;flex-direction:row;justify-content:flex-end;align-items:center;background-color:#fff;bottom:0;position:sticky;border-top:.5px solid rgba(0,0,0,.12)}.profiles-menu{visibility:hidden;width:0px;height:0px;display:block;overflow:hidden;position:absolute;top:50px}.collapsed-head-row{display:flex;justify-content:space-evenly}\n", ".collapse-icon{font-size:16px;height:16px;color:#3f51b5;align-self:flex-start}.collapse-icon:hover{cursor:pointer}.hide{display:none}.paginator-row{display:flex;align-items:center}\n"], dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: PaginatorComponent, selector: "tb-paginator" }, { kind: "directive", type: MultiSortDirective, selector: "[multiSort]", inputs: ["matSortDisabled"], exportAs: ["multiSort"] }, { kind: "component", type: GroupByListComponent, selector: "group-by-list" }, { kind: "component", type: FilterChipsComponent, selector: "lib-filter-list" }, { kind: "component", type: GenFilterDisplayerComponent, selector: "tb-filter-displayer" }, { kind: "component", type: GenColDisplayerComponent, selector: "tb-col-displayer" }, { kind: "component", type: SortMenuComponent, selector: "tb-sort-menu" }, { kind: "component", type: GenericTableComponent, selector: "tb-generic-table", inputs: ["displayDataLength", "data", "rows", "columnInfos", "dataSource", "trackBy"], outputs: ["selection"] }, { kind: "component", type: ProfilesMenuComponent, selector: "tb-profiles-menu", inputs: ["tableId", "isMatMenuChild"] }, { kind: "component", type: TableHeaderMenuComponent, selector: "lib-table-header-menu" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3$1.MatIconButton, selector: "button[mat-icon-button], a[mat-icon-button], button[matIconButton], a[matIconButton]", exportAs: ["matButton", "matAnchor"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i1$4.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "directive", type: i1$4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "component", type: VirtualScrollContainer, selector: "tb-virtual-scroll-container" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tb-table-container', changeDetection: ChangeDetectionStrategy.OnPush, providers: [TableStore, ExportToCsvService, WrapperFilterStore, DataStore], imports: [
                        NgTemplateOutlet,
                        PaginatorComponent,
                        MultiSortDirective, GroupByListComponent, FilterChipsComponent, GenFilterDisplayerComponent, GenColDisplayerComponent,
                        SortMenuComponent, GenericTableComponent, ProfilesMenuComponent, TableHeaderMenuComponent,
                        MatButtonModule, MatMenuModule, MatIconModule, MatTooltipModule, VirtualScrollContainer
                    ], template: "@let tableId = $tableId();\r\n@let tableSettings = state.$tableSettings();\r\n\r\n<ng-content select=\"[before]\" />\r\n<ng-container multiSort>\r\n  <div class=\"tb-header-wrapper\" [id]=\"headerId\">\r\n    <div class=\"title\">\r\n      @if ((!$collapsedHeader()) || tableSettings.showTitleWhenHeaderCollapsed)\r\n      {\r\n        <ng-content select=\".tb-header-title\"/>\r\n      }\r\n    </div>\r\n    @if(state.$groupByKeys().length)\r\n    {\r\n      <group-by-list />\r\n    }\r\n    <div class=\"flx-row-end\">\r\n      <lib-filter-list />\r\n      @if (!tableSettings.hideHeader)\r\n      {\r\n        @if (!$collapsedHeader())\r\n        {\r\n          <ng-container *ngTemplateOutlet=\"headerMenu\"/>\r\n          <button mat-icon-button color='primary' [matMenuTriggerFor]=\"mainMenu\">\r\n            <mat-icon>more_vert</mat-icon>\r\n          </button>\r\n          <mat-menu #mainMenu='matMenu' [xPosition]=\"'before'\">\r\n            <lib-table-header-menu #l/>\r\n          </mat-menu>\r\n\r\n        }\r\n        @else\r\n        {\r\n          <mat-icon color=\"primary\" class=\"flat-menu-button pointer\" [matMenuTriggerFor]=\"mainMenu\">more_horiz</mat-icon>\r\n          <mat-menu #mainMenu='matMenu'>\r\n            <div class=\"collapsed-head-row\">\r\n              <ng-container *ngTemplateOutlet=\"headerMenu; injector menuInjector\"/>\r\n            </div>\r\n            <lib-table-header-menu />\r\n          </mat-menu>\r\n        }\r\n        <mat-icon class=\"collapse-icon header\" [matTooltip]=\"$collapsedHeader() ? 'expand' : 'collapse'\"\r\n          (click)=\"state.toggleCollapseHeader()\">\r\n          {{$collapsedHeader() ? 'expand_less' : 'expand_more'}}\r\n        </mat-icon>\r\n      }\r\n\r\n    </div>\r\n  </div>\r\n\r\n  @if($useVirtual())\r\n  {\r\n    <tb-virtual-scroll-container class=\"scrollable\">\r\n      <tb-generic-table [rows]=\"$customRows()\" [data]=\"$data()!\" [displayDataLength]=\"$displayDataLength()\"\r\n        [columnInfos]='$myColumns()' [trackBy]=\"$trackBy()\" [dataSource]=\"dataSource\" (selection)='selection$.emit($event)' />\r\n    </tb-virtual-scroll-container>\r\n  }\r\n  @else\r\n  {\r\n    <tb-generic-table [rows]=\"$customRows()\" [data]=\"$data()!\" [displayDataLength]=\"$displayDataLength()\"\r\n      [columnInfos]='$myColumns()' [trackBy]=\"$trackBy()\" [dataSource]=\"dataSource\"  (selection)='selection$.emit($event)' />\r\n  }\r\n  @if(tableSettings.usePaginator)\r\n  {\r\n    <div class=\"paginator\">\r\n      <tb-paginator #tbPaginator />\r\n\r\n      <mat-icon class=\"collapse-icon footer\" [matTooltip]=\"$collapsedFooter() ? 'expand' : 'collapse'\"\r\n        (click)=\"state.toggleCollapseFooter()\">\r\n        {{$collapsedFooter() ? 'expand_more' : 'expand_less'}}\r\n      </mat-icon>\r\n    </div>\r\n  }\r\n\r\n  <ng-template #headerMenu>\r\n    @if (!tableSettings.hideFilter) {<tb-filter-displayer/>}\r\n    @if (!tableSettings.hideColumnSettings) {<tb-col-displayer/>}\r\n    @if (!tableSettings.hideSort) {<tb-sort-menu/>}\r\n    @if (!!tableId && !$collapsedHeader()) {<tb-profiles-menu [tableId]=\"tableId\"/>}\r\n  </ng-template>\r\n\r\n</ng-container>\r\n", styles: [".tb-header-wrapper{display:flex;flex-direction:row;width:100%}.flx-row-end{display:flex;flex-direction:row;justify-content:flex-end;align-items:center;margin-left:auto}.flat-menu{line-height:initial;height:initial}.pointer{cursor:pointer}.add-key{width:90%}.paginator{display:flex;flex-direction:row;justify-content:flex-end;align-items:center;background-color:#fff;bottom:0;position:sticky;border-top:.5px solid rgba(0,0,0,.12)}.profiles-menu{visibility:hidden;width:0px;height:0px;display:block;overflow:hidden;position:absolute;top:50px}.collapsed-head-row{display:flex;justify-content:space-evenly}\n", ".collapse-icon{font-size:16px;height:16px;color:#3f51b5;align-self:flex-start}.collapse-icon:hover{cursor:pointer}.hide{display:none}.paginator-row{display:flex;align-items:center}\n"] }]
        }] });
function isFunction(a) {
    return typeof a === 'function';
}

class TableBuilderModule {
    static forRoot(config) {
        return {
            ngModule: TableBuilderModule,
            providers: [
                { provide: TableBuilderConfigToken, useValue: config }
            ]
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderModule, imports: [TableContainerComponent,
            CustomCellDirective,
            TableFilterDirective,
            TableFilterStringContainsDirective,
            TableWrapperDirective], exports: [TableContainerComponent,
            CustomCellDirective,
            TableFilterStringContainsDirective,
            TableWrapperDirective,
            UtilitiesModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderModule, providers: [
            MultiSortDirective,
        ], imports: [TableContainerComponent, UtilitiesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: TableBuilderModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        TableContainerComponent,
                        CustomCellDirective,
                        TableFilterDirective,
                        TableFilterStringContainsDirective,
                        TableWrapperDirective,
                    ],
                    exports: [
                        TableContainerComponent,
                        CustomCellDirective,
                        TableFilterStringContainsDirective,
                        TableWrapperDirective,
                        UtilitiesModule,
                    ],
                    providers: [
                        MultiSortDirective,
                    ]
                }]
        }] });

class MatTableObservableDataSource extends MatTableDataSource {
    constructor(dataSrc) {
        super([]);
        this.dataSrc = dataSrc;
    }
    connect() {
        if (!this.subscription) {
            this.subscription = this.dataSrc.subscribe(data => this.data = data);
        }
        return super.connect();
    }
    disconnect() {
        if (this.subscription) {
            this.subscription.unsubscribe();
            this.subscription = undefined;
        }
        super.disconnect();
    }
}

class TableBuilder {
    #$metaData;
    #$data;
    #$settings;
    #$metaNeedsPrep;
    #$dataIsObservable;
    #$settingsIsObservable;
    #$needsPrep;
    constructor(data, metaData, settings = new GeneralTableSettings()) {
        this.data = data;
        this.metaData = metaData;
        this.settings = settings;
        this.container = signal(undefined);
        this.$metaData = computed(() => this.$initialized() ? this.#$metaData() : undefined);
        this.$settings = computed(() => this.$initialized() ? this.#$settings() : undefined);
        this.#$metaNeedsPrep = signal(false);
        this.#$dataIsObservable = signal(false);
        this.#$settingsIsObservable = signal(false);
        this.#$needsPrep = computed(() => this.#$dataIsObservable() || this.#$metaNeedsPrep() || this.#$settingsIsObservable());
        this.$initialized = signal(false);
        this.#dataCleaners = computed(() => {
            const metaData = this.$metaData();
            if (!metaData)
                return undefined;
            return createDataCleaners(metaData);
        });
        this.$data = computed(() => {
            const data = this.#$data();
            const cleaners = this.#dataCleaners();
            if (!data || !cleaners)
                return [];
            const cleanedData = data.map((data, i) => {
                const cleaned = cleaners(data);
                cleaned[initIndexSymbol] = i;
                return cleaned;
            });
            return cleanedData;
        });
        if (isObservable(data)) {
            this.#$dataIsObservable.set(true);
        }
        else {
            this.#$data = isSignal(data) ? data : signal(data);
        }
        if (isObservable(metaData) || !metaData) {
            this.#$metaNeedsPrep.set(true);
        }
        else {
            this.#$metaData = isSignal(metaData) ? metaData : signal(metaData);
        }
        if (isObservable(settings)) {
            this.#$settingsIsObservable.set(true);
        }
        else {
            this.#$settings = isSignal(settings) ? settings : signal(settings);
        }
        if (!this.#$needsPrep()) {
            this.$initialized.set(true);
        }
        else {
            try {
                assertInInjectionContext(TableBuilder);
                const injector = inject(Injector);
                this.prep(injector);
            }
            catch { }
        }
    }
    prep(injector) {
        if (this.#$settingsIsObservable()) {
            this.#$settings = toSignal(this.settings, { injector, requireSync: true });
        }
        if (this.#$dataIsObservable()) {
            this.#$data = toSignal(this.data, { injector, initialValue: [] });
        }
        if (this.#$metaNeedsPrep()) {
            if (this.metaData) {
                this.#$metaData = toSignal(this.metaData, { injector, initialValue: [] });
            }
            else {
                this.#$metaData = computed(() => this.createMetaData(this.#$data()[0]));
            }
        }
        this.$initialized.set(true);
    }
    #dataCleaners;
    createMetaData(obj) {
        return Object.keys(obj ?? {})
            .map(key => ({
            key,
            fieldType: FieldType.Unknown,
            order: -1
        }));
    }
}
const CreateTableBuilder = (reportDef$) => {
    reportDef$ = reportDef$.pipe(defaultShareReplay());
    return new TableBuilder(reportDef$.pipe(map(r => r.data)), reportDef$.pipe(map(r => r.metaData)));
};

// State
class AppStatusState {
}
class ActionStatus {
}
const InitialState = {
    ids: [],
    entities: {}
};
var serverStatusTypes;
(function (serverStatusTypes) {
    serverStatusTypes[serverStatusTypes["notStarted"] = 0] = "notStarted";
    serverStatusTypes[serverStatusTypes["inProgress"] = 1] = "inProgress";
    serverStatusTypes[serverStatusTypes["success"] = 2] = "success";
    serverStatusTypes[serverStatusTypes["error"] = 3] = "error";
})(serverStatusTypes || (serverStatusTypes = {}));
// Entity and Selectors
const statusAdapter = createEntityAdapter();
const initialState = statusAdapter.getInitialState(InitialState);
const getStatusState = createFeatureSelector('ActionStatus');
const { selectIds, selectEntities, selectAll, selectTotal } = statusAdapter.getSelectors(getStatusState);
const selectEntity = (id) => createSelector(selectEntities, (entities) => entities[id]);
// Reducers
function actionStatusReducer(state = initialState, action) {
    const actionStatus = get(action, 'payload.actionStatus');
    if (actionStatus) {
        if (state.ids.find(id => id === actionStatus.id)) {
            const modifiedObj = { ...state.entities[actionStatus.id] };
            modifiedObj.status = actionStatus.status;
            modifiedObj.responsePayload = actionStatus.responsePayload;
            return statusAdapter.upsertOne(modifiedObj, state);
        }
        else {
            return statusAdapter.addOne(actionStatus, state);
        }
    }
    return state;
}

class NgrxExtModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: NgrxExtModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: NgrxExtModule, imports: [CommonModule, i1$9.StoreFeatureModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: NgrxExtModule, imports: [CommonModule,
            StoreModule.forFeature('ActionStatus', actionStatusReducer)] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: NgrxExtModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [
                        CommonModule,
                        StoreModule.forFeature('ActionStatus', actionStatusReducer),
                    ]
                }]
        }] });

class ActionStateSpinnerComponent {
    constructor() {
        this.serverStatusTypes = serverStatusTypes;
    }
    ngOnInit() {
        this.serverActionStatus$ = this.status$.pipe(delayOn(a => a.status === serverStatusTypes.inProgress, 500));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ActionStateSpinnerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "20.0.3", type: ActionStateSpinnerComponent, isStandalone: true, selector: "lib-action-state-spinner", inputs: { status$: "status$" }, ngImport: i0, template: "@if((serverActionStatus$ | async)?.status === serverStatusTypes.inProgress)\r\n{\r\n  <div id=\"blocker\">\r\n    <mat-spinner class=\"spinner\" [diameter]=\"200\" />\r\n  </div>\r\n}\r\n\r\n", styles: ["#blocker{position:fixed;top:0;left:0;width:100%;height:100%;background-color:#0e0d0d69;z-index:999999}.spinner{position:absolute;top:50%;left:40%;transform:translate(-50%,-50%)}\n"], dependencies: [{ kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "ngmodule", type: MatProgressSpinnerModule }, { kind: "component", type: i1$a.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ActionStateSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-action-state-spinner', imports: [AsyncPipe, MatProgressSpinnerModule], template: "@if((serverActionStatus$ | async)?.status === serverStatusTypes.inProgress)\r\n{\r\n  <div id=\"blocker\">\r\n    <mat-spinner class=\"spinner\" [diameter]=\"200\" />\r\n  </div>\r\n}\r\n\r\n", styles: ["#blocker{position:fixed;top:0;left:0;width:100%;height:100%;background-color:#0e0d0d69;z-index:999999}.spinner{position:absolute;top:50%;left:40%;transform:translate(-50%,-50%)}\n"] }]
        }], propDecorators: { status$: [{
                type: Input
            }] } });

class ActionStateUiModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ActionStateUiModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.3", ngImport: i0, type: ActionStateUiModule, imports: [ActionStateSpinnerComponent], exports: [ActionStateSpinnerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ActionStateUiModule, imports: [ActionStateSpinnerComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.3", ngImport: i0, type: ActionStateUiModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        ActionStateSpinnerComponent,
                    ],
                    exports: [
                        ActionStateSpinnerComponent,
                    ]
                }]
        }] });

/*
 * Public API Surface of action-state
 */

let _store;
let _cache;
let _ei;
/**
 * Creates a selector that can dispatch an action if conditions are met.
 * Note: The props of the selector factory must include the props of the action.
 * @param selectorFactory A method that returns selector.
 * @param action The action that will be dispatched when conditions are met.
 * @param [dispatchIf = defaultFilter] Optional. A method that takes the result of the selector and returns a boolean. The actions gets dispatched
 * if true is returned. If no method is passed in than the action will be dispatched if the selector returns undefined or null.
 */
const createActionableSelector = (selectorFactory, action, dispatchIf = defaultFilter) => {
    const options = {
        selectorFactory,
        action: (...props) => () => _store.dispatch(action(...props)),
        dispatchIf
    };
    const actionable = createActionResultSelector(options);
    return (...props) => createSelector(actionable(...props), b => b.result);
};
const createActionSelector = (options) => {
    const actionable = createActionResultSelector(options);
    return ((...props) => createSelector(actionable(...props), b => b.result));
};
const createActionableResultSelector = (selectorFactory, action, dispatchIf = defaultFilter) => {
    const options = {
        selectorFactory,
        action: (...props) => () => _store.dispatch(action(...props)),
        dispatchIf
    };
    return createActionResultSelector(options);
};
const createActionResultSelector = (options) => {
    const id = crypto.randomUUID();
    const slctr = (...props) => createSelector(options.selectorFactory(...props), (selected) => {
        const needsDispatch = (options.dispatchIf || defaultFilter)(selected);
        if (needsDispatch && !_cache.isInCache(id, ...props)) {
            queueMicrotask(() => runInInjectionContext(options.injector || _ei, () => {
                options.action(...props)();
            }));
        }
        return ({
            loading: needsDispatch,
            result: selected
        });
    });
    return slctr;
};
class AppStoreCache {
    constructor() {
        this.cache = {};
        this.isInCache = (actionableSelectorId, ...p) => {
            const props = p.reduce((a, b) => {
                if (typeof b != 'object')
                    b = { b };
                return ({ ...a, ...b });
            }, {});
            let itemsInCache = this.cache[actionableSelectorId] = (this.cache[actionableSelectorId] || []);
            if (itemsInCache.some(itemInCache => shallowEquals(itemInCache, props))) {
                return true;
            }
            itemsInCache.push(props);
            return false;
        };
    }
}
const clearActionableSelectorRequestCache = () => _cache.cache = {};
const shallowEquals = (cachedItem, newItem) => {
    const cachedItemKeys = Object.keys(cachedItem);
    const secondKeys = Object.keys(newItem);
    if (cachedItemKeys.length !== secondKeys.length) {
        return false;
    }
    for (let index = 0; index < cachedItemKeys.length; index++) {
        const currentKey = cachedItemKeys[index];
        if (cachedItem[currentKey] !== newItem[currentKey]) {
            return false;
        }
    }
    return true;
};
function defaultFilter(data) {
    return data == null || data == undefined;
}
const setStore = (store) => {
    if (store instanceof Store)
        _store ??= store;
};
const setEnvironmentInjector = (ei) => {
    if (ei instanceof EnvironmentInjector)
        _ei ??= ei;
};
function provideActionableSelector() {
    return makeEnvironmentProviders([
        provideAppInitializer(setUpStoreFactory)
    ]);
}
const setUpStoreFactory = () => {
    const store = inject(Store);
    const env = inject(EnvironmentInjector);
    _cache ??= new AppStoreCache();
    setStore(store);
    setEnvironmentInjector(env);
};
function setUpStoreFactoryOld(store, env) {
    _cache ??= new AppStoreCache();
    return () => new Promise((resolve, reject) => {
        setStore(store);
        setEnvironmentInjector(env);
        resolve(null);
    });
}

/*
 * Public API Surface of http-request-state
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ActionStateSpinnerComponent, ActionStateUiModule, ActionStatus, AppStatusState, ArrayStyle, AutoFocusDirective, CancellationToken, ClickEmitterDirective, ClickSubjectDirective, ConditionalClassesDirective, CreateTableBuilder, CustomCellDirective, DateFilterComponent, DefaultVirtualScrollOptions, DialogDirective, DialogService, DialogWrapper, FieldType, FilterChipsComponent, FilterComponent, FilterType, FunctionPipe, GenColDisplayerComponent, GenFilterDisplayerComponent, GeneralTableSettings, GenericTableComponent, GroupByListComponent, HttpErrorStateDirective, HttpInProgressStateDirective, HttpNotStartedStateDirective, HttpRequestModule, HttpRequestStateDirective, RequestStateFactory as HttpRequestStateFactory, RequestStateStore as HttpRequestStateStore, RequestStatus as HttpRequestStatus, RequestStrategy as HttpRequestStrategy, HttpSuccessStateDirective, MatButtonToggleFilterDirective, MatCheckboxTbFilterDirective, MatOptionTbFilterDirective, MatRadioButtonTbFilterDirective, MatSlideToggleGroupDirective, MatSlideToggleTbFilterDirective, MatTableObservableDataSource, MultiSortDirective, NgrxExtModule, NotPersistedTableSettings, PaginatorComponent, PaginatorOptions, PersistedTableSettings, PhoneNumberPipe, PreventEnterDirective, RequestStateFactory, RequestStateStore, RequestStateStoreConfigToken, RequestStatus, RequestStrategy, ResizeColumnDirective, SortDirection, SpaceCasePipe, StopPropagationDirective, StylerDirective, Subjectifier, Subscriber, TableBuilder, TableBuilderConfigToken, TableBuilderModule, TableColumnFooterSettings, TableColumnHeaderSettings, TableContainerComponent, TableCustomFilterDirective, TableCustomFilterDirectiveBase, TableFilterDirective, TableFilterStringContainsDirective, TableSettings, TableWrapperDirective, TableWrapperFooterSettings, TableWrapperHeaderSettings, Target, TbSelectedFilterDirective, TrimWhitespaceDirective, UtilitiesModule, VirtualScrollOptions, actionStatusReducer, chainRequest, clearActionableSelectorRequestCache, combineArrays, createActionResultSelector, createActionSelector, createActionableResultSelector, createActionableSelector, createFailure, createFilterFunc, createFilterFuncs, createRequestor, createSuccess, defaultFilter, defaultShareReplay, delayOn, filterArray, filterTypeMap, getAllGroupHeaderNames, getAllGroupHeaderNamesByKeys, getRequestorBody, getRequestorStatus, getStatusState, httpRequest, httpRequestor, inProgress, initialGroupByState, initialState, isCustomFilter, isErrorState, isFilterInfo, isSuccessOrErrorState, isSuccessState, mapArray, mapError, mapGroupHeader, metaDataArrToDict, needsFilterCreation, notNull, notStarted, onWait, onceWhen, parseTbSizeToPixels, phoneFormatter, previousAndCurrent, provideActionableSelector, provideTableBuilder, selectAll, selectEntities, selectEntity, selectIds, selectTotal, serverStatusTypes, setCustomGroupBy, setUpStoreFactory, setUpStoreFactoryOld, skipOneWhen, sortsAreSame, spaceCase, startWithIfEmpty, statusAdapter, statusIsSuccessOrInProgress, subscriber, switchOff, tapError, tapSuccess, updateGroupByState, wrapInArr };
//# sourceMappingURL=one-paragon-angular-utilities.mjs.map
